SystemOrganization addCategory: #'Volunti-Common-Config'!
SystemOrganization addCategory: #'Volunti-Common-Model'!
SystemOrganization addCategory: #'Volunti-Common-Model-Users'!
SystemOrganization addCategory: #'Volunti-Common-Model-Cryptography'!
SystemOrganization addCategory: #'Volunti-Common-Election'!
SystemOrganization addCategory: #'Volunti-Common-Network'!
SystemOrganization addCategory: #'Volunti-Common-View'!
SystemOrganization addCategory: #'Volunti-Common-View-Helpers'!
SystemOrganization addCategory: #'Volunti-Common-Tests'!

!Number methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 2/29/2012 15:14'!
isOne
	^ self = 1! !

!X509TBSCertificate methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 12/31/2011 10:45'!
= aTBSCertificate
	^ self subject = aTBSCertificate subject! !

RSAPublicKey subclass: #VORSAPublicKey
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!VORSAPublicKey methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 08:33'!
exponent
	"e is private"! !

!VORSAPublicKey methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/5/2012 14:16'!
isVORSAPublicKey
	^ true! !

WAComponent subclass: #VOAuthorityConfigurationComponent
	instanceVariableNames: 'configurationsReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOAuthorityConfigurationComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/14/2012 13:49'!
buildConfigurationsReport
	^ TWBSMagritteReport
		rows: self session agent configurations
		description: VONetworkConfiguration new magritteDescription! !

!VOAuthorityConfigurationComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/14/2012 13:52'!
children
	^ super children , (Array with: self configurationsReport)! !

!VOAuthorityConfigurationComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/14/2012 13:49'!
configurationsReport
	^ configurationsReport ifNil: [ configurationsReport := self buildConfigurationsReport ]! !

!VOAuthorityConfigurationComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/14/2012 13:39'!
configureSystem
	^ self session announcer
		announce: (RefreshContent content: (VOSystemConfigurationTask manager: self session agent manager))! !

!VOAuthorityConfigurationComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/14/2012 13:56'!
renderContentOn: html
	html render: self configurationsReport! !

WAComponent subclass: #VOCryptographicParametersComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOCryptographicParametersComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/3/2012 08:44'!
child
	^ self session agent cryptographicParameters asComponent! !

!VOCryptographicParametersComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/3/2012 08:43'!
renderContentOn: html
	html render: self child! !

WAComponent subclass: #VOElectionComponent
	instanceVariableNames: 'election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOElectionComponent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 11/15/2012 08:04'!
with: anElection
	^ self new election: anElection! !

!VOElectionComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2012 08:13'!
election
	^ election! !

!VOElectionComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2012 08:05'!
election: anElection
	election := anElection! !

!VOElectionComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 13:42'!
renderChoice: choice on: html
	html div
		class: 'thumbnail';
		with: [ 
					choice hasAnImage
						ifTrue: [ 
							html image
								url: choice image url;
								altText: 'Image of ' , choice name ].
					html div
						class: 'caption';
						with: [ 
									html heading
										level3;
										with: choice name ] ]! !

!VOElectionComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 13:42'!
renderChoicesOn: html
	html unorderedList
		class: 'thumbnails';
		with: [ 
					self election choices
						do: [ :choice | 
							html listItem
								class: 'choice span2';
								with: [ self renderChoice: choice on: html ] ] ]! !

!VOElectionComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 13:35'!
renderContentOn: html
	self renderDetailsOn: html.
	self renderChoicesOn: html! !

!VOElectionComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 13:44'!
renderDetailsOn: html
	html
		paragraph: [ 
			html
				text: 'This election is named ';
				strong: election name;
				text: '. '.
			election hasDates
				ifTrue: [ 
					html
						text: 'It begins on ';
						strong: election startDate;
						text: ' and ends on ';
						strong: election endDate;
						text: '. ' ].
			html
				text: 'It has ';
				strong: election numberOfChoices greaseString;
				text: ' choices:' ]! !

WAComponent subclass: #VOErrorComponent
	instanceVariableNames: 'failure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOErrorComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 07:02'!
failure: anError
	failure := anError! !

!VOErrorComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 14:25'!
renderAlertOn: html
	html paragraph
		class: 'alert alert-danger';
		with: [ 
					html strong: 'Error:'.
					html text: ' An error occured during the process. Please contact the administrator.'.
					html break.
					html strong: 'Details: '.
					html text: failure messageText ]! !

!VOErrorComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 14:26'!
renderContentOn: html
	self renderAlertOn: html.
	self renderWarningOn: html! !

!VOErrorComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 14:26'!
renderWarningOn: html
	html paragraph
		class: 'alert alert-warning';
		with: [ 
					html strong: 'Possible causes:'.
					html break.
					failure seasidePossibleCauses do: [ :cause | html render: cause ] separatedBy: [ html break ] ]! !

WAComponent subclass: #VOKeyManagementComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 10:00'!
agent
	^ self session agent! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 10:01'!
downloadFile
	| file |
	file := WAFile new
		contentType: WAMimeType textPlain;
		contents: self agent certificate xmlDescription;
		fileName: 'certificate';
		yourself.
	self requestContext
		respond: [ :response | 
			response
				contentType: 'text/xml';
				document: file rawContents greaseString;
				attachmentWithFileName: file fileName ]! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 10:01'!
informationMessage
	^ 'You must configure the election manager before managing keys.'! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 10:01'!
renderAlertOn: html
	html paragraph
		class: 'alert alert-info';
		with: self informationMessage! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 10:00'!
renderCertificateOn: html
	html
		paragraph: [ 
			html text: 'The certificate of this server is available until '.
			html strong: self agent certificateValidity.
			html text: ': '.
			self renderRefreshCertificateOn: html.
			html text: ' or '.
			self renderRefreshKeysOn: html.
			html text: ' (the certificate is also refreshed).' ].
	self renderDownloadOn: html! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:58'!
renderContentOn: html
	self session agent hasConfigurations
		ifTrue: [ 
			self session agent hasCertificate
				ifTrue: [ self renderCertificateOn: html ]
				ifFalse: [ self renderNoCertificateOn: html ] ]
		ifFalse: [ self renderAlertOn: html ]! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:59'!
renderDownloadOn: html
	html anchor
		class: 'btn';
		callback: [ self downloadFile ];
		with: [ 
					html span class: 'icon-download'.
					html text: ' Public key' ]! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 14:43'!
renderNoCertificateOn: html
	html paragraph: 'No certificate found. '.
	html anchor
		callback: [ self agent refreshKeys ];
		with: 'Create'.
	html text: ' !! (A certificate is automatically created when needed)'! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 10:00'!
renderRefreshCertificateOn: html
	html anchor
		callback: [ self agent refreshCertificate ];
		with: 'refresh certificate'! !

!VOKeyManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 10:01'!
renderRefreshKeysOn: html
	html anchor
		callback: [ self agent refreshKeys ];
		with: 'refresh keys'! !

WAComponent subclass: #VOLogComponent
	instanceVariableNames: 'log entries anchor report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOLogComponent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 4/9/2012 11:09'!
log: anOrderedCollection anchor: aString
	^ self new
		log: anOrderedCollection;
		anchor: aString;
		yourself! !

!VOLogComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/9/2012 11:10'!
anchor: aString
	anchor := aString! !

!VOLogComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 10/29/2012 10:45'!
children
	^ Array with: report! !

!VOLogComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 10:22'!
entries
	entries isNil
		ifTrue: [ self entries: self log "tenMostRecent" ].
	^ entries! !

!VOLogComponent methodsFor: 'update' stamp: 'NicolasVanderAuwera 10/29/2012 07:13'!
entries: aCollection
	entries :=  aCollection reverse! !

!VOLogComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/13/2011 16:56'!
log
	^ log ifNil: [ log := OrderedCollection new ]! !

!VOLogComponent methodsFor: 'logging' stamp: 'NicolasVanderAuwera 10/29/2012 10:22'!
log: anOrderedCollection
	log := anOrderedCollection.! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 06:52'!
renderAnchorOn: html
	anchor
		ifNotNil: [ :arg | 
			html anchor
				callback: [ self answer ];
				with: anchor ]! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 14:55'!
renderContentOn: html
	html
		twbsRow: [ 
			html
				twbsSpan: 12
				with: [ 
					self renderTitleOn: html.
					self renderLegendOn: html.
					self renderEntriesOn: html.
					self renderAnchorOn: html ] ]! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 10:57'!
renderDangerSpanOn: html
	html span
		class: 'label  label-important';
		with: 'Problem'.
	html space! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 12:07'!
renderEntriesOn: html
	html div
		class: 'log';
		with: self report! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 12:07'!
renderLegendOn: html
	html
		div: [ 
			html
				paragraph: [ 
					self renderNewSpanOn: html.
					html text: 'Entry published 2 hours ago'.
					html text: '; '.
					self renderDangerSpanOn: html.
					html text: 'Entry where a problem occured' ] ]! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 10:17'!
renderNewSpanOn: html
	html span
		class: 'label  label-success';
		with: 'New'.
	html space! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 06:52'!
renderTitleOn: html
	html heading
		level: 2;
		with: self title! !

!VOLogComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:41'!
report
	^ report
		ifNil: [ 
			report := TWBSMagritteReport rows: self entries description: VOLogEntry new magritteDescription.
			report
				addColumn:
					(MAColumn new
						label: '';
						renderer: [ :entry :html | 
									entry isRecent
										ifTrue: [ self renderNewSpanOn: html ].
									entry hasProblem
										ifTrue: [ self renderDangerSpanOn: html ] ];
						yourself).
			report
				showBatchFirstLast: true;
				showBordered: true;
				sortEnabled: true;
				"showFilter: true;"
				batchSize: 20 ]! !

!VOLogComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 06:52'!
title
	^ 'Log'! !

!VOLogComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 11:09'!
updateReport: items
	report rows: items reverse! !

WAComponent subclass: #VOLoginComponent
	instanceVariableNames: 'username password message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOLoginComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/2/2012 08:01'!
children
	^ super children copyWith: message! !

!VOLoginComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/2/2012 08:00'!
initialize
	super initialize.
	username := ''.
	password := ''.
	message := VOMessageComponent new! !

!VOLoginComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:21'!
legend
	^ 'Please enter your username and password.'! !

!VOLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 08:01'!
loginFailed
	message errorMessage: 'Login failed.'! !

!VOLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 08:05'!
renderButtonOn: html
	html div
		class: 'form-actions form-horizontal';
		with: [ 
					html submitButton
						class: 'btn btn-primary submit';
						callback: [ self validateLogin ];
						with: 'Log in' ]! !

!VOLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/15/2012 09:49'!
renderContentOn: html
	self renderTitleOn: html.
	self renderLoginFormOn: html! !

!VOLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 11:53'!
renderLoginFormOn: html
	html form
		class: 'magritte form-horizontal';
		with: [ 
					html legend: self legend.
					html div
						class: 'control-group';
						with: [ 
									html render: message.
									self renderUsernameOn: html.
									self renderPasswordOn: html.
									self renderButtonOn: html ] ]! !

!VOLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 07:27'!
renderPasswordOn: html
	html div
		class: 'controls';
		with: [ 
					html label
						for: html nextId;
						with: 'Password'.
					html passwordInput
						id: html lastId;
						callback: [ :value | password := value ] ]! !

!VOLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 11:50'!
renderTitleOn: html
	html heading
		level: 3;
		with: self title! !

!VOLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 11:53'!
renderUsernameOn: html
	html div
		class: 'controls';
		with: [ 
					html label
						for: html nextId;
						with: 'Username'.
					html textInput
						id: html lastId;
						callback: [ :value | username := value ] ]! !

!VOLoginComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 09:48'!
title
	^ 'Login'! !

!VOLoginComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/2/2012 08:09'!
validateLogin
	| user |
	user := self session findUserByUsername: username.
	(user notNil and: [ user password = password ])
		ifTrue: [ self session login: user ]
		ifFalse: [ self loginFailed ]! !

WAComponent subclass: #VOMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View-Helpers'!

!VOMenuComponent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 2/15/2012 08:27'!
addEntry: label withAction: actionBlock
	self entries add: label -> actionBlock! !

!VOMenuComponent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 11/1/2012 12:10'!
addEntry: label withAction: actionBlock if: boolean
	boolean
		ifTrue: [ self addEntry: label withAction: actionBlock ]! !

!VOMenuComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 08:27'!
entries
	^ entries! !

!VOMenuComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 2/15/2012 08:27'!
initialize
	super initialize.
	entries := OrderedCollection new! !

!VOMenuComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 14:22'!
renderContentOn: html
	html
		navigation: [ 
			html unorderedList
				class: 'nav nav-pills';
				with: [ 
							self entries
								do: [ :each | 
									html
										listItem: [ 
											html anchor
												callback: each value;
												with: each key ] ] ] ]! !

WAComponent subclass: #VOMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View-Helpers'!

!VOMessageComponent commentStamp: 'NicolasVanderAuwera 11/2/2012 10:52' prior: 0!
I am a helper component that displays different types of messages : information and error.

Instance Variables:
	messageString	<String>
	messageType	<String>
	wasShown	<Boolean>!

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
errorMessage: aString
	self
		messageString: aString;
		messageType: 'danger';
		wasShown: false! !

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
infoMessage: aString
	self
		messageString: aString;
		messageType: 'info';
		wasShown: false! !

!VOMessageComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/2/2012 08:04'!
initialize
	super initialize.
	wasShown := true.
	messageString := messageType := ''! !

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
messageString
	^ messageString! !

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
messageString: anObject
	messageString := anObject! !

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
messageType
	^ messageType! !

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
messageType: anObject
	messageType := anObject! !

!VOMessageComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 07:59'!
renderContentOn: html
	self wasShown
		ifTrue: [ ^ self ].
	html div
		class: 'alert alert-' , self messageType;
		with: self messageString.
	self wasShown: true! !

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
wasShown
	^ wasShown! !

!VOMessageComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/2/2012 07:57'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #VOPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

VOPage subclass: #VOAdministrationComponent
	instanceVariableNames: 'login configurationsReport components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOAdministrationComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/14/2012 13:56'!
buildAuthorityConfigurationComponent
	^ VOAuthorityConfigurationComponent new! !

!VOAdministrationComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/14/2012 12:35'!
children
	^ super children , (Array with: login) , self components values! !

!VOAdministrationComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/18/2012 08:39'!
components
	components
		ifNil: [ 
			components := Dictionary new.
			components
				at: 'Server management' put: VOServerManagementComponent new;
				at: 'Key management' put: VOKeyManagementComponent new;
				at: 'User management' put: VOUserEditor new;
				at: 'Server configuration' put: self session agent configuration asComponent.
			self session agent hasConfigurations
				ifTrue: [ components at: 'Configurations of all authorities' put: self buildAuthorityConfigurationComponent ] ].
	^ components! !

!VOAdministrationComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/14/2012 13:50'!
initialize
	super initialize.
	login := VOLoginComponent new! !

!VOAdministrationComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/14/2012 13:05'!
renderAdministratorContentOn: html
	html
		div: [ 
			self components
				keysAndValuesDo: [ :title :component | 
					html heading
						level3;
						id: title withoutSeparator;
						class: 'page-header';
						with: title.
					html render: component ] ]! !

!VOAdministrationComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/15/2012 08:43'!
renderAffixOn: html
	html unorderedList
		class: 'nav nav-list bs-docs-sidenav';
		with: [ 
					self components
						keysDo: [ :title | 
							html
								listItem: [ 
									html anchor
										url: '#' , title withoutSeparator;
										with: [ 
													html span class: 'icon-chevron-right'.
													html text: title ] ] ] ]! !

!VOAdministrationComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:56'!
renderCoreOn: html
	html div
		class: 'row';
		with: [ 
					self session isAdmin
						ifTrue: [ 
							html twbsSpan: 3 with: [ self renderAffixOn: html ].
							html twbsSpan: 9 with: [ self renderAdministratorContentOn: html ] ] ]! !

!VOAdministrationComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2012 09:56'!
renderMainContentOn: html
	html heading
		class: 'page-header';
		level: 2;
		with: self title.
	self session isLoggedIn
		ifFalse: [ self renderUnloggedContentOn: html ]
		ifTrue: [ 
			self renderAdministrationMessageOn: html.
			self renderCoreOn: html ]! !

!VOAdministrationComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 08:09'!
renderUnloggedContentOn: html
	self session isLoggedIn
		ifFalse: [ html render: login ]! !

!VOAdministrationComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 17:01'!
title
	^ 'Administration'! !

VOPage subclass: #VOElectionsListComponent
	instanceVariableNames: 'elections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOElectionsListComponent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/15/2012 10:49'!
elections: electionsList
	^ self new elections: electionsList! !

!VOElectionsListComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 10:43'!
elections
	^ elections! !

!VOElectionsListComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 10:43'!
elections: electionsList
	elections := electionsList! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 10:09'!
renderElection: election on: html
	html
		tableRow: [ 
			html
				tableData: [ 
					Date today - (Duration days: 2) <= election createdAt asDate
						ifTrue: [ 
							html span
								class: 'label  label-success';
								with: 'New'.
							html space ].
					html text: election name ].
			self renderMoreData: election on: html.
			html tableData: election createdAt asDate ]! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 15:13'!
renderElectionsOn: html
	html
		table class: 'table'; with: [ 
			self renderTableHeadingOn: html.
			self renderTableBodyOn: html ]! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 06:28'!
renderMainContentOn: html
	html heading
		level: 2;
		with: self title.
	self renderElectionsOn: html! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/15/2012 11:01'!
renderMoreData: election on: html
	! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/15/2012 11:02'!
renderMoreDataHeadingOn: html! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/2/2012 08:17'!
renderTableBodyOn: html
	self elections do: [ :election | self renderElection: election on: html ]! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 4/9/2012 14:35'!
renderTableHeadingOn: html
	html
		tableRow: [ 
			html tableHeading: 'Name'.
			self renderMoreDataHeadingOn: html.
			html tableHeading: 'Creation Date' ]! !

!VOElectionsListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/30/2012 06:28'!
title
	^ 'Elections'! !

VOPage subclass: #VOMainComponent
	instanceVariableNames: 'agent login'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOMainComponent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 12/13/2011 09:13'!
agent: anAgent
	^ self new
		agent: anAgent;
		yourself! !

!VOMainComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/13/2011 09:15'!
agent
	^ agent! !

!VOMainComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/13/2011 09:15'!
agent: anAgent
	agent := anAgent! !

!VOMainComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/17/2012 15:04'!
initialize
	super initialize.
	login := VOLoginComponent new! !

!VOMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 08:03'!
renderMainContentOn: html
	super renderMainContentOn: html.
	self session isLoggedIn
		ifTrue: [ self renderAdministrationMessageOn: html ]! !

VOMainComponent subclass: #VOManagerMainComponent
	instanceVariableNames: 'electionsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOManagerMainComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/17/2012 15:10'!
buildElectionsListComponent
	^ VOElectionsListComponent elections: self agent authorities! !

!VOManagerMainComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/17/2012 15:04'!
children
	^ Array with: self electionsList! !

!VOManagerMainComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2012 15:10'!
electionsList
	^ electionsList ifNil: [ electionsList := self buildElectionsListComponent ]! !

!VOManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 15:02'!
renderElectionsListOn: html
	html render: self electionsList! !

!VOManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 15:06'!
renderMainContentOn: html
	super renderMainContentOn: html.
	self session isLoggedIn
		ifFalse: [ html render: login ]
		ifTrue: [ self renderRestrictedContentOn: html ]! !

!VOManagerMainComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 15:02'!
renderRestrictedContentOn: html
	self renderElectionsListOn: html! !

!VOPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 08:19'!
renderAdministrationMessageOn: html
	html div
		class: 'alert alert-success';
		with: [ 
					html
						paragraph: [ 
							html
								text: 'Welcome, ';
								strong: self session user name;
								text: '. You are logged in as a ';
								strong: self session user role;
								text: '.';
								space.
							html anchor
								callback: [ self session logout ];
								with: 'Logout' ] ]! !

!VOPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 13:25'!
renderAsideOn: html! !

!VOPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 15:19'!
renderContentOn: html
	self renderMainContentOn: html.
	self renderAsideOn: html! !

!VOPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 13:25'!
renderMainContentOn: html! !

WAComponent subclass: #VORootComponent
	instanceVariableNames: 'menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

VORootComponent subclass: #VOAgentComponent
	instanceVariableNames: 'agent content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOAgentComponent class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 11/2/2012 13:35'!
initialize
	super initialize.
	self register! !

!VOAgentComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 13:05'!
agent
	^ agent
	! !

!VOAgentComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/13/2011 08:57'!
agentClass
	self subclassResponsibility! !

!VOAgentComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 13:06'!
buildAdministration
	^ VOAdministrationComponent new! !

!VOAgentComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/1/2012 12:11'!
buildMenu
	^ VOMenuComponent new
		addEntry: 'Home' withAction: [ self setHome ];
		addEntry: 'Administration' withAction: [ self setAdministration ];
		addEntry: 'Activities' withAction: [ self setLog ] if: agent hasLog;
		yourself! !

!VOAgentComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/15/2012 07:31'!
children
	^ super children , (Array with: content)! !

!VOAgentComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 17:20'!
content: aComponent
	content := aComponent
		"addDecoration: VOErrorHandlingDecoration new;
		yourself"! !

!VOAgentComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 13:12'!
initialize
	super initialize.
	agent := self agentClass current.
	self session agent: self agent.
	self setHome! !

!VOAgentComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2012 15:17'!
main
	^ VOMainComponent! !

!VOAgentComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 14:37'!
renderMainContentOn: html
	html render: content! !

!VOAgentComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/20/2012 13:07'!
setAdministration
	content := self buildAdministration! !

!VOAgentComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/20/2012 13:08'!
setHome
	content := self main agent: self agent! !

!VOAgentComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 10/29/2012 10:04'!
setLog
	self content: (VOLogComponent log: self agent log anchor: nil)
	! !

!VOAgentComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/27/2011 09:17'!
title
	^ 'Agent'
	! !

!VORootComponent class methodsFor: 'testing' stamp: 'NicolasVanderAuwera 4/11/2012 07:51'!
canBeRoot
	^ true! !

!VORootComponent class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 10/29/2012 14:27'!
register
	^ (WAAdmin register: self asApplicationAt: self url)
		addLibrary: JQDevelopmentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		preferenceAt: #sessionClass put: self sessionClass;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		addLibrary: TWBSDevelopmentLibrary;
		yourself! !

!VORootComponent class methodsFor: 'configuration' stamp: 'NicolasVanderAuwera 5/5/2012 07:26'!
sessionClass
	^ VOSessionAgent! !

!VORootComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/1/2012 12:07'!
buildMenu
	self subclassResponsibility! !

!VORootComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 11/1/2012 12:12'!
children
	^ Array with: self menu! !

!VORootComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 12:12'!
menu
	^ menu ifNil: [ menu := self buildMenu ]! !

!VORootComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/17/2012 13:39'!
renderContentOn: html
	html div
		class: 'wrapper';
		with: [ 
					self renderHeaderOn: html.
					html div
						id: 'main';
						class: 'container';
						with: [ 
									self renderTitleOn: html.
									self renderMainContentOn: html.
									html div class: 'push' ] ].
	"self renderFooterOn: html"! !

!VORootComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/14/2012 14:16'!
renderFooterOn: html
	html footer
		class: 'footer';
		with: [ 
					html div
						class: 'container';
						with: [ html paragraph: 'This is the footer.' ] ]! !

!VORootComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 14:23'!
renderHeaderOn: html
	html div
		id: 'header';
		with: [ 
					html header
						class: 'container';
						with: [ 
									html div
										class: 'row';
										with: [ 
													self renderLogoOn: html.
													self renderMenuOn: html ] ] ]! !

!VORootComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 14:24'!
renderLogoOn: html
	html div
		class: 'span8';
		with: [ 
					html image
						altText: 'iVolunti';
						id: 'logo';
						url: (VOFileLibrary urlOf: #logo3Png) ]! !

!VORootComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/15/2012 07:27'!
renderMainContentOn: html! !

!VORootComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 12:12'!
renderMenuOn: html
	html div
		class: 'span4';
		with: self menu! !

!VORootComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 07:56'!
renderTitleOn: html
	html div
		class: 'page-header';
		with: [ 
					html heading
						id: 'title';
						level: 1;
						with: self title ]! !

!VORootComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 07:29'!
title
	^ ''! !

!VORootComponent methodsFor: 'updating' stamp: 'NicolasVanderAuwera 11/14/2012 14:23'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'iVolunti | ' , self title translated.
	anHtmlRoot stylesheet url: (VOFileLibrary urlOf: #applicationCss)! !

WAComponent subclass: #VOServerManagementComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOServerManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/2/2012 14:09'!
renderActionsOn: html
	self session agent isRunning
		ifFalse: [ self renderStartOn: html ]
		ifTrue: [ self renderStopOn: html ].
	html break! !

!VOServerManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 16:58'!
renderContentOn: html
	self session agent port isZero
		ifTrue: [ 
			html paragraph
				class: 'info';
				with: 'The server port is not configured. You have to configure it below, before launching the server.' ].
	html paragraph
		class: 't-justify';
		with: 'Launch or stop the server by clicking on the following button:'.
	self renderActionsOn: html! !

!VOServerManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 17:00'!
renderStartOn: html
	html anchor
		class: 'btn btn-success';
		class: 'disabled' if: self session agent port isZero;
		callback: [ self start ];
		with: 'Start'.
	html break! !

!VOServerManagementComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/1/2012 16:59'!
renderStopOn: html
	html anchor
		class: 'btn btn-danger';
		class: 'disabled' if: self session agent port isZero;
		callback: [ self stop ];
		with: 'Stop'.
	html break! !

!VOServerManagementComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/1/2012 16:59'!
start
	self session agent start
	! !

!VOServerManagementComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/1/2012 16:59'!
stop
	self session agent stop
	! !

WASession subclass: #VOSession
	instanceVariableNames: 'announcer user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Config'!

!VOSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2012 08:21'!
announcer
	^ announcer! !

!VOSession methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/15/2012 08:21'!
initialize
	super initialize.
	announcer := Announcer new! !

!VOSession methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/20/2012 09:52'!
isLoggedIn
	^ user notNil! !

!VOSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 11:03'!
user
	^ user ! !

!VOSession methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 09:52'!
user: aUser
	user := aUser! !

VOSession subclass: #VOSessionAgent
	instanceVariableNames: 'agent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Config'!

!VOSessionAgent commentStamp: 'NicolasVanderAuwera 3/10/2012 15:50' prior: 0!
I am used by agent interface for storing user.!

!VOSessionAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 05:55'!
agent
	^ agent! !

!VOSessionAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 05:55'!
agent: anObject
	agent := anObject! !

!VOSessionAgent methodsFor: 'enumerating' stamp: 'NicolasVanderAuwera 11/2/2012 10:55'!
findUserByUsername: aString
	^ VOSystemUser withUsername: aString! !

!VOSessionAgent methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/20/2012 09:54'!
isAdmin
	^ self isLoggedIn and: [ self user isAdministrator ]! !

!VOSessionAgent methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/20/2012 08:59'!
isAgentConfigured
	^ self agent isConfigured! !

!VOSessionAgent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/2/2012 07:43'!
login: anUser
	user := anUser! !

!VOSessionAgent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/2/2012 07:44'!
logout
	user := nil! !

!String methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 10/30/2012 09:03'!
withoutSeparator
	"Remove all blank character"

	| stream |
	stream := WriteStream on: String new.
	self
		do: [ :c | 
			c isSeparator
				ifFalse: [ stream nextPut: c ] ].
	^ stream contents! !

!X509Certificate class methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 11/20/2012 14:21'!
almostDays
	^ 30! !

!X509Certificate methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 12/31/2011 10:09'!
= aCertificate
	^ self tbsCertificate = aCertificate tbsCertificate! !

!X509Certificate methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 10/29/2012 16:28'!
isAlmost
	^ Date today >= (tbsCertificate validity notAfter - (Duration days: self class almostDays)) and: [ self isValid ]! !

!X509Certificate methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 10/29/2012 16:10'!
isPassed
	^ self isValid not
	! !

!X509Certificate methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 1/10/2012 08:06'!
isValid
	^ tbsCertificate validity notAfter >= DateAndTime now! !

!X509Certificate methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 11/1/2012 09:21'!
xmlDescription
	| writer |
	writer := XMLWriter new.
	writer
		enablePrettyPrinting;
		xml;
		comment: 'Certificate'.
	writer tag
		name: 'ivolunti:certificate';
		xmlnsAt: 'example' put: 'certificate://ivolunti';
		with: [ 
					writer tag: 'subjetInfo' with: [ writer tag: 'dn' with: self tbsCertificate subject dn ].
					writer
						tag: 'publicKey'
						with: [ 
							writer
								tag: 'exponent' with: self tbsCertificate subjectPublicKeyInfo subjectPublicKey exponent greaseString;
								tag: 'modulo' with: self tbsCertificate subjectPublicKeyInfo subjectPublicKey modulo greaseString ] ].
	^ writer! !

OrderedCollection subclass: #VOLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

!VOLog methodsFor: 'adding' stamp: 'NicolasVanderAuwera 2/15/2012 10:29'!
add: description
	super add: (VOLogEntry description: description)! !

!VOLog methodsFor: 'filter' stamp: 'NicolasVanderAuwera 2/15/2012 09:51'!
mostRecent: aNumber
	aNumber > self size
		ifTrue: [ ^ self ].
	^ self last: aNumber! !

!VOLog methodsFor: 'filter' stamp: 'NicolasVanderAuwera 2/15/2012 09:52'!
tenMostRecent 
	^ self mostRecent: 10! !

!Collection methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 3/5/2012 14:47'!
asCommaString
	^ String streamContents: [ :s | (self collect: [ :choice | choice name ]) asStringOn: s delimiter: ', ' ]! !

WAWidgetDecoration subclass: #VOTWBSHeaderDecoration
	instanceVariableNames: 'headerString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOTWBSHeaderDecoration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/3/2012 17:18'!
headerString: aString
	headerString := aString! !

!VOTWBSHeaderDecoration methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/3/2012 17:19'!
renderContentOn: html
	html heading
		level3;
		class: 'page-header';
		with: headerString.
	self renderNextOn: html! !

GRObject subclass: #VOAgent
	instanceVariableNames: 'stream server log configuration configurations cryptographicParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

VOAgent class
	instanceVariableNames: 'current'!

!VOAgent commentStamp: 'NicolasVanderAuwera 3/10/2012 15:53' prior: 0!
I am an abstract agent. I contains a server to handle connection. Override handle method to configure the agent.!

VOAgent class
	instanceVariableNames: 'current'!

!VOAgent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 13:11'!
current
	^ current ifNil: [ current := self new ]! !

!VOAgent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/29/2012 10:36'!
key
	^ self name asLowercase! !

!VOAgent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 11/20/2012 10:55'!
new
	^ super new start! !

!VOAgent class methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/1/2011 09:23'!
port 
	"Default port"
	^ 1701! !

!VOAgent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/9/2012 11:05'!
title
	^ self name! !

!VOAgent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 8/21/2012 09:10'!
addInLog: msg
	self configuration activatedLog
		ifFalse: [ ^ self ].
	self log add: msg.
	self triggerEvent: 'logRefreshed'! !

!VOAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 10/29/2012 16:48'!
answerOn: socket
	self openStreamOn: socket.
	[ self manageStream ]
		ensure: [ self closeStream ]! !

!VOAgent methodsFor: 'removing' stamp: 'NicolasVanderAuwera 12/9/2011 08:00'!
clearLog
	log := nil! !

!VOAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/6/2011 14:13'!
closeStream
	stream close! !

!VOAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:12'!
configuration
	^ configuration ifNil: [ configuration := VOAgentConfiguration new port: self class port ]! !

!VOAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 07:52'!
configuration: anObject
	configuration := anObject! !

!VOAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 13:25'!
configurations
	^ configurations! !

!VOAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/3/2012 08:41'!
cryptographicParameters
	^ cryptographicParameters! !

!VOAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/3/2012 07:52'!
handle: aMessage
	aMessage command = #test
		ifTrue: [ ^ stream sendObject: (VOMessage new command: self class key) ].
	aMessage command = #parameters
		ifTrue: [ self receiveParameters: aMessage ]! !

!VOAgent methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/2/2012 14:15'!
hasConfigurations
	^ true! !

!VOAgent methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/3/2012 08:28'!
hasCryptographicParameters
	^ cryptographicParameters notNil! !

!VOAgent methodsFor: 'testing' stamp: 'NicolasVanderAuwera 8/21/2012 09:10'!
hasLog
	^ self configuration activatedLog! !

!VOAgent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/21/2012 09:09'!
initialize
	super initialize.
	server := VOServer new handler: [ :socket | self answerOn: socket ].
	log := VOLog new.
	configuration := VOAgentConfiguration new port: self class port! !

!VOAgent methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/27/2012 14:53'!
isRunning
	^ server isRunning! !

!VOAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 10:18'!
log
	^ log! !

!VOAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 13:25'!
manageStream
	self handle: stream receiveObject! !

!VOAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/9/2011 10:40'!
openStreamOn: socket
	stream := SocketStream on: socket.
	self addInLog: 'New connection established'! !

!VOAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 08:01'!
port
	^ configuration port! !

!VOAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/3/2012 07:52'!
receiveParameters: aMessage
	| parameters |
	parameters := aMessage content.
	configurations := parameters at: #configurations.
	cryptographicParameters := parameters at: #parameters! !

!VOAgent methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/2/2012 11:12'!
start
	server startAtPort: self port.
	self addInLog: 'Server started'! !

!VOAgent methodsFor: 'running' stamp: 'NicolasVanderAuwera 12/9/2011 08:10'!
stop
	server stop.
	self addInLog: 'Server stopped'! !

VOAgent subclass: #VOCertifiedAgent
	instanceVariableNames: 'subjectInfo certificate publicKey privateKey subjectKeyInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

!VOCertifiedAgent commentStamp: 'NicolasVanderAuwera 3/10/2012 15:53' prior: 0!
Agent with a RSA key pair.!

!VOCertifiedAgent class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 12/31/2011 11:03'!
country
	^ 'BE'! !

!VOCertifiedAgent class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 12/31/2011 11:03'!
organisation
	^ 'Volunti'! !

!VOCertifiedAgent class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 12/31/2011 11:03'!
organisationUnit
	^ 'Agent'! !

!VOCertifiedAgent methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 14:09'!
buildSubject
	^ Dictionary new
		at: #subjectInfo put: self subjectInfo;
		at: #subjectKeyInfo put: self subjectKeyInfo;
		yourself! !

!VOCertifiedAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 08:08'!
certificate
	(certificate isNil or: [ certificate isValid not ])
		ifTrue: [ certificate := self requestCertificate ].
	^ certificate! !

!VOCertifiedAgent methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/21/2012 08:59'!
certificateValidity
	^ certificate tbsCertificate validity notAfter asDate! !

!VOCertifiedAgent methodsFor: 'certificate' stamp: 'NicolasVanderAuwera 5/6/2012 10:37'!
createSubjectInfo
	^ VOAgentX501SubjectInfo
		country: self class country
		organisation: self class organisation
		organisationUnit: self class organisationUnit! !

!VOCertifiedAgent methodsFor: 'certificate' stamp: 'NicolasVanderAuwera 5/6/2012 10:40'!
createSubjectKeyInfo
	| subKeyInfo |
	subKeyInfo := X509SubjectPublicKeyInfo new.
	subKeyInfo subjectPublicKey: self publicKey.
	subKeyInfo algorithm: (X509AlgorithmIdentifier oidString: '1.2.840.113549.1.1.5').
	^ subKeyInfo! !

!VOCertifiedAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 14:14'!
handle: aMessage
	super handle: aMessage.
	aMessage command = #certificate
		ifTrue: [ stream sendObject: self certificate ]! !

!VOCertifiedAgent methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/20/2012 14:15'!
hasCertificate
	^ certificate notNil! !

!VOCertifiedAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 08:07'!
privateKey
	privateKey isNil
		ifTrue: [ self requestKeys ].
	^ privateKey! !

!VOCertifiedAgent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 08:07'!
publicKey
	publicKey isNil
		ifTrue: [ self requestKeys ].
	^ publicKey! !

!VOCertifiedAgent methodsFor: 'cryptography' stamp: 'NicolasVanderAuwera 11/20/2012 14:19'!
refreshCertificate
	certificate := self requestCertificate.
	self addInLog: 'Certificate refreshed'! !

!VOCertifiedAgent methodsFor: 'cryptography' stamp: 'NicolasVanderAuwera 11/20/2012 14:17'!
refreshKeys
	self requestKeys.
	self refreshCertificate! !

!VOCertifiedAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 14:19'!
requestCertificate
	| connection receipt |
	connection := VOConnection configuration: (self configurations at: #vocertificationauthority).
	receipt := connection send: (VOCertificateRequestMessage new content: self buildSubject).
	self addInLog: 'Certificate received'.
	^ receipt! !

!VOCertifiedAgent methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 14:11'!
requestKeys
	| connection receipt |
	connection := VOConnection configuration: (self configurations at: #vokeygenerationserver).
	receipt := connection send: VOKeyRequestMessage new.
	publicKey := receipt at: #publickey.
	privateKey := receipt at: #privatekey.
	self addInLog: 'New keys are received'! !

!VOCertifiedAgent methodsFor: 'cryptography' stamp: 'NicolasVanderAuwera 7/27/2012 08:15'!
sign: aString
	^ self privateKey v15SignMessage: aString
	! !

!VOCertifiedAgent methodsFor: 'certificate' stamp: 'NicolasVanderAuwera 5/6/2012 10:46'!
subjectInfo
	^ subjectInfo ifNil: [ subjectInfo := self createSubjectInfo ]! !

!VOCertifiedAgent methodsFor: 'certificate' stamp: 'NicolasVanderAuwera 5/11/2012 08:08'!
subjectKeyInfo
	^ subjectKeyInfo ifNil: [ subjectKeyInfo := self createSubjectKeyInfo ]! !

VOCertifiedAgent subclass: #VOManager
	instanceVariableNames: 'authorities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

!VOManager methodsFor: 'adding' stamp: 'NicolasVanderAuwera 11/20/2012 15:01'!
addAuthority: anAuthority
	anAuthority
		when: #close
		send: #removeaSubAgent:
		to: self
		with: anAuthority.
	self authorities add: anAuthority.
	self testInvariant.
	self
		addInLog:
			'A new authority (' , anAuthority class name , '), for the election named ' , anAuthority class name , ', has been created.'! !

!VOManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 15:00'!
authorities
	^ authorities ifNil: [ authorities := OrderedCollection new ]! !

!VOManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/19/2012 09:00'!
authorityClass
	self subclassResponsibility! !

!VOManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/27/2012 07:59'!
authorityFor: aProtocol
	"must be overriden"! !

!VOManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 7/23/2012 07:48'!
authorityFor: aProtocol id: id name: name numberOfChoices: anInteger
	^ (self authorityFor: aProtocol) id: id name: name privateKey: privateKey numberOfChoices: anInteger! !

!VOManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/27/2012 08:00'!
authorityOnStream
	^ self authorityWithId: self idOnStream! !

!VOManager methodsFor: 'searching' stamp: 'NicolasVanderAuwera 7/23/2012 07:49'!
authorityWithId: anId
	^ self authorities detect: [ :each | each id = anId ] ifNone: [ nil ]! !

!VOManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 7/23/2012 07:50'!
closeAuthority
	| authority |
	authority := self authorityWithId: stream nextLine greaseInteger.
	authority notNil
		ifFalse: [ ^ self ].
	authority close.
	self addInLog: 'Authority ' , authority id greaseString , ' was closed'! !

!VOManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 15:09'!
createAuthority: anElection
	| authority |
	authority := (self authorityFor: anElection protocol) newFrom: anElection.
	self addAuthority: authority.
	^ authority! !

!VOManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 11/20/2012 14:49'!
handle: aMessage
	super handle: aMessage.
	aMessage command = #initialization
		ifTrue: [ self createAuthority: aMessage content ].
	aMessage command = #close
		ifTrue: [ self closeAuthority ].
	aMessage command = #open
		ifTrue: [ self openAuthority ]! !

!VOManager methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/3/2012 08:18'!
hasConfigurations
	^ configurations notNil! !

!VOManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/27/2012 08:00'!
idOnStream
	^ stream nextLine greaseInteger! !

!VOManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/19/2012 09:05'!
openAuthority
	(self authorityWithId: self idOnStream) open! !

!VOManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 14:19'!
requestConfigurations
	| client |
	client := SocketStream openConnectionToHostNamed: NetNameResolver localHostName port: VOElectionManager port.
	client sendCommand: #configurations.
	configurations := client receiveObject.
	client close! !

!VOManager methodsFor: 'test' stamp: 'NicolasVanderAuwera 8/19/2012 09:04'!
testInvariant
	self assert: (authorities allSatisfy: [ :authority | authority isKindOf: self authorityClass ])! !

GRObject subclass: #VOAuthority
	instanceVariableNames: 'id name opened createdAt configurations numberOfChoices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

!VOAuthority class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 3/5/2012 15:21'!
id: anInteger name: aString
	^ self new
		id: anInteger;
		name: aString;
		yourself! !

!VOAuthority class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/5/2012 08:56'!
id: anInteger name: aString privateKey: sk
	| po |
	po := self id: anInteger name: aString.
	po privateKey: sk.
	^ po! !

!VOAuthority class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/8/2012 07:33'!
id: anInteger name: aString privateKey: sk numberOfChoices: anotherInteger
	| agent |
	agent := self id: anInteger name: aString.
	agent privateKey: sk.
	agent numberOfChoices: anotherInteger.
	^ agent! !

!VOAuthority methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 5/2/2012 10:05'!
close
	opened := false! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 16:18'!
configurations
	configurations ifNil: [ self requestConfigurations ].
	^ configurations! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:04'!
createdAt
	^ createdAt! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/5/2012 15:21'!
id
	^ id! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/5/2012 15:21'!
id: anObject
	id := anObject! !

!VOAuthority methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/7/2012 07:05'!
initialize
	super initialize.
	createdAt := DateAndTime now.
	opened := false! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/5/2012 15:21'!
name
	^ name! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/5/2012 15:21'!
name: anObject
	name := anObject! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 07:32'!
numberOfChoices: anInteger
	numberOfChoices := anInteger! !

!VOAuthority methodsFor: 'public' stamp: 'NicolasVanderAuwera 5/2/2012 10:05'!
open
	opened := true! !

!VOAuthority methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 07:06'!
opened
	^ opened! !

!VOAuthority methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 15:01'!
requestConfigurations
	| client |
	client := SocketStream openConnectionToHostNamed: NetNameResolver localHostName port: VOElectionManager port.
	client sendCommand: #configurations.
	configurations := client receiveObject.
	client close! !

GRObject subclass: #VOChoice
	instanceVariableNames: 'id name image'
	classVariableNames: 'Id'
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!VOChoice class methodsFor: 'accessing instances and variables' stamp: 'NicolasVanderAuwera 11/19/2011 14:07'!
id
	Id isNil
		ifTrue: [ Id := 0 ].
	^ Id := Id + 1! !

!VOChoice class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 11/16/2011 09:42'!
name: aString
	^ self new
		name: aString;
		id: self id;
		yourself! !

!VOChoice methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 3/1/2012 07:25'!
<= aChoice
	^ self id < aChoice id! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 07:09'!
assertNatural: anId
	self assert: anId isInteger.
	self assert: anId > 0! !

!VOChoice methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 14:06'!
descriptionImage
	<magritteDescription>
	^ MAFileDescription new
		accessor: #image;
		label: 'Image';
		priority: 1;
		yourself! !

!VOChoice methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 14:08'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 2;
		comment: 'Indicate the name of the candidate.';
		beRequired;
		yourself! !

!VOChoice methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/19/2012 09:08'!
hasAnImage
	^ image notNil! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/16/2011 08:27'!
id
	^ id! !

!VOChoice methodsFor: 'private' stamp: 'NicolasVanderAuwera 3/1/2012 07:09'!
id: anId
	self assertNatural: anId.
	id := anId! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/19/2012 08:52'!
image
	^ image! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/19/2012 08:52'!
image: anObject
	image := anObject! !

!VOChoice methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2011 14:10'!
initialize
	super initialize.
	id := 0.
	name := ''! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/16/2011 08:29'!
name
	^ name! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/15/2011 11:13'!
name: aString
	self assert: aString isString.
	name := aString! !

!VOChoice methodsFor: 'validation' stamp: 'NicolasVanderAuwera 3/1/2012 10:24'!
validate
	self name notEmpty
		ifFalse: [ WAValidationNotification signal: 'Each choice must have a name.' ]! !

GRObject subclass: #VOEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

VOEntry subclass: #CryptographicParameters
	instanceVariableNames: 'numberOfWitnesses rsaKeyLength paillierKeyLength numberOfBallots hashFunction mentalBoothKeySize readOnly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!CryptographicParameters class methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/5/2012 14:44'!
defaultNumberOfWitnesses
	^ 5! !

!CryptographicParameters class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/30/2012 14:33'!
hashFunction
	^ SHA256! !

!CryptographicParameters class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/5/2012 14:37'!
maxNumberOfBallots
	^ 2! !

!CryptographicParameters class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 13:31'!
paillierKeyLength
	^ 128! !

!CryptographicParameters class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/30/2012 14:35'!
rsaKeyLength
	^ 1024! !

!CryptographicParameters methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/3/2012 10:00'!
beReadonly
	readOnly := true! !

!CryptographicParameters methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/3/2012 10:00'!
descriptionContainer
	<magritteContainer>
	self isReadonly
		ifTrue: [ 
			^ super descriptionContainer
				beReadonly;
				yourself ].
	^ super descriptionContainer! !

!CryptographicParameters methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:02'!
descriptionHashFunction
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #hashFunction;
		label: 'Hash function';
		comment: 'The function used by the system to hash messages.';
		options:
				(HashFunction allSubclasses
						remove: SHA256;
						remove: MD5;
						yourself);
		yourself! !

!CryptographicParameters methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:25'!
descriptionMentalBoothKeySize
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #mentalBoothKeySize;
		label: 'Mental booth key size';
		options: (5 to: 10);
		yourself! !

!CryptographicParameters methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:22'!
descriptionNumberOfBallots
	<magritteDescription>
	^ MANumberDescription new
		accessor: #numberOfBallots;
		label: 'Number of ballots';
		comment: 'The number of ballots that could be submitted by a voter.';
		beRequired;
		yourself! !

!CryptographicParameters methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:22'!
descriptionNumberOfWitnesses
	<magritteDescription>
	^ MANumberDescription new
		accessor: #numberOfWitnesses;
		label: 'Number of witnesses';
		comment: 'The number of witnesses involved in the elections.';
		beRequired;
		yourself! !

!CryptographicParameters methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:25'!
descriptionPaillierKeyLength
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #paillierKeyLength;
		label: 'Paillier key length';
		options: #(128 256 512 1024 2048 4096);
		default: 2048;
		yourself! !

!CryptographicParameters methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:25'!
descriptionRSAKeyLength
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #rsaKeyLength;
		label: 'RSA key length';
		options: #(128 256 512 1024 2048 4096);
		default: 2048;
		yourself! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:53'!
hashFunction
	^ hashFunction! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:53'!
hashFunction: anObject
	hashFunction := anObject! !

!CryptographicParameters methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/3/2012 08:38'!
initialize
	super initialize.
	numberOfWitnesses := 10.
	paillierKeyLength := rsaKeyLength := 2048.
	numberOfBallots := 5.
	hashFunction := SHA256NonPrimitive.
	mentalBoothKeySize := 5.
	readOnly := false! !

!CryptographicParameters methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/3/2012 10:03'!
isReadonly
	^ readOnly! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:24'!
mentalBoothKeySize
	^ mentalBoothKeySize! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:24'!
mentalBoothKeySize: anObject
	mentalBoothKeySize := anObject! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfBallots
	^ numberOfBallots! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfBallots: anObject
	numberOfBallots := anObject! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfWitnesses
	^ numberOfWitnesses! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfWitnesses: anObject
	numberOfWitnesses := anObject! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
paillierKeyLength
	^ paillierKeyLength! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
paillierKeyLength: anObject
	paillierKeyLength := anObject! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
rsaKeyLength
	^ rsaKeyLength! !

!CryptographicParameters methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
rsaKeyLength: anObject
	rsaKeyLength := anObject! !

VOEntry subclass: #Election
	instanceVariableNames: 'choices name id createdAt startDate endDate protocol opened description properties'
	classVariableNames: 'Archive Database Types'
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

Election class
	instanceVariableNames: 'id'!

!Election commentStamp: 'NicolasVanderAuwera 3/1/2012 07:14' prior: 0!
I am an election and I have my protocol.

Instance Variables:
	k -> number of choices that the voter has to select
	choices -> list of choices!

Election class
	instanceVariableNames: 'id'!

!Election class methodsFor: 'adding' stamp: 'NicolasVanderAuwera 11/4/2012 08:16'!
add: anElection
	self database add: anElection! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 08:51'!
archive
	^ Archive ifNil: [ Archive := OrderedCollection new ]! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 14:02'!
database
	Database ifNil: [ Database := OrderedCollection new ].
	^ Database! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 09:52'!
description
	^ 'Choose 1 out of N'! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:31'!
id
	id ifNil: [ id := 0 ].
	^ id := id + 1! !

!Election class methodsFor: 'removing' stamp: 'NicolasVanderAuwera 11/20/2012 09:49'!
remove: anElection
	self database remove: anElection.
	self archive add: anElection! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 09:49'!
withId: anId
	^ self database detect: [ :election | election id = anId ] ifNone: [ nil ]! !

!Election methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 12/7/2011 10:34'!
<= election
	^ self id <= election id! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/7/2012 18:34'!
ballot
	^ VOBallot! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/27/2012 15:04'!
choices
	^ choices! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/27/2012 15:04'!
choices: aCollection
	choices := aCollection! !

!Election methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/2/2012 08:31'!
close
	opened := false! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/4/2012 14:47'!
createdAt
	^ createdAt! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/28/2012 13:00'!
description
	^ description! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/28/2012 13:00'!
description: anObject
	description := anObject! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/15/2012 07:49'!
descriptionChoices
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #choices;
		label: 'Choices';
		classes: (Array with: VOChoice);
		addCondition: [ :value | value notEmpty ] labelled: 'An election must have at least one choice';
		componentClass: VOOneToManyComponent;
		priority: 5;
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 10:51'!
descriptionContainer
	^ super descriptionContainer
		addCondition: [ :memento | 
					(memento cache at: self descriptionStartDate) isNil
						or: [ (memento cache at: self descriptionEndDate) > (memento cache at: self descriptionStartDate) ] ]
			labelled: 'End date must be after start date';
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/15/2012 07:50'!
descriptionDescription
	<magritteDescription>
	^ MAMemoDescription new
		accessor: #description;
		label: 'Description';
		comment: 'Describe in few words your election.';
		priority: 2;
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/15/2012 07:49'!
descriptionEndDate
	<magritteDescription>
	^ MADateAndTimeDescription new
		accessor: #endDate;
		label: 'End date';
		priority: 4;
		comment: 'Indicate the end date of the election.';
		addCondition: [ :value | value > Date today ] labelled: 'The end date must be greater than today';
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 15:58'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 1;
		comment: 'Please enter the name of the election.';
		beRequired;
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/15/2012 07:49'!
descriptionProperties
	<magritteDescription>
	^ MAMultipleOptionDescription new
		accessor: #properties;
		label: 'Properties';
		optionsAndLabels: (VOProperty allSubclasses collect: [ :class | class new -> class new name ]);
		priority: 6;
		comment: 'Select one or more properties. You can also let the system with no properties.';
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/20/2012 09:28'!
descriptionProtocol
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #protocol;
		label: 'Protocol';
		optionsAndLabels: (VOProtocol withAllSubclasses collect: [ :class | class new -> class key capitalized ]);
		comment:
				'Simple : the voter has to choose between different candidates. The partial result of the election is always available. Anonymous : the voter is anonymized before the voting phase. The result is presented once the election is finished. Mentalbooth and Alternative : use different techniques to protect the voter from over-the-shoulder attacks.';
		beRequired;
		beSorted;
		priority: 6;
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/15/2012 07:49'!
descriptionStartDate
	<magritteDescription>
	^ MADateAndTimeDescription new
		accessor: #startDate;
		label: 'Start date';
		priority: 3;
		addCondition: [ :value | value > Date today ] labelled: 'The start date must be greater than today';
		comment: 'Indicate the start date of the election.';
		yourself! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
endDate
	^ endDate! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
endDate: anObject
	endDate := anObject! !

!Election methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/17/2012 13:40'!
hasDates
	^ self startDate notNil or: [ self endDate notNil ]! !

!Election methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/17/2012 13:41'!
hasDescription
	^ self description notNil! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:20'!
id
	^ id! !

!Election methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 08:53'!
initialize
	super initialize.
	createdAt := DateAndTime now.
	id := self class id.
	name := ''.
	opened := false.
	description := ''.
	choices := OrderedCollection new! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/3/2012 13:41'!
legend
	^ 'Create the election you want'! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:36'!
name
	^ name! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:36'!
name: aString
	name := aString! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 16:52'!
numberOfChoices
	^ choices size! !

!Election methodsFor: 'public' stamp: 'NicolasVanderAuwera 5/2/2012 08:31'!
open
	opened := true! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/2/2012 09:35'!
opened
	^ opened! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:18'!
properties
	^ properties! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:18'!
properties: anObject
	properties := anObject! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:09'!
protocol
	^ protocol! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:09'!
protocol: anObject
	protocol := anObject! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
startDate
	^ startDate! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
startDate: anObject
	startDate := anObject! !

Election subclass: #KOutOfNElection
	instanceVariableNames: 'maxNumberOfAllowedChoices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!KOutOfNElection commentStamp: 'NicolasVanderAuwera 11/8/2011 07:49' prior: 0!
Choose K out of N (when a voter cast his vote, it should be with only k value to 1)!

!KOutOfNElection class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 09:52'!
description
	^ 'Choose K out of N'! !

!KOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/7/2012 18:34'!
ballot
	^ VOKOutOfNBallot! !

!KOutOfNElection methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/3/2012 17:02'!
descriptionMaxNumberOfAllowedChoices
	<magritteDescription>
	^ MANumberDescription new
		accessor: #maxNumberOfAllowedChoices;
		label: 'Maximum number of choices';
		beRequired;
		bePositive;
		comment: 'Please enter the maximum number of choices a voter can select.';
		yourself! !

!KOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2011 08:12'!
maxNumberOfAllowedChoices
	^ maxNumberOfAllowedChoices! !

!KOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2011 11:20'!
maxNumberOfAllowedChoices: aNumber
	maxNumberOfAllowedChoices := aNumber! !

KOutOfNElection subclass: #MPtKOutOfNElection
	instanceVariableNames: 'pointsToDistribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!MPtKOutOfNElection class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 09:53'!
description
	^ 'Distribute M points to K out of N with possible equality'! !

!MPtKOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/7/2012 18:34'!
ballot
	^ VOMPtKOutOfNBallot! !

!MPtKOutOfNElection methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/3/2012 17:02'!
descriptionPointsToDistribute
	<magritteDescription>
	^ MANumberDescription new
		accessor: #pointsToDistribute;
		label: 'Points to distribute';
		comment: 'Please enter the number of points a voter has to distribute among choices.';
		bePositive;
		beRequired;
		yourself! !

!MPtKOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/10/2012 10:21'!
isRemainingPointsToDistribute
	^ self pointsToDistribute > 0! !

!MPtKOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2011 07:19'!
pointsToDistribute
	^ pointsToDistribute! !

!MPtKOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2011 07:19'!
pointsToDistribute: anObject
	pointsToDistribute := anObject! !

VOEntry subclass: #VOAgentConfiguration
	instanceVariableNames: 'port ipAddress activatedLog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

!VOAgentConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:01'!
activatedLog
	^ activatedLog! !

!VOAgentConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:01'!
activatedLog: anObject
	activatedLog := anObject! !

!VOAgentConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 10:33'!
buttons
	^ Array with: #save -> 'Sauver'! !

!VOAgentConfiguration methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/2/2012 12:44'!
descriptionActivatedLog
	<magritteDescription>
	^ MABooleanDescription new
		accessor: #activatedLog;
		label: 'Activate log';
		default: false;
		comment: 'Effective once the session is finished';
		priority: 5;
		yourself! !

!VOAgentConfiguration methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 05:41'!
descriptionIpAddress
	<magritteDescription>
	^ MAStringDescription new
		accessor: #ipAddress;
		label: 'IP Address';
		beReadonly;
		priority: 3;
		yourself! !

!VOAgentConfiguration methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 05:57'!
descriptionPort
	<magritteDescription>
	^ MANumberDescription new
		accessor: #port;
		label: 'Port';
		beRequired;
		bePositive;
		priority: 4;
		yourself! !

!VOAgentConfiguration methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 09:49'!
initialize
	super initialize.
	port := 0.
	ipAddress := NetNameResolver localHostName.
	activatedLog := true! !

!VOAgentConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 08:23'!
ipAddress
	^ ipAddress ifNil: [ ipAddress := NetNameResolver localHostName ]! !

!VOAgentConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 07:53'!
port
	^ port! !

!VOAgentConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 07:53'!
port: anObject
	port := anObject! !

VOEntry subclass: #VOConfigurationManager
	instanceVariableNames: 'configurations configured'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOConfigurationManager class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/5/2012 11:24'!
configurations: aDictionary
	^ self new configurations: aDictionary! !

!VOConfigurationManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 10:33'!
buttons
	^ Array with: #save -> 'Continue'! !

!VOConfigurationManager methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/2/2012 12:17'!
checkAll
	self configurations do: [ :configuration | configuration toCheck: true ]! !

!VOConfigurationManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 11:46'!
configurations
	^ configurations! !

!VOConfigurationManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 11:24'!
configurations: aDictionary
	configurations := aDictionary! !

!VOConfigurationManager methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/29/2012 14:34'!
descriptionConfigurations
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #configurations;
		classes: (Array with: VONetworkConfiguration);
		componentClass: VOOneToManyEditableOnlyComponent;
		priority: 1;
		yourself! !

!VOConfigurationManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 10:34'!
formCss
	^ 'form-vertical'! !

!VOConfigurationManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/5/2012 11:35'!
initialize
	super initialize.
	configured := false! !

!VOConfigurationManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 14:16'!
isConfigured
	^ configured! !

!VOConfigurationManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 10:23'!
legend
	^ 'Please enter the host address and the port of each authority.'! !

!VOConfigurationManager methodsFor: 'validation' stamp: 'NicolasVanderAuwera 11/2/2012 12:36'!
validateAllConfigurations
	| booleans |
	booleans := self configurations
		collect: [ :configuration | 
			configuration testConnection.
			configuration isConfigured ].
	configured := booleans detect: [ :bool | bool = false ] ifNone: [ true ]! !

!VOConfigurationManager methodsFor: 'validation' stamp: 'NicolasVanderAuwera 11/2/2012 12:36'!
validateAllConfigurations: aBoolean
	aBoolean
		ifTrue: [ self validateAllConfigurations ]
		ifFalse: [ self validateSelectedConfigurations ]! !

!VOConfigurationManager methodsFor: 'validation' stamp: 'NicolasVanderAuwera 11/2/2012 12:34'!
validateSelectedConfigurations
	| booleans |
	booleans := self configurations
		collect: [ :configuration | 
			configuration toCheck
				ifTrue: [ 
					configuration testConnection.
					configuration isConfigured ]
				ifFalse: [ false ] ].
	configured := booleans detect: [ :bool | bool = false ] ifNone: [ true ]! !

!VOEntry methodsFor: 'converting' stamp: 'NicolasVanderAuwera 11/3/2012 17:26'!
asComponent
	| form |
	form := super asComponent
		addDecoration: TWBSMagritteValidationDecoration new;
		addDecoration:
				(TWBSMagritteFormDecoration newWithDefaultButtons
						buttons: self buttons;
						formCss: self formCss;
						"legend: self legend;"
						yourself);
		yourself.
	form magritteDescription twbsInlineValidationMessages: false.
	^ form! !

!VOEntry methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 06:37'!
buttons
	^ Array with: #save -> 'Sauver' with: #cancel -> 'Annuler'! !

!VOEntry methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 10:23'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: TWBSMagritteFormRenderer;
		yourself! !

!VOEntry methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 10:33'!
formCss
	^ 'form-horizontal'! !

!VOEntry methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 10:21'!
legend
	^ ''! !

VOEntry subclass: #VOLogEntry
	instanceVariableNames: 'description createdAt problem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

!VOLogEntry class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/15/2012 09:09'!
description: aString
	^ self new description: aString! !

!VOLogEntry class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 10/29/2012 14:53'!
description: aString problem: aBoolean
	^ (self description: aString) problem: aBoolean! !

!VOLogEntry methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 09:09'!
createdAt
	^ createdAt! !

!VOLogEntry methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 09:09'!
description
	^ description! !

!VOLogEntry methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/15/2012 09:09'!
description: anObject
	description := anObject! !

!VOLogEntry methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/29/2012 11:54'!
descriptionCreatedAt
	<magritteDescription>
	^ MADateAndTimeDescription new
		accessor: #createdAt;
		label: 'Date and time';
		priority: 2;
		yourself! !

!VOLogEntry methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/29/2012 11:54'!
descriptionDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #description;
		label: 'Description';
		priority: 3;
		yourself! !

!VOLogEntry methodsFor: 'testing' stamp: 'NicolasVanderAuwera 10/29/2012 14:39'!
hasProblem
	^ problem := false! !

!VOLogEntry methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/29/2012 12:03'!
initialize
	super initialize.
	createdAt := DateAndTime now.
	problem := false! !

!VOLogEntry methodsFor: 'testing' stamp: 'NicolasVanderAuwera 10/29/2012 10:49'!
isRecent
	^ Date today - (Duration hours: 2) <= createdAt asDate! !

!VOLogEntry methodsFor: 'printing' stamp: 'NicolasVanderAuwera 8/2/2012 14:08'!
print
	^ self createdAt greaseString , ' - ' , self description greaseString! !

!VOLogEntry methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 14:52'!
problem: aBoolean
	problem := aBoolean! !

VOEntry subclass: #VOMBUser
	instanceVariableNames: 'id signature share'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Users'!

!VOMBUser methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 11:43'!
descriptionId
	<magritteDescription>
	^ MANumberDescription new
		accessor: #id;
		label: 'Identifier';
		bePositive;
		yourself! !

!VOMBUser methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 11:44'!
descriptionSignature
	<magritteDescription>
	^ MANumberDescription new
		accessor: #signature;
		label: 'Signature';
		bePositive;
		yourself! !

!VOMBUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 09:17'!
fields
	^ #(#id #signature)! !

!VOMBUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 09:15'!
id
	^ id! !

!VOMBUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 09:15'!
id: anObject
	id := anObject! !

!VOMBUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 08:01'!
share
	^ share! !

!VOMBUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 08:01'!
share: anObject
	share := anObject! !

!VOMBUser methodsFor: 'process' stamp: 'NicolasVanderAuwera 8/23/2012 08:05'!
sign: m with: partialSignature
	| partialSign |
	partialSign := (share sign: m) * partialSignature \\ share n.
	^ partialSign * (share correctionFor: m) \\ share n! !

!VOMBUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 09:15'!
signature
	^ signature! !

!VOMBUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 09:15'!
signature: anObject
	signature := anObject! !

!VOMBUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 8/18/2012 08:07'!
validate
	(id notNil and: [ id > 0 ])
		ifFalse: [ WAValidationNotification signal: 'The ID must be positive.' ].
	(signature notNil and: [ signature > 0 ])
		ifFalse: [ WAValidationNotification signal: 'The signature must be positive.' ]! !

VOEntry subclass: #VOUser
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Users'!

VOUser subclass: #VOAuthenticatedUser
	instanceVariableNames: 'password salt confirmationPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model'!

!VOAuthenticatedUser class methodsFor: 'generator' stamp: 'NicolasVanderAuwera 5/3/2012 06:43'!
generateSalt: size
	| characterList random salt |
	characterList := 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789' asByteString.
	random := SecureRandom new.
	salt := ByteString new.
	size timesRepeat: [ salt := salt , (characterList at: (random nextFrom: 1 to: characterList size)) greaseString ].
	^ salt! !

!VOAuthenticatedUser methodsFor: 'actions' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
authenticate
	| ok client |
	ok := false.
	client := SocketStream openConnectionToHostNamed: NetNameResolver localHostName port: VORegistrationOfficeManager port.
	client sendObject: self message: #authenticate.
	ok := client nextLine asSymbol = #success.
	client close.
	^ ok! !

!VOAuthenticatedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 07:38'!
confirmationPassword
	^ confirmationPassword! !

!VOAuthenticatedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 11:05'!
confirmationPassword: aString
	confirmationPassword := aString! !

!VOAuthenticatedUser methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/3/2012 09:42'!
defaultPasswordLength
	^ 8! !

!VOAuthenticatedUser methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/3/2012 06:46'!
defaultSaltSize
	^ 30! !

!VOAuthenticatedUser methodsFor: 'process' stamp: 'NicolasVanderAuwera 5/3/2012 09:33'!
encryptPassword: aString
	^ SHA256 new hashMessage: aString , self salt! !

!VOAuthenticatedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 11:07'!
fields
	^ super fields , #(#password #confirmationPassword)! !

!VOAuthenticatedUser methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/29/2012 09:11'!
initialize
	super initialize.
	password := ''! !

!VOAuthenticatedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 07:38'!
password
	^ password ! !

!VOAuthenticatedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 13:39'!
password: anObject
	password := anObject! !

!VOAuthenticatedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:46'!
salt
	salt ifNil: [ salt := self class generateSalt: self defaultSaltSize ].
	^ salt! !

!VOAuthenticatedUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/3/2012 11:06'!
validate
	super validate.
	password size >= self defaultPasswordLength
		ifFalse: [ 
			WAValidationNotification
				signal: 'Your password must have at least ' , self defaultPasswordLength greaseString , ' characters.' ].
	password = confirmationPassword
		ifFalse: [ WAValidationNotification signal: 'Passwords not match.' ].	"self authenticate
		ifFalse: [ WAValidationNotification signal: 'Information that you have provided are not correct.' ]."
	password := self encryptPassword: password! !

!VOAuthenticatedUser methodsFor: 'process' stamp: 'NicolasVanderAuwera 5/3/2012 09:44'!
verifyPassword: anotherString
	^ password = (self encryptPassword: anotherString)! !

VOUser subclass: #VOSystemUser
	instanceVariableNames: 'password confirmationPassword role'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Users'!

!VOSystemUser class methodsFor: 'adding' stamp: 'NicolasVanderAuwera 11/1/2012 12:42'!
add: anUser
	Database add: anUser! !

!VOSystemUser class methodsFor: 'private' stamp: 'NicolasVanderAuwera 11/20/2012 11:02'!
buildDatabase
	^ OrderedCollection new
		add: (self createAdministrator: 'admin' password: 'admin');
		yourself! !

!VOSystemUser class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 11/2/2012 08:12'!
createAdministrator: aName password: aPassword
	^ self new
		name: aName;
		password: aPassword;
		role: #administrator;
		yourself! !

!VOSystemUser class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 11:03'!
database
	^ Database ifNil: [ Database := self buildDatabase ]! !

!VOSystemUser class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:22'!
description
	^ 'This user can create, manage and delete an election.'! !

!VOSystemUser class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:23'!
key
^ 'Election creator'! !

!VOSystemUser class methodsFor: 'enumerating' stamp: 'NicolasVanderAuwera 11/20/2012 11:03'!
withUsername: aString
	^ self database detect: [ :user | user name = aString ] ifNone: [ nil ]! !

!VOSystemUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:20'!
confirmationPassword
	^ confirmationPassword! !

!VOSystemUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:20'!
confirmationPassword: anObject
	confirmationPassword := anObject! !

!VOSystemUser methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/1/2012 12:35'!
descriptionConfirmationPassword
	<magritteDescription>
	^ MAPasswordDescription new
		accessor: #confirmationPassword;
		label: 'Password confirmation';
		priority: 4;
		beRequired;
		yourself! !

!VOSystemUser methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/1/2012 11:19'!
descriptionContainer
	^ super descriptionContainer
		addCondition: [ :memento | 
					(memento cache at: self descriptionPassword) isNil
						or: [ (memento cache at: self descriptionPassword) = (memento cache at: self descriptionConfirmationPassword) ] ]
			labelled: 'Passwords must match';
		yourself! !

!VOSystemUser methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/1/2012 12:34'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		beRequired;
		priority: 1;
		yourself! !

!VOSystemUser methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/1/2012 12:35'!
descriptionPassword
	<magritteDescription>
	^ MAPasswordDescription new
		accessor: #password;
		label: 'Password';
		priority: 3;
		beRequired;
		yourself! !

!VOSystemUser methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/1/2012 12:36'!
descriptionRole
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #role;
		label: 'Role';
		optionsAndLabels: (Array with: #manager -> 'Manager' with: #administrator -> 'Administrator');
		beRequired;
		comment: 'A manager can create/manage/delete elections and an administrator can manage all the system.';
		priority: 2;
		yourself! !

!VOSystemUser methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/1/2012 13:57'!
isAdministrator
	^ role = #administrator! !

!VOSystemUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:20'!
password
	^ password! !

!VOSystemUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 11:20'!
password: anObject
	password := anObject! !

!VOSystemUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 12:28'!
role
	^ role! !

!VOSystemUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 12:28'!
role: anObject
	role := anObject! !

!VOUser methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/3/2012 06:35'!
defaultNameLength
	^ 4! !

!VOUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/29/2012 12:56'!
description
	^ 'All fields are required.'! !

!VOUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/29/2012 09:23'!
fields
	^ #(description name)! !

!VOUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/30/2012 14:44'!
id
	^ name! !

!VOUser methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/29/2012 09:09'!
initialize
	super initialize.
	name := ''! !

!VOUser methodsFor: 'testing' stamp: 'NicolasVanderAuwera 4/11/2012 08:52'!
isAdmin
	^ false! !

!VOUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/6/2012 07:47'!
name
	^ name! !

!VOUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/6/2012 07:47'!
name: anObject
	name := anObject! !

!VOUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/3/2012 09:38'!
validate
	self name size >= self defaultNameLength
		ifFalse: [ 
			WAValidationNotification
				signal: 'Your name must have at least ' , self defaultNameLength greaseString , ' characters.' ]! !

GRObject subclass: #VONetworkConfiguration
	instanceVariableNames: 'description host port configured key errorMsg receipt connection toCheck'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VONetworkConfiguration commentStamp: 'NicolasVanderAuwera 3/10/2012 15:54' prior: 0!
I contains information about an agent (host, port,...)!

!VONetworkConfiguration class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 3/1/2012 13:17'!
description: aString key: aSymbol
	^ self new
		description: aString;
		key: aSymbol;
		yourself! !

!VONetworkConfiguration methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 1/18/2012 10:11'!
defaultHost
	^ NetNameResolver localHostName! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/18/2012 09:38'!
description
	^ description! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/18/2012 09:38'!
description: anObject
	description := anObject! !

!VONetworkConfiguration methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 07:05'!
descriptionDescription
	<magritteDescription>
	^ MAStringDescription new
		accessor: #description;
		label: 'Name';
		beReadonly;
		yourself! !

!VONetworkConfiguration methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 06:50'!
descriptionHost
	<magritteDescription>
	^ MAStringDescription new
		accessor: #host;
		label: 'Host address';
		beRequired;
		priority: 1;
		default: self defaultHost;
		yourself! !

!VONetworkConfiguration methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 06:49'!
descriptionPort
	<magritteDescription>
	^ MANumberDescription new
		accessor: #port;
		label: 'Port';
		beRequired;
		bePositive;
		priority: 2;
		yourself! !

!VONetworkConfiguration methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 11/1/2012 09:27'!
descriptionToCheck
	<magritteDescription>
	^ MABooleanDescription new
		accessor: #toCheck;
		label: 'To check?';
		default: false;
		yourself! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 15:51'!
errorMsg
	connection ifNil: [ ^ '' ].
	^ connection errorMsg! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/18/2012 10:11'!
host
	host isNil
		ifTrue: [ host := self defaultHost ].
	^ host! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/9/2012 13:42'!
host: anObject
	host := anObject! !

!VONetworkConfiguration methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/1/2012 09:52'!
initialize
	super initialize.
	configured := false.
	toCheck := false! !

!VONetworkConfiguration methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/17/2012 11:39'!
isConfigured
	^ configured! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 13:19'!
key
	^ key! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 13:19'!
key: anObject
	key := anObject! !

!VONetworkConfiguration methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/17/2012 11:51'!
notConfigured
	^ configured not! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 08:13'!
port
	^ port! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/9/2012 13:42'!
port: anObject
	port := anObject! !

!VONetworkConfiguration methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/1/2012 09:37'!
testConnection
	connection := VOConnection configuration: self.
	receipt := connection send: VOTestConnectionMessage new.
	receipt ifNil: [ ^ self ].
	receipt command = self key
		ifTrue: [ configured := true ]
		ifFalse: [ errorMsg := 'You are trying to connect to another agent.' ]! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:25'!
toCheck
	^ toCheck! !

!VONetworkConfiguration methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:25'!
toCheck: anObject
	toCheck := anObject! !

GRObject subclass: #VOServer
	instanceVariableNames: 'listener connections handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOServer commentStamp: 'NicolasVanderAuwera 3/10/2012 15:55' prior: 0!
I am waiting until a client try to communicate with me.!

!VOServer methodsFor: 'adding' stamp: 'NicolasVanderAuwera 12/7/2011 10:15'!
addConnection: conn
	conn
		when: #closed
		send: #removeConnection:
		to: self
		with: conn.
	self connections add: conn! !

!VOServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/6/2011 13:02'!
connections
	"Answer the value of connections"

	^ connections! !

!VOServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/6/2011 13:14'!
connections: anObject
	"Set the value of connections"

	connections := anObject! !

!VOServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/6/2011 13:13'!
handler
	"Answer the value of handler"

	^ handler! !

!VOServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/6/2011 13:13'!
handler: anObject
	"Set the value of handler"

	handler := anObject! !

!VOServer methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 12/6/2011 13:14'!
initialize
	self connections: OrderedCollection new! !

!VOServer methodsFor: 'testing' stamp: 'NicolasVanderAuwera 12/6/2011 14:54'!
isRunning
	^ listener notNil and: [ listener isRunning ]! !

!VOServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/6/2011 13:02'!
listener
	"Answer the value of listener"

	^ listener
! !

!VOServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/6/2011 13:01'!
listener: anObject
	"Set the value of listener"

	listener := anObject! !

!VOServer methodsFor: 'printing' stamp: 'NicolasVanderAuwera 12/6/2011 13:14'!
printOn: stream
	super printOn: stream.
	stream nextPutAll: ' - '.
	self listener isRunning
		ifTrue: [ stream nextPutAll: '[running]' ]
		ifFalse: [ stream nextPutAll: '[stopped]' ]! !

!VOServer methodsFor: 'removing' stamp: 'NicolasVanderAuwera 12/9/2011 08:25'!
removeConnection: conn
	self connections remove: conn ifAbsent: [  ]! !

!VOServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/6/2011 13:15'!
serveSocket: socket
	self addConnection: socket.
	self handler notNil
		ifTrue: [ self handler value: socket ]! !

!VOServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/6/2011 13:20'!
startAtPort: port
	self listener:
		(ConnectionListener onPort: port handler: [ :socket | self serveSocket: socket ] priority: Processor highIOPriority)
			start! !

!VOServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/6/2011 14:48'!
stop
	self listener stop! !

GRObject subclass: #VOSpecialUser
	instanceVariableNames: 'nationalNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Users'!

VOSpecialUser subclass: #VOAdvancedUser
	instanceVariableNames: 'email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Users'!

!VOAdvancedUser methodsFor: 'converting' stamp: 'NicolasVanderAuwera 5/11/2012 07:28'!
asSubjectInfo
	^ VOUserX501SubjectInfo email: email nationalNumber: nationalNumber! !

!VOAdvancedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 07:28'!
email
	^ email! !

!VOAdvancedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 07:28'!
email: anObject
	email := anObject! !

!VOAdvancedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 07:28'!
fields
	^ #(email) , super fields! !

!VOAdvancedUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/11/2012 07:29'!
validate
	self validateEmail.
	super validate! !

!VOAdvancedUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/11/2012 07:28'!
validateEmail
	"| regex |
	regex := '[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}'.
	(email matchesRegex: regex)
		ifFalse: [ WAValidationNotification signal: 'Your email is incorrect.' ]"! !

VOAdvancedUser subclass: #VOAnonymousUser
	instanceVariableNames: 'blindedId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Users'!

!VOAnonymousUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/5/2012 17:37'!
blindedId
	^ blindedId! !

!VOAnonymousUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/5/2012 17:37'!
blindedId: anObject
	blindedId := anObject! !

!VOAnonymousUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/10/2012 09:07'!
fields
	^ super fields , #(#blindedId)! !

!VOAnonymousUser methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/29/2012 09:23'!
initialize
	super initialize.
	blindedId := 0! !

!VOAnonymousUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/5/2012 07:32'!
validate
	super validate.
	self blindedId = 0
		ifTrue: [ WAValidationNotification signal: 'The signed id field must not be empty.' ]! !

VOSpecialUser subclass: #VORegistratedUser
	instanceVariableNames: 'firstname lastname age'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Users'!

VORegistratedUser class
	instanceVariableNames: 'users'!

VORegistratedUser class
	instanceVariableNames: 'users'!

!VORegistratedUser class methodsFor: 'adding' stamp: 'NicolasVanderAuwera 2/6/2012 11:02'!
addUser: aUser
	self users add: aUser! !

!VORegistratedUser class methodsFor: 'searching' stamp: 'NicolasVanderAuwera 2/6/2012 10:56'!
userWithID: idString password: passwordString
	^ self users detect: [ :each | each name = idString and: [ each verifyPassword: passwordString ] ] ifNone: [ nil ]! !

!VORegistratedUser class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 10:57'!
users
	users isNil
		ifTrue: [ users := OrderedCollection new ].
	^ users! !

!VORegistratedUser class methodsFor: 'searching' stamp: 'NicolasVanderAuwera 2/6/2012 11:00'!
usersWithId: idString
	^ self users detect: [ :aUser | aUser name = idString ] ifNone: [ nil ]! !

!VORegistratedUser methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 5/3/2012 06:26'!
= aUser
	^ nationalNumber = aUser nationalNumber! !

!VORegistratedUser methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/3/2012 06:11'!
adult
	^ 18! !

!VORegistratedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:11'!
age
	^ age! !

!VORegistratedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:11'!
age: anObject
	age := anObject! !

!VORegistratedUser methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/3/2012 11:58'!
defaultNameLength
	^ 3! !

!VORegistratedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:17'!
fields
	^ #(#firstname #lastname #age) , super fields! !

!VORegistratedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:11'!
firstname
	^ firstname! !

!VORegistratedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:11'!
firstname: anObject
	firstname := anObject! !

!VORegistratedUser methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 5/3/2012 06:27'!
hash
	^ nationalNumber hash! !

!VORegistratedUser methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/18/2012 08:06'!
initialize
	super initialize.
	firstname := ''.
	lastname := ''! !

!VORegistratedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:11'!
lastname
	^ lastname! !

!VORegistratedUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 06:11'!
lastname: anObject
	lastname := anObject! !

!VORegistratedUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 8/2/2012 14:17'!
validate
	self validateNames.
	self validateAge.
	super validate.
	(self class usersWithId: nationalNumber) notNil
		ifTrue: [ WAValidationNotification signal: 'You are already registered' ]! !

!VORegistratedUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/3/2012 06:13'!
validateAge
	age >= self adult
		ifFalse: [ WAValidationNotification signal: 'You age must be greater or equal to ' , self adult greaseString ]! !

!VORegistratedUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/3/2012 06:10'!
validateNames
	firstname size >= self defaultNameLength
		ifFalse: [ 
			WAValidationNotification
				signal: 'Your firstname must have at least ' , self defaultNameLength greaseString , ' characters.' ].
	lastname size >= self defaultNameLength
		ifFalse: [ 
			WAValidationNotification
				signal: 'Your firstname must have at least ' , self defaultNameLength greaseString , ' characters.' ]! !

!VOSpecialUser methodsFor: 'converting' stamp: 'NicolasVanderAuwera 8/2/2012 14:31'!
asSubjectInfo
	^ VOUserX501SubjectInfo nationalNumber: nationalNumber! !

!VOSpecialUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/11/2012 07:28'!
fields
	^ #(nationalNumber)! !

!VOSpecialUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 07:30'!
nationalNumber
	^ nationalNumber! !

!VOSpecialUser methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 07:30'!
nationalNumber: anObject
	nationalNumber := anObject! !

!VOSpecialUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/11/2012 07:29'!
validate
	self validateNationalNumber! !

!VOSpecialUser methodsFor: 'validation' stamp: 'NicolasVanderAuwera 8/18/2012 09:13'!
validateNationalNumber
	| regex |
	regex := '[0-9][0-9].[0-9][0-9].[0-9][0-9]-[0-9][0-9][0-9].[0-9][0-9]'.
	(nationalNumber matchesRegex: regex)
		ifFalse: [ WAValidationNotification signal: 'The national number has the following format: XX.XX.XX-XXX.XX (X is a digit).' ]! !

GRObject subclass: #VOX501SubjectInfo
	instanceVariableNames: 'dn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

VOX501SubjectInfo subclass: #VOAgentX501SubjectInfo
	instanceVariableNames: 'country organisation organisationUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!VOAgentX501SubjectInfo class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/3/2012 10:01'!
country: country organisation: organisation organisationUnit: organisationUnit
	^ self new
		country: country;
		organisation: organisation;
		organisationUnit: organisationUnit;
		yourself! !

!VOAgentX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
country
	^ country! !

!VOAgentX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
country: anObject
	country := anObject! !

!VOAgentX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:00'!
dn
	^ dn ifNil: [ dn := Array with: self country with: self organisation with: self organisationUnit ]! !

!VOAgentX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
organisation
	^ organisation! !

!VOAgentX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
organisation: anObject
	organisation := anObject! !

!VOAgentX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
organisationUnit
	^ organisationUnit! !

!VOAgentX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
organisationUnit: anObject
	organisationUnit := anObject! !

VOX501SubjectInfo subclass: #VOUserX501SubjectInfo
	instanceVariableNames: 'email nationalNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!VOUserX501SubjectInfo class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/3/2012 10:02'!
email: anEmail nationalNumber: aString
	^ self new
		email: anEmail;
		nationalNumber: aString;
		yourself! !

!VOUserX501SubjectInfo class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/2/2012 14:19'!
nationalNumber: aString
	^ self new
		nationalNumber: aString;
		yourself! !

!VOUserX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:04'!
dn
	^ dn ifNil: [ dn := Array with: email with: nationalNumber ]! !

!VOUserX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
email
	^ email! !

!VOUserX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:03'!
email: anObject
	email := anObject! !

!VOUserX501SubjectInfo methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 8/2/2012 14:19'!
hash
	^ nationalNumber hash! !

!VOUserX501SubjectInfo methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/9/2012 10:01'!
initialize
	super initialize.
	nationalNumber := ''.
	email := ''! !

!VOUserX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:04'!
nationalNumber
	^ nationalNumber! !

!VOUserX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:04'!
nationalNumber: anObject
	nationalNumber := anObject! !

!VOX501SubjectInfo methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 5/3/2012 09:55'!
= aSubjectInfo
	^ self hash = aSubjectInfo hash! !

!VOX501SubjectInfo methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 10:02'!
dn
	self subclassResponsibility! !

!VOX501SubjectInfo methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 5/3/2012 10:54'!
hash
	^ self dn hash! !

!SecureRandom methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 1/5/2012 10:10'!
nextModulo: n
	| rand ea |
	[ 
	rand := self next.
	ea := EuclidAlgorithm with: n with: rand.
	ea run.
	ea gcd = 1 ] whileFalse.
	^ rand! !

RSAPrivateKey subclass: #VORSAPrivateKey
	instanceVariableNames: 'd e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!VORSAPrivateKey class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/20/2012 13:32'!
p: int1 q: int2 dP: int3 dQ: int4 qInv: int5 d: int6

	^ self new
		p: int1 q: int2 dP: int3 dQ: int4 qInv: int5 d: int6;
		yourself! !

!VORSAPrivateKey methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/5/2012 14:15'!
isVORSAPrivateKey
	^ true! !

!VORSAPrivateKey methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 1/20/2012 13:32'!
p: int1 q: int2 dP: int3 dQ: int4 qInv: int5 d: int6
	p := int1.
	q := int2.
	dP := int3.
	dQ := int4.
	qInv := int5.
	d := int6
! !

!SocketStream methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 2/28/2012 08:20'!
receiveObject
	| data size |
	size := self nextLine.	"size of the streamed object"
	data := self next: size greaseInteger.
	^ Object from: data! !

!SocketStream methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 2/28/2012 07:21'!
requestObject: aSymbol
	self sendCommand: aSymbol.
	^ self receiveObject! !

!SocketStream methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 2/28/2012 07:19'!
requestObject: aSymbol arg: argument
	self sendCommand: aSymbol.
	self sendCommand: argument greaseString.
	^ self receiveObject! !

!SocketStream methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 2/28/2012 07:02'!
sendObject: anObject
	| streamedObject |
	streamedObject := anObject asStreamedObject.
	self sendCommand: streamedObject size greaseString.
	self
		nextPutAll: streamedObject;
		flush! !

!SocketStream methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 2/28/2012 07:02'!
sendObject: anObject message: msg
	self sendCommand: msg.
	self sendObject: anObject! !

WAFileLibrary subclass: #VOFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOFileLibrary methodsFor: 'uploaded' stamp: 'NicolasVanderAuwera 11/17/2012 13:51'!
applicationCss
	^ '/* Images
-------------------------------------------------- */

li.choice img {
	width: 100px;
	-moz-box-shadow: 0px 0px 5px 0px #656565;
	-webkit-box-shadow: 0px 0px 5px 0px #656565;
	-o-box-shadow: 0px 0px 5px 0px #656565;
	box-shadow: 0px 0px 5px 0px #656565;
	filter:progid:DXImageTransform.Microsoft.Shadow(color=#656565, Direction=NaN, Strength=5);
}



/* Sticky footer
-------------------------------------------------- */

* {
	margin: 0;
}
html, body {
	height: 100%;
}
.wrapper {
	min-height: 100%;
	height: auto !!important;
	height: 100%;
	margin: 0 auto -142px; /* the bottom margin is the negative value of the footer''s height */
}
.footer, .push {
	height: 142px; /* .push must be the same height as .footer */
}



/* Sidenav for Docs
-------------------------------------------------- */

.bs-docs-sidenav {
  width: 228px;
  margin: 30px 0 0;
  padding: 0;
  background-color: #fff;
  -webkit-border-radius: 6px;
     -moz-border-radius: 6px;
          border-radius: 6px;
  -webkit-box-shadow: 0 1px 4px rgba(0,0,0,.065);
     -moz-box-shadow: 0 1px 4px rgba(0,0,0,.065);
          box-shadow: 0 1px 4px rgba(0,0,0,.065);
}
.bs-docs-sidenav > li > a {
  display: block;
  width: 190px \9;
  margin: 0 0 -1px;
  padding: 8px 14px;
  border: 1px solid #e5e5e5;
}
.bs-docs-sidenav > li:first-child > a {
  -webkit-border-radius: 6px 6px 0 0;
     -moz-border-radius: 6px 6px 0 0;
          border-radius: 6px 6px 0 0;
}
.bs-docs-sidenav > li:last-child > a {
  -webkit-border-radius: 0 0 6px 6px;
     -moz-border-radius: 0 0 6px 6px;
          border-radius: 0 0 6px 6px;
}
.bs-docs-sidenav > .active > a {
  position: relative;
  z-index: 2;
  padding: 9px 15px;
  border: 0;
  text-shadow: 0 1px 0 rgba(0,0,0,.15);
  -webkit-box-shadow: inset 1px 0 0 rgba(0,0,0,.1), inset -1px 0 0 rgba(0,0,0,.1);
     -moz-box-shadow: inset 1px 0 0 rgba(0,0,0,.1), inset -1px 0 0 rgba(0,0,0,.1);
          box-shadow: inset 1px 0 0 rgba(0,0,0,.1), inset -1px 0 0 rgba(0,0,0,.1);
}
/* Chevrons */
.bs-docs-sidenav .icon-chevron-right {
  float: right;
  margin-top: 2px;
  margin-right: -6px;
  opacity: .25;
}
.bs-docs-sidenav > li > a:hover {
  background-color: #f5f5f5;
}
.bs-docs-sidenav a:hover .icon-chevron-right {
  opacity: .5;
}
.bs-docs-sidenav .active .icon-chevron-right,
.bs-docs-sidenav .active a:hover .icon-chevron-right {
  background-image: url(../img/glyphicons-halflings-white.png);
  opacity: 1;
}
.bs-docs-sidenav.affix {
  top: 40px;
}
.bs-docs-sidenav.affix-bottom {
  position: absolute;
  top: auto;
  bottom: 270px;
}



/* Footer
-------------------------------------------------- */

.footer {
  /*padding: 70px 0;*/
  /*margin-top: 70px;*/
  border-top: 1px solid #e5e5e5;
  background-color: #f5f5f5;
}
.footer p {
  margin-bottom: 0;
  color: #777;
}
.footer-links {
  margin: 10px 0;
}
.footer-links li {
  display: inline;
  padding: 0 2px;
}
.footer-links li:first-child {
  padding-left: 0;
}'! !

!VOFileLibrary methodsFor: 'uploaded' stamp: 'NicolasVanderAuwera 10/29/2012 14:31'!
logo3Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 1 2 0 0 0 80 8 6 0 0 0 242 126 123 24 0 0 3 240 105 67 67 80 73 67 67 32 80 114 111 102 105 108 101 0 0 40 145 141 85 221 111 219 84 20 63 137 111 92 164 22 63 160 177 142 14 21 139 175 85 83 91 185 27 26 173 198 6 73 147 165 233 66 26 185 205 216 42 164 201 117 110 26 83 215 54 182 211 109 85 159 246 2 111 12 248 3 128 178 7 30 144 120 66 26 12 196 246 178 237 1 180 73 83 65 21 213 36 164 61 116 218 64 104 147 246 130 170 112 174 175 83 187 93 198 184 145 175 127 57 231 119 62 239 209 53 64 199 87 154 227 152 73 25 96 222 242 93 53 159 145 143 159 152 150 59 86 33 9 207 65 39 244 64 167 166 123 78 186 92 46 2 46 198 133 71 214 195 95 33 193 222 55 7 218 235 255 115 117 86 169 167 3 36 158 66 108 87 61 125 30 241 105 128 148 169 59 174 15 32 222 70 249 240 41 223 65 220 241 60 226 29 46 38 136 88 97 120 150 227 44 195 51 28 31 15 56 83 234 40 98 150 139 164 215 181 42 226 37 196 253 51 49 249 108 12 243 28 130 181 35 79 45 234 26 186 204 122 81 118 237 154 97 210 88 186 79 80 255 207 53 111 54 90 241 122 241 233 242 230 38 143 226 187 143 213 94 119 199 212 16 127 174 107 185 73 196 47 35 190 230 248 25 38 127 21 241 189 198 92 37 141 120 47 64 242 153 154 123 164 194 249 201 55 22 235 83 239 32 222 137 184 106 248 133 169 80 190 104 205 148 38 184 109 114 121 206 62 170 134 156 107 186 55 138 61 131 23 17 223 170 211 66 145 231 35 64 149 102 115 172 95 136 123 235 141 177 208 191 48 238 45 76 230 90 126 22 235 163 37 238 71 112 223 211 198 203 136 123 16 127 232 218 234 4 207 89 88 166 102 94 229 254 133 43 142 95 14 115 16 214 45 179 84 228 62 137 68 189 160 198 64 238 215 167 198 184 45 57 224 227 33 114 91 50 93 51 142 20 66 254 146 99 6 179 136 185 145 243 110 67 173 132 156 27 154 155 203 115 63 228 62 181 42 161 207 212 174 170 150 101 189 29 68 124 24 142 37 52 160 96 195 12 238 58 88 176 1 50 168 144 135 12 190 29 112 81 83 3 3 76 148 80 212 82 148 24 137 167 97 14 101 237 121 229 128 195 113 196 152 13 172 215 153 53 70 105 207 225 17 238 132 28 155 116 19 133 236 199 231 32 41 146 67 100 152 140 128 76 222 36 111 145 195 36 139 210 17 114 112 211 182 28 139 207 98 221 217 244 243 62 52 208 43 227 29 131 204 185 158 70 95 20 239 172 123 210 208 175 127 244 247 22 107 251 145 156 105 43 159 120 7 192 195 14 180 152 3 241 250 175 46 253 176 43 242 177 66 46 188 123 179 235 234 18 76 60 169 191 169 219 169 245 212 10 238 171 169 181 136 145 250 61 181 134 191 85 72 99 110 102 144 209 60 62 70 144 135 23 203 32 94 195 101 124 124 208 112 255 3 121 118 140 183 37 98 205 58 215 19 105 88 39 232 7 165 135 37 56 219 31 73 149 223 148 63 149 21 229 11 229 188 114 119 91 151 219 118 73 248 84 248 86 248 81 248 78 248 94 248 25 100 225 146 112 89 248 73 184 34 124 35 92 140 157 213 227 231 99 243 236 131 122 91 213 50 77 187 94 83 48 165 140 180 91 122 73 202 74 47 72 175 72 197 200 159 212 45 13 73 99 210 30 212 236 222 60 183 120 188 120 45 6 156 192 189 213 213 246 177 56 175 130 90 3 78 5 21 120 65 135 45 56 179 109 254 67 107 210 75 134 72 97 219 212 14 179 89 110 49 196 156 152 21 211 32 139 123 197 17 113 72 28 103 184 149 159 184 7 117 35 184 231 182 76 157 254 152 10 104 140 21 175 115 32 152 58 54 171 204 122 33 208 121 64 125 122 218 103 23 237 168 237 156 113 141 217 186 47 239 83 148 215 229 52 126 170 168 92 176 244 193 126 89 51 77 57 80 121 178 75 61 234 46 208 234 32 176 239 32 191 162 31 168 193 247 45 177 243 122 36 243 223 6 56 244 23 222 89 55 34 217 116 3 224 107 15 160 251 181 72 214 135 119 226 179 159 1 92 56 160 55 220 133 240 206 79 36 126 1 240 106 251 247 241 127 93 25 188 155 110 53 155 15 240 190 234 248 4 96 227 227 102 243 159 229 102 115 227 75 244 191 6 112 201 252 23 89 0 113 120 196 40 194 64 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 1 110 105 84 88 116 88 77 76 58 99 111 109 46 97 100 111 98 101 46 120 109 112 0 0 0 0 0 60 120 58 120 109 112 109 101 116 97 32 120 109 108 110 115 58 120 61 34 97 100 111 98 101 58 110 115 58 109 101 116 97 47 34 32 120 58 120 109 112 116 107 61 34 88 77 80 32 67 111 114 101 32 52 46 52 46 48 34 62 10 32 32 32 60 114 100 102 58 82 68 70 32 120 109 108 110 115 58 114 100 102 61 34 104 116 116 112 58 47 47 119 119 119 46 119 51 46 111 114 103 47 49 57 57 57 47 48 50 47 50 50 45 114 100 102 45 115 121 110 116 97 120 45 110 115 35 34 62 10 32 32 32 32 32 32 60 114 100 102 58 68 101 115 99 114 105 112 116 105 111 110 32 114 100 102 58 97 98 111 117 116 61 34 34 10 32 32 32 32 32 32 32 32 32 32 32 32 120 109 108 110 115 58 100 99 61 34 104 116 116 112 58 47 47 112 117 114 108 46 111 114 103 47 100 99 47 101 108 101 109 101 110 116 115 47 49 46 49 47 34 62 10 32 32 32 32 32 32 32 32 32 60 100 99 58 115 117 98 106 101 99 116 62 10 32 32 32 32 32 32 32 32 32 32 32 32 60 114 100 102 58 66 97 103 47 62 10 32 32 32 32 32 32 32 32 32 60 47 100 99 58 115 117 98 106 101 99 116 62 10 32 32 32 32 32 32 60 47 114 100 102 58 68 101 115 99 114 105 112 116 105 111 110 62 10 32 32 32 60 47 114 100 102 58 82 68 70 62 10 60 47 120 58 120 109 112 109 101 116 97 62 10 229 63 13 65 0 0 32 0 73 68 65 84 120 156 236 189 105 144 92 215 117 38 248 157 123 239 91 114 171 202 218 80 133 194 94 196 66 98 39 1 145 20 41 145 144 104 106 113 219 150 59 220 180 37 183 37 175 45 217 146 237 158 233 137 153 24 79 119 76 48 102 194 158 112 79 119 132 219 61 51 29 182 167 99 198 61 94 198 150 61 178 100 89 75 219 150 104 81 226 46 113 193 70 128 4 64 108 133 165 0 212 146 89 149 249 242 189 123 206 252 120 75 190 151 149 5 20 68 201 150 102 112 16 133 202 202 124 247 220 237 220 239 44 247 220 155 36 34 184 67 119 232 14 253 255 155 212 63 116 3 238 208 29 186 67 255 240 116 7 8 238 208 29 186 67 119 128 224 14 221 161 59 116 7 8 238 208 29 186 67 184 3 4 119 232 14 221 33 0 230 59 205 144 136 232 59 197 75 254 30 182 52 86 106 239 223 71 221 223 45 186 217 28 124 63 247 235 14 125 247 136 222 142 92 244 17 184 219 4 129 39 147 223 71 115 229 118 73 238 179 172 113 223 73 1 206 181 155 138 237 40 188 254 174 212 253 221 162 158 185 232 211 175 236 239 239 171 126 125 63 210 119 82 185 172 192 43 125 175 192 239 237 204 231 183 5 4 197 133 244 36 240 68 178 144 103 102 86 15 4 141 237 55 127 182 118 82 48 54 38 248 244 46 201 11 240 219 234 108 214 238 39 9 79 28 165 184 189 135 128 198 116 183 45 181 73 1 158 194 119 186 238 239 38 37 253 234 206 69 191 126 1 185 49 5 128 79 11 190 199 251 245 253 68 253 129 120 25 173 26 132 151 173 49 28 37 60 129 226 26 27 27 139 121 124 7 228 244 182 129 160 43 116 79 16 14 205 16 26 219 9 237 89 194 198 137 184 129 173 198 173 193 32 88 36 96 61 48 186 24 63 27 180 186 101 188 146 224 90 69 224 205 10 198 22 25 167 135 4 181 147 130 167 14 49 240 228 183 213 209 229 0 176 139 48 115 84 97 227 4 161 213 32 4 67 185 54 95 0 234 19 140 234 101 233 214 61 38 233 194 249 94 90 52 203 250 117 122 72 101 115 49 119 89 1 235 129 245 201 195 23 46 0 94 165 103 76 191 55 251 245 253 68 125 149 98 47 16 23 148 11 144 7 225 155 177 94 182 198 118 2 104 78 20 215 215 185 203 2 63 153 207 177 49 193 167 191 61 128 95 53 16 244 21 186 53 158 194 220 101 133 154 175 208 169 17 6 170 132 176 69 8 131 229 96 224 120 146 127 191 94 45 147 132 1 73 228 23 158 37 211 22 114 60 153 11 44 195 122 22 131 150 209 140 24 87 3 198 212 44 167 29 93 109 39 187 237 126 66 225 208 46 194 216 81 133 153 138 66 205 85 240 141 66 83 43 132 101 170 87 227 182 205 53 151 4 229 58 163 205 140 134 101 212 191 253 186 191 155 180 98 191 92 171 225 59 10 75 70 165 99 76 142 39 212 92 146 217 239 131 126 125 63 81 95 165 56 53 75 104 166 10 38 81 116 94 69 80 170 73 87 185 76 10 198 142 230 45 206 28 61 217 5 147 198 118 202 214 216 232 16 161 97 20 6 218 4 140 198 143 122 77 193 124 89 10 243 249 109 42 205 219 4 130 39 9 135 158 82 152 25 83 24 128 70 109 147 130 14 244 160 170 104 86 161 22 67 74 172 75 98 150 186 187 17 139 75 32 109 186 38 145 141 8 149 50 164 67 10 0 74 154 10 59 23 45 183 196 100 133 149 116 44 161 101 27 141 106 4 101 35 116 174 89 52 92 123 59 130 155 77 212 19 79 116 129 203 4 26 84 215 131 182 97 88 149 53 83 164 197 144 66 228 18 140 17 210 161 80 36 172 150 108 180 96 23 45 212 64 183 238 218 73 193 83 79 241 106 234 254 110 82 6 2 79 60 161 10 253 138 60 147 206 5 147 167 197 64 33 138 8 0 200 19 166 72 88 25 27 45 204 246 244 235 14 24 220 54 245 149 173 57 163 80 211 10 254 13 133 176 82 84 136 41 8 123 11 130 70 135 49 179 200 5 77 14 116 205 254 12 0 140 130 23 104 152 72 15 122 90 177 171 148 180 149 130 239 197 115 26 9 83 135 121 193 46 90 12 25 11 120 246 219 85 154 171 2 130 2 8 140 141 41 180 135 12 34 207 12 176 49 92 214 198 26 235 120 86 153 109 107 199 170 15 238 216 188 227 210 92 99 230 203 47 31 191 146 149 87 145 32 136 95 139 99 8 214 16 28 75 78 4 245 3 239 220 181 97 227 240 192 46 95 227 32 9 111 84 48 199 219 140 23 222 154 157 63 252 215 207 28 190 24 136 237 232 64 133 11 158 19 194 11 35 28 187 96 177 19 246 86 157 92 182 88 106 29 13 119 84 215 203 145 19 5 214 225 193 146 227 118 28 231 163 143 221 187 119 176 76 247 41 203 15 147 82 39 150 44 191 248 250 197 27 71 190 241 218 169 171 65 20 132 113 221 243 33 102 6 35 44 172 174 238 239 54 197 125 123 66 225 64 34 128 214 51 249 126 125 96 207 221 19 91 199 7 246 148 136 238 23 203 123 73 233 183 34 240 243 23 111 180 94 253 220 115 135 207 20 251 213 136 208 25 138 238 128 193 234 105 69 165 200 11 102 64 87 52 171 72 139 83 83 169 66 164 168 204 164 59 66 104 89 45 142 157 227 5 11 49 22 141 14 163 84 19 156 187 220 29 239 141 19 148 1 10 47 152 90 205 49 108 141 97 79 25 31 174 222 178 110 184 242 232 214 77 219 47 45 44 93 254 210 75 71 47 43 104 27 104 137 84 180 20 54 26 97 4 53 16 65 7 81 14 12 24 88 69 76 226 86 115 158 33 223 161 67 93 16 104 193 169 149 106 78 36 236 253 226 63 122 231 253 101 71 63 168 216 62 202 28 61 144 43 184 4 165 191 209 97 245 205 223 249 155 23 62 3 132 241 251 172 201 136 162 169 13 107 106 143 239 218 248 113 197 209 63 89 169 110 227 120 191 251 39 207 157 248 183 231 26 115 77 29 232 160 209 110 134 168 154 16 167 23 111 42 184 5 179 249 64 2 2 40 155 193 202 128 19 105 229 58 134 252 95 120 223 129 247 150 116 244 243 108 163 135 251 116 122 73 25 239 183 223 184 210 252 139 207 189 244 250 57 45 243 157 134 173 116 48 115 38 191 104 86 53 192 223 105 234 10 33 20 74 215 53 172 103 6 29 227 70 186 229 186 158 239 125 242 3 247 255 20 162 206 191 132 72 185 95 121 237 186 191 255 249 215 206 255 230 235 231 102 230 190 151 250 245 253 66 133 245 48 51 166 176 115 189 70 224 152 129 32 116 172 199 142 103 60 231 254 187 55 15 239 222 48 182 211 119 213 65 5 12 119 172 188 112 225 198 194 107 95 120 246 200 249 182 230 72 135 58 212 218 70 115 236 90 180 47 113 22 23 27 93 36 4 45 130 174 235 84 201 186 164 220 143 61 246 142 251 43 158 122 160 223 26 83 202 124 5 218 60 253 191 126 246 233 63 238 40 21 232 206 98 56 31 86 58 208 65 132 214 136 197 83 96 224 201 91 91 207 171 2 130 84 171 78 85 12 154 145 83 51 174 235 40 41 253 242 135 222 253 75 182 211 250 181 91 13 158 144 121 233 149 179 87 127 231 217 55 206 95 2 128 159 126 207 189 63 82 81 252 241 85 14 252 181 150 56 191 250 191 253 237 203 95 51 17 183 27 214 118 176 112 53 204 153 180 5 193 45 196 50 210 197 210 178 206 128 231 185 81 69 188 253 235 215 141 60 182 119 243 111 113 20 62 118 203 202 5 28 186 222 199 255 253 151 190 254 37 19 117 218 13 35 1 102 150 34 96 115 180 218 1 254 78 82 193 28 5 52 230 125 167 94 30 113 66 46 123 63 244 206 109 27 119 140 86 127 221 218 240 241 213 240 82 110 249 159 255 155 47 254 221 159 127 47 244 235 251 133 10 227 127 12 26 59 215 235 116 61 88 210 238 207 61 126 223 190 122 201 125 24 182 253 41 17 212 123 203 27 199 255 211 83 87 231 255 195 23 158 59 124 42 112 117 168 218 28 41 94 178 243 129 229 52 134 54 232 105 197 170 172 173 99 29 151 225 253 202 15 63 242 9 14 219 255 237 173 218 166 140 243 183 167 175 55 255 213 95 124 227 141 51 142 90 10 230 150 174 135 24 108 135 152 153 225 213 184 179 55 205 44 204 58 62 179 43 246 89 16 232 154 207 142 227 104 255 83 63 252 208 111 172 6 4 0 128 36 58 184 119 211 232 127 49 57 82 223 242 161 7 118 63 190 90 16 64 220 250 209 146 138 126 187 234 80 57 50 202 31 240 66 7 40 27 172 241 20 102 118 197 218 49 105 107 33 130 123 232 41 133 177 163 10 118 206 12 86 6 28 59 96 92 71 87 253 31 216 55 245 111 86 5 2 49 23 229 116 130 223 253 165 199 222 249 46 75 142 59 184 36 14 92 171 49 118 84 37 91 166 249 58 255 158 232 73 224 244 144 194 133 245 26 186 174 35 50 174 99 200 223 177 166 246 63 174 22 4 0 128 59 75 255 238 145 109 119 141 119 251 53 26 247 235 208 83 10 255 32 253 250 126 161 36 38 48 0 141 192 49 53 227 186 145 239 123 255 229 135 30 248 153 65 135 191 32 81 251 95 246 3 1 0 136 194 246 143 111 26 242 190 250 203 31 122 248 215 12 235 178 227 104 63 210 174 91 117 60 183 102 2 183 234 120 110 36 228 57 170 85 114 216 41 255 242 63 122 215 111 172 6 4 0 128 163 240 177 173 195 149 95 223 51 53 54 28 145 113 193 37 131 11 235 117 188 77 255 196 45 231 242 214 41 198 79 60 65 104 76 19 76 160 235 161 107 44 57 238 19 143 30 220 205 81 231 167 150 49 211 6 35 99 227 168 84 106 203 216 104 225 93 239 223 183 229 103 39 171 230 159 245 126 54 50 186 6 91 119 238 195 182 253 15 226 174 123 246 98 120 100 172 240 185 48 143 126 226 177 123 127 205 85 228 71 86 188 122 221 53 48 65 78 112 159 76 162 183 0 82 196 110 108 39 96 189 6 79 26 235 70 142 163 181 255 139 239 187 239 39 108 24 188 63 207 155 72 97 114 253 38 108 219 123 63 166 118 236 198 192 64 207 28 18 84 25 242 219 239 186 123 199 136 229 186 129 174 107 204 84 98 11 105 89 196 247 187 71 93 147 244 169 56 46 80 211 170 230 179 227 146 114 127 225 125 247 253 128 13 59 133 126 149 203 85 76 221 189 59 30 211 93 251 49 50 54 190 140 231 3 91 214 254 43 215 245 61 235 86 28 240 194 50 193 185 3 6 93 234 142 255 76 172 20 189 49 61 16 132 78 228 179 247 171 143 31 248 65 132 193 175 175 150 151 237 4 191 244 139 239 59 240 79 66 137 202 142 162 146 235 90 223 137 60 223 117 173 239 176 235 71 198 248 63 246 238 189 251 197 118 62 210 91 246 102 107 44 178 209 123 31 223 189 225 191 115 73 185 181 154 99 224 5 26 107 60 133 67 51 183 84 90 43 186 6 5 95 168 180 71 163 106 157 90 187 228 15 215 75 181 143 62 178 231 115 98 237 238 244 89 215 113 177 105 215 125 184 24 58 224 132 221 176 167 128 153 183 48 125 225 236 77 7 101 219 222 131 184 16 149 33 34 217 82 54 4 140 133 215 113 230 228 177 194 179 109 85 254 212 127 252 210 139 127 21 73 208 106 182 131 54 230 46 135 93 223 22 0 118 73 97 107 179 106 157 90 52 232 57 158 42 255 208 3 123 118 111 40 241 23 242 252 70 215 76 32 154 216 142 118 216 29 3 34 96 82 230 113 234 248 107 133 186 217 248 255 245 191 251 220 115 127 228 216 70 107 94 217 0 167 103 163 191 207 192 97 22 27 56 48 173 225 86 204 80 197 117 59 101 237 79 109 172 14 125 104 239 182 207 9 135 219 210 103 39 214 109 64 56 50 133 197 144 1 8 4 4 69 192 58 106 226 205 163 47 23 248 118 200 253 228 127 252 194 51 159 15 85 176 212 48 18 160 169 67 180 14 219 183 147 183 241 255 53 90 230 18 76 13 153 186 46 187 161 227 248 63 188 239 158 169 187 70 252 167 65 69 165 90 173 14 96 108 114 29 148 113 176 112 125 6 51 87 46 45 227 251 230 92 251 71 255 234 217 163 111 144 146 136 108 155 193 134 88 148 25 25 42 151 62 250 200 190 63 16 182 247 164 207 186 142 139 141 59 239 197 116 232 192 198 18 135 145 146 2 102 206 98 250 194 185 34 99 237 125 226 183 254 242 107 159 93 92 106 181 177 56 219 65 103 40 194 55 39 237 205 92 190 85 28 58 58 4 204 93 86 152 141 52 147 167 127 228 193 61 187 243 32 0 0 235 246 62 128 243 129 3 102 73 83 25 112 163 205 88 168 111 196 232 154 137 21 57 111 217 190 19 231 194 18 88 18 129 149 248 39 98 224 138 25 193 96 125 184 240 188 167 248 157 218 227 146 53 158 51 80 53 6 181 77 241 130 63 61 20 163 222 161 167 98 119 97 106 54 103 193 180 220 200 58 222 68 213 57 152 231 229 123 62 212 218 29 104 69 241 184 8 4 201 138 198 52 6 176 101 219 61 133 186 29 177 15 185 198 58 172 202 26 20 105 108 156 72 18 71 158 4 176 178 246 164 85 208 173 102 160 43 136 71 227 190 213 180 178 67 29 237 153 200 121 120 199 93 187 242 32 64 164 32 99 83 88 12 109 210 163 24 95 89 4 23 184 130 53 19 107 139 99 106 232 65 75 218 101 83 118 234 97 98 105 205 140 21 44 173 213 182 243 123 153 190 221 57 200 5 158 99 5 51 86 81 160 186 182 86 27 199 178 183 105 205 224 123 123 65 96 235 158 131 8 215 239 197 180 30 193 5 174 97 97 232 46 108 189 247 33 40 93 60 218 51 57 80 57 168 52 42 90 184 108 201 43 89 69 37 237 161 244 222 253 59 238 203 131 0 0 172 219 115 63 206 119 28 88 22 64 4 68 132 235 109 198 252 192 70 140 142 21 215 152 82 120 152 89 153 65 79 199 249 7 0 138 105 252 203 233 22 64 240 100 156 29 53 58 20 7 49 184 101 134 92 247 64 254 137 13 91 182 226 210 146 116 23 18 4 34 4 64 16 89 193 192 250 173 43 114 95 44 141 162 55 193 42 110 173 192 10 48 58 117 119 241 179 168 253 83 239 217 119 247 22 23 228 218 128 29 176 142 5 119 141 167 208 216 30 187 3 51 71 99 255 57 153 44 23 21 87 43 248 46 112 40 207 107 253 214 157 152 239 88 64 150 39 121 9 0 91 45 186 39 204 246 81 225 146 97 242 52 150 76 188 199 187 194 130 201 145 138 187 244 228 10 63 72 203 169 91 11 105 34 136 51 21 5 29 104 142 180 177 218 117 134 75 203 231 99 174 29 1 137 129 149 194 28 197 242 131 234 218 169 226 36 216 232 221 86 43 223 133 114 163 192 58 136 60 131 169 33 131 153 49 133 3 127 169 227 192 228 242 254 173 56 169 55 161 91 45 198 149 22 231 237 150 235 33 69 217 60 164 63 171 159 131 248 243 39 84 230 18 184 86 15 218 134 177 164 93 235 184 158 171 228 161 124 31 167 238 222 139 243 145 23 143 124 78 249 158 111 17 182 236 40 232 79 148 53 254 169 130 174 146 114 42 154 169 162 52 85 148 165 202 72 197 187 175 119 78 167 151 138 99 41 34 128 16 34 22 212 122 214 152 68 246 81 207 85 134 85 89 163 97 20 166 102 227 244 228 155 208 45 78 31 30 37 180 65 8 124 18 26 165 146 79 74 16 189 43 255 132 95 27 2 194 174 208 165 11 25 2 8 17 154 182 191 204 184 174 135 133 14 199 207 39 5 9 241 216 81 242 226 114 160 224 151 202 104 183 186 163 176 121 184 250 110 99 204 25 109 189 80 213 154 81 195 70 140 185 138 96 77 242 192 28 20 106 90 13 218 134 9 189 33 135 180 227 124 248 221 247 28 16 27 188 55 95 255 162 83 5 218 28 183 54 107 162 36 46 10 97 166 205 80 218 128 109 20 127 34 60 60 58 82 42 77 95 185 214 30 208 21 189 224 5 26 27 39 24 87 135 146 192 228 19 130 79 39 221 47 228 132 31 90 158 243 159 209 199 251 164 159 174 144 109 118 232 41 194 12 8 147 67 170 174 181 234 144 171 125 101 29 45 118 15 231 199 181 92 5 44 101 214 64 220 246 100 118 8 8 122 176 95 152 199 181 209 158 141 194 142 213 198 214 156 14 55 218 139 192 212 16 208 216 195 56 182 72 56 48 45 168 29 42 156 253 200 173 211 155 186 14 249 5 141 222 188 249 148 62 157 190 40 246 189 167 44 10 135 212 210 242 183 115 190 37 155 139 233 220 123 185 57 0 114 249 251 105 145 25 66 227 52 97 102 138 48 21 104 132 37 99 221 138 227 24 246 84 100 124 142 162 119 231 107 232 148 6 33 45 1 21 148 75 252 250 26 85 225 185 30 130 78 154 84 99 183 236 221 186 113 227 145 211 103 47 145 134 37 81 176 32 227 40 28 204 23 247 170 117 32 148 46 182 16 64 130 228 63 96 209 246 204 41 236 90 209 164 68 16 103 34 54 39 8 173 195 55 29 167 155 3 193 19 0 142 1 192 56 164 220 34 38 95 1 194 133 103 18 115 62 93 201 233 203 180 145 106 133 234 195 78 7 37 34 216 52 54 144 118 60 199 35 178 192 250 205 91 11 254 186 167 228 126 75 248 83 209 110 192 129 9 235 202 177 115 94 32 48 17 225 90 69 80 243 21 120 193 88 246 140 11 114 73 193 31 242 204 1 88 155 241 24 29 27 199 141 118 12 66 146 71 159 164 98 18 192 209 64 43 1 129 132 120 118 174 45 126 201 213 161 93 210 40 105 149 88 35 192 185 49 65 99 72 112 0 64 123 54 238 113 105 79 146 102 122 148 48 181 30 104 47 46 31 9 191 34 152 121 75 80 218 35 192 101 193 129 33 1 166 129 218 161 120 52 178 140 179 167 98 107 103 172 163 224 27 101 163 80 251 182 109 184 52 96 88 100 99 129 167 113 129 40 47 132 185 193 21 96 49 234 105 134 136 207 76 101 86 42 116 61 216 48 36 169 153 10 233 70 71 205 133 202 98 157 207 104 204 50 74 123 24 199 46 203 173 64 161 15 197 193 199 20 28 27 211 177 114 57 6 96 39 98 249 218 5 192 79 251 254 100 119 81 246 82 10 168 237 4 112 155 19 132 210 202 174 39 128 238 217 151 96 145 128 121 192 173 116 207 95 0 192 5 0 193 81 192 219 28 167 1 227 178 100 109 2 128 153 49 96 227 30 74 51 55 107 37 215 113 152 189 144 61 111 247 230 201 113 128 171 41 43 207 243 49 179 196 5 165 40 185 161 105 91 70 125 100 20 87 46 93 204 222 219 54 62 184 247 181 211 212 80 90 133 136 44 68 177 195 2 221 187 180 227 101 146 184 122 130 68 94 147 1 166 30 28 22 176 4 86 11 152 16 86 122 128 184 255 25 135 213 221 71 208 89 34 120 37 130 182 20 194 188 160 17 101 219 84 237 230 28 224 141 163 184 146 147 42 33 168 244 54 178 219 53 12 121 192 245 118 186 254 146 248 66 250 120 50 130 129 55 88 44 24 117 30 251 161 251 182 223 243 217 103 15 191 236 25 27 134 161 182 48 145 128 34 130 23 8 116 93 213 42 108 172 45 57 172 173 227 58 142 171 137 239 207 179 168 175 221 128 70 39 110 67 182 70 178 88 101 172 75 235 46 97 33 95 136 212 156 192 106 110 91 45 100 245 128 13 204 66 212 6 108 139 48 53 148 75 8 241 9 243 227 128 127 67 1 53 170 215 235 74 150 218 36 81 50 33 3 0 22 0 50 158 80 216 150 57 51 46 192 146 0 99 140 145 134 160 49 26 47 186 106 34 144 0 128 49 96 172 163 224 90 93 15 93 19 178 24 235 41 67 145 117 8 226 244 117 174 82 108 131 228 142 194 9 152 139 56 14 130 82 138 202 20 169 208 178 21 39 36 234 192 83 60 80 10 107 210 178 138 61 59 95 41 49 156 69 142 65 161 194 192 102 193 177 69 206 64 161 123 120 41 71 79 2 56 154 228 224 15 17 48 75 192 102 5 183 66 24 105 41 96 28 152 89 34 140 1 112 27 2 180 128 198 40 23 23 101 142 90 13 130 91 161 108 140 103 106 132 129 69 2 70 129 176 181 50 18 149 106 64 24 16 140 139 122 85 72 194 128 144 51 179 105 220 19 96 93 124 198 196 41 49 48 38 88 87 22 224 74 124 0 46 104 17 90 150 96 160 107 165 192 137 196 120 36 240 52 164 180 97 172 190 185 80 85 165 130 86 159 117 70 18 91 104 66 128 235 251 133 207 124 199 108 4 232 85 8 34 24 37 16 152 165 14 191 57 224 34 115 15 130 70 188 198 178 165 145 78 112 66 21 85 80 88 0 209 69 120 30 16 180 186 99 119 11 186 53 16 236 4 48 147 52 192 26 186 210 92 60 58 89 210 217 199 231 207 188 137 45 247 78 96 186 213 13 20 166 173 245 52 97 230 212 145 21 89 151 162 22 88 188 88 80 25 153 53 144 9 176 0 51 109 193 224 224 48 230 231 111 100 229 214 212 188 253 218 152 99 150 117 96 209 180 53 227 136 150 178 69 29 224 22 41 107 217 184 198 58 202 120 222 143 62 184 243 32 69 225 3 249 122 23 168 20 27 54 148 225 54 178 70 39 203 198 9 26 133 182 138 50 47 178 132 70 92 50 158 104 211 105 58 60 192 128 234 88 53 199 16 84 22 81 215 101 98 170 40 41 59 36 24 214 226 145 234 4 164 164 92 161 82 167 165 80 42 197 204 124 0 104 161 229 84 184 60 32 76 145 98 213 118 45 145 199 106 92 120 142 75 22 243 155 24 83 11 221 217 78 50 206 44 133 154 217 53 194 190 113 28 24 72 111 156 71 18 25 73 32 32 19 152 156 239 213 67 196 82 1 89 171 216 69 228 90 50 194 70 137 237 40 148 108 155 2 91 113 141 165 208 179 84 97 214 101 177 115 188 198 194 189 196 232 116 44 102 198 24 7 134 186 86 66 74 169 21 83 154 80 8 140 194 252 128 66 41 208 245 186 40 110 141 42 41 183 98 229 2 0 134 132 150 92 161 225 182 204 7 67 113 114 205 194 98 151 215 8 16 131 170 40 9 53 113 101 64 193 243 73 52 43 128 33 43 218 157 0 34 151 100 64 19 80 70 208 105 41 148 125 148 172 147 61 223 210 161 80 224 72 101 200 97 138 152 169 93 98 84 90 66 75 163 66 220 22 33 151 68 19 137 82 58 146 146 227 26 227 71 162 74 90 83 217 55 106 36 95 149 214 166 199 33 136 253 248 44 104 43 128 82 58 95 4 74 81 141 180 169 178 32 4 91 40 136 190 48 187 112 105 231 248 64 246 204 249 183 78 97 243 254 181 152 110 89 80 143 211 225 43 194 181 83 197 221 53 38 253 28 216 18 162 144 16 246 154 128 253 105 213 55 20 73 212 33 24 15 127 243 173 83 111 124 236 93 119 191 1 225 44 82 125 241 200 11 216 120 207 94 204 112 9 173 144 97 20 48 230 19 26 231 78 224 198 194 220 138 60 103 167 207 130 70 19 54 57 59 42 211 206 137 224 142 110 216 84 0 2 95 201 131 90 235 63 239 168 192 243 224 217 206 98 71 160 53 1 13 176 87 210 158 241 156 136 92 87 216 122 67 142 190 15 210 69 204 177 241 181 152 111 219 46 232 0 105 80 34 171 91 17 112 245 252 153 66 91 91 145 61 34 208 154 185 109 108 36 142 117 75 34 172 20 15 49 87 81 133 216 144 58 10 202 175 56 154 161 180 144 209 226 24 45 108 181 3 86 226 15 40 8 0 99 9 190 22 64 160 65 150 64 76 186 100 149 70 164 84 199 182 85 41 170 82 199 82 165 101 85 71 51 57 158 204 53 151 164 94 29 33 75 161 230 64 28 207 87 70 33 116 89 92 87 110 22 240 77 23 61 17 68 4 43 24 103 128 146 26 69 16 24 144 10 197 40 168 128 140 14 195 72 34 67 198 146 113 34 18 109 53 115 212 214 28 85 131 86 164 157 106 52 175 141 197 58 107 209 233 88 140 141 49 142 33 54 241 219 179 132 141 123 8 129 81 176 90 161 178 96 6 168 162 217 247 76 135 34 237 251 100 152 124 5 39 105 94 104 132 124 146 150 245 185 226 6 22 65 75 168 226 10 116 32 64 21 104 135 36 190 162 78 11 202 175 24 173 66 165 68 91 37 170 164 96 137 196 83 4 120 253 251 230 88 146 208 85 112 132 164 82 33 176 165 14 25 114 1 116 0 104 229 50 57 86 200 209 150 194 128 73 27 75 198 48 85 132 91 29 8 28 31 240 3 229 5 190 86 176 78 36 240 149 210 85 11 93 21 194 64 190 42 69 170 168 12 145 190 142 229 75 8 32 213 51 93 44 21 0 3 90 161 3 144 128 89 63 123 252 173 235 59 214 236 187 170 73 210 200 23 46 30 125 1 155 238 217 139 171 145 139 118 4 104 5 172 241 129 198 249 147 203 214 88 179 99 95 21 94 33 56 183 2 221 246 85 101 11 139 139 124 118 110 233 183 55 13 250 255 62 125 175 19 118 240 230 107 47 1 0 74 229 10 218 237 54 206 178 93 86 246 122 91 154 35 62 101 62 213 245 235 51 88 183 225 110 92 107 217 76 139 1 185 197 41 49 150 182 77 181 192 135 108 231 145 247 221 187 125 215 23 95 58 254 45 139 48 242 28 95 218 18 40 4 101 241 43 86 91 10 93 205 198 35 165 61 87 201 1 228 154 50 56 190 14 243 65 22 194 200 185 7 41 24 8 198 125 133 179 141 130 99 128 179 215 154 199 69 200 136 53 14 147 176 203 32 66 201 130 218 0 71 36 78 73 9 140 238 24 24 199 144 249 200 195 251 15 14 26 117 159 130 125 64 65 214 66 164 202 34 101 18 40 144 68 68 212 20 82 13 144 62 30 176 126 241 210 226 226 171 95 124 241 196 73 205 81 168 216 15 117 135 163 182 54 150 56 176 213 218 128 132 54 36 9 28 229 185 226 88 82 46 148 118 0 184 34 92 84 135 130 28 0 32 9 48 73 222 165 92 70 4 26 136 49 145 52 25 227 189 111 223 214 137 117 195 3 219 75 158 217 173 152 31 4 73 149 64 215 160 204 223 177 208 179 95 62 113 230 175 143 191 241 214 66 77 185 29 237 141 68 115 254 130 194 188 207 24 24 101 224 2 48 57 68 8 230 8 245 186 30 96 24 174 13 152 48 180 206 199 14 237 191 123 180 82 58 160 193 15 217 200 190 27 36 85 69 234 170 144 126 58 96 188 248 7 95 121 225 75 139 139 54 162 154 102 88 97 10 125 17 39 34 24 3 65 168 165 236 171 143 190 231 129 131 213 146 115 64 49 63 44 108 119 1 4 40 117 52 130 122 113 174 29 190 246 71 223 120 245 149 184 87 14 28 102 130 227 208 3 123 55 78 108 27 29 188 167 236 170 253 138 249 62 2 15 137 72 21 2 67 138 154 32 154 21 82 167 67 81 47 204 52 90 175 126 250 133 99 71 209 9 216 120 138 209 1 68 185 20 149 140 214 20 185 10 166 164 148 174 64 169 154 21 41 3 249 209 239 250 182 66 200 1 111 87 201 244 18 131 60 69 122 64 72 58 16 43 32 69 65 39 114 143 78 207 61 181 119 221 224 143 167 207 133 61 107 44 88 97 141 133 100 62 247 251 95 125 249 107 43 76 245 138 244 109 221 89 248 133 111 157 60 249 11 239 185 247 235 14 236 187 122 63 107 45 45 246 45 179 20 74 251 211 207 191 113 233 39 31 218 182 110 192 161 236 64 140 31 204 67 164 90 24 207 56 100 144 110 72 18 102 90 17 234 67 35 152 155 189 158 61 51 81 115 247 105 230 163 17 75 20 137 192 141 188 16 26 176 68 154 225 187 112 93 247 199 30 188 251 32 108 167 144 63 48 15 31 128 237 122 206 73 124 34 179 154 73 64 139 215 243 69 16 194 124 253 171 71 78 77 27 29 25 182 202 141 0 136 130 129 177 12 235 19 124 79 25 134 249 185 247 236 251 161 146 131 131 100 249 157 64 184 6 220 173 2 200 89 57 128 17 17 31 98 71 1 187 197 3 126 112 115 89 225 147 239 221 243 138 21 253 252 66 135 95 250 253 175 190 246 172 230 40 84 74 69 100 35 134 34 136 27 81 100 92 199 176 184 10 226 9 200 237 93 225 146 175 49 231 249 100 66 216 15 13 8 3 177 142 97 247 159 62 178 247 157 195 62 253 44 0 128 163 172 140 64 38 97 59 31 33 224 35 31 220 190 241 236 67 83 155 254 197 31 60 245 245 151 58 139 97 167 230 149 66 93 30 176 115 58 98 192 5 90 160 65 175 170 88 185 58 114 172 227 66 220 127 254 163 239 250 9 68 193 111 34 10 186 184 44 0 139 93 15 216 143 184 192 71 126 225 177 131 63 127 246 198 226 111 124 246 27 175 190 78 26 12 81 66 226 2 42 84 80 37 245 201 15 62 248 115 154 195 79 34 234 160 27 233 16 128 249 1 13 60 48 226 2 159 120 207 125 127 242 191 127 237 216 127 2 128 15 191 123 207 161 154 171 118 105 219 249 0 40 82 105 197 210 237 55 68 164 14 65 29 176 91 28 224 177 201 138 194 175 60 118 223 23 46 47 180 62 243 103 223 56 118 20 38 4 177 34 192 106 40 227 144 130 15 173 43 31 58 184 227 208 80 197 236 6 138 139 49 155 107 201 13 126 50 233 148 139 73 165 84 119 249 29 159 120 116 231 61 45 43 231 103 151 130 11 127 241 252 177 195 36 226 124 253 245 179 115 91 198 246 156 173 185 180 169 119 186 86 90 99 22 250 200 239 253 245 203 191 215 247 195 91 208 173 129 160 57 65 189 157 5 128 102 200 39 134 28 44 3 130 149 40 100 68 2 142 102 22 163 185 129 186 147 1 193 244 217 83 80 27 247 33 142 97 73 102 166 75 94 75 19 97 100 114 83 1 8 124 141 131 214 168 207 104 214 145 5 32 136 52 180 22 97 209 198 68 30 137 41 13 249 206 189 144 32 43 179 102 124 45 230 218 220 5 157 212 10 17 128 19 48 112 21 225 226 169 83 133 182 55 58 242 58 132 12 131 92 54 194 218 58 154 28 101 69 20 65 179 254 177 119 236 222 189 118 192 249 5 226 240 129 62 67 181 106 18 27 237 87 136 246 215 13 62 241 203 31 216 255 187 115 173 206 75 255 247 211 135 95 140 184 19 65 197 218 194 0 218 146 184 66 82 50 204 30 250 184 6 5 224 89 142 9 203 136 133 234 164 201 253 249 71 247 255 112 73 203 125 125 30 41 242 151 104 211 128 198 159 127 242 253 143 254 15 255 203 103 159 249 63 59 161 213 226 180 194 154 97 198 82 93 80 14 41 34 87 179 233 56 46 251 222 175 254 240 3 191 105 195 224 199 110 197 151 57 218 181 161 238 253 225 79 191 239 254 127 253 251 95 249 214 151 73 197 121 170 162 28 245 169 15 222 255 36 113 120 75 121 115 17 253 196 199 31 221 185 195 10 22 60 68 143 164 177 167 219 33 197 157 31 156 172 234 31 252 149 15 220 251 202 145 75 179 255 225 171 71 222 156 214 66 70 4 70 137 46 253 204 35 123 63 90 209 246 241 126 235 2 144 162 181 73 9 40 100 225 154 62 49 26 226 106 217 224 158 242 128 123 207 79 63 186 127 234 255 250 218 171 95 3 179 63 215 234 204 215 220 21 92 158 62 100 89 22 161 84 28 27 0 226 187 63 86 219 231 85 61 53 208 38 248 33 193 181 4 173 233 208 174 173 27 135 28 249 249 85 183 16 192 160 71 213 199 118 111 169 156 187 62 95 136 194 181 150 22 177 214 143 7 45 139 134 166 219 35 153 73 37 88 210 197 83 181 202 118 30 254 224 189 59 246 42 166 178 22 227 49 28 143 173 245 53 57 37 11 83 98 232 146 11 91 72 182 25 88 179 14 0 231 204 231 52 5 183 107 198 141 187 140 48 234 228 107 106 190 120 230 210 171 194 236 8 200 85 36 37 165 85 153 4 181 251 182 110 216 244 169 15 190 227 127 154 172 226 247 136 139 1 201 183 75 218 6 31 31 113 229 119 63 254 3 7 126 137 200 25 84 226 212 20 153 170 37 93 85 138 42 4 41 177 86 37 1 45 11 22 102 63 153 165 154 219 26 233 67 4 25 122 100 231 230 189 171 1 129 2 69 237 255 254 192 206 13 107 29 133 146 19 121 126 36 202 139 74 214 143 34 207 119 34 227 59 29 191 244 115 239 59 248 184 13 59 183 4 129 60 213 28 252 55 15 239 218 178 79 180 30 21 173 71 63 252 238 253 31 34 89 110 125 174 68 70 162 253 30 162 71 110 171 47 125 136 36 218 191 103 162 246 59 63 253 200 254 159 18 82 163 74 235 177 159 127 239 222 79 197 32 176 82 153 248 183 244 254 125 51 139 44 71 85 23 119 125 236 209 189 239 223 189 101 221 186 13 131 222 222 219 105 175 171 248 129 31 127 120 215 59 69 152 96 45 1 203 79 162 47 207 205 136 233 230 22 193 204 76 178 79 59 10 128 33 161 85 174 163 105 203 88 237 129 94 52 92 191 105 10 102 104 2 77 75 40 43 192 9 155 56 125 252 48 36 151 118 176 109 216 91 127 250 234 220 145 249 14 110 12 186 200 242 135 237 194 53 144 25 65 175 37 144 182 152 32 184 222 182 24 26 30 197 236 141 107 25 191 137 170 191 143 33 175 179 2 105 195 33 172 35 12 24 5 237 253 227 7 183 221 175 36 42 12 228 28 60 64 108 54 59 89 242 82 174 222 214 245 124 178 9 176 196 234 165 55 47 93 111 10 137 163 172 21 34 109 160 148 252 228 35 123 222 83 119 241 47 96 195 190 67 103 140 131 137 201 245 240 235 35 176 228 34 2 33 144 56 55 194 213 2 151 0 3 1 133 75 152 159 185 140 107 51 87 250 242 113 36 248 248 47 191 255 222 125 95 58 246 214 255 124 250 226 141 6 200 42 18 50 68 202 39 150 138 64 138 97 232 36 227 172 107 77 229 222 95 129 6 43 229 145 123 214 212 30 207 75 41 145 194 212 221 123 208 113 171 104 89 160 98 4 178 112 13 231 78 159 44 148 125 112 235 228 47 61 255 250 244 191 22 180 181 27 57 17 148 17 113 2 101 5 230 157 251 54 78 150 53 255 219 188 240 43 165 177 229 158 61 232 152 50 218 22 168 104 65 52 119 5 23 206 158 46 240 221 60 54 248 232 179 138 254 102 255 212 228 216 104 197 252 74 254 51 215 245 176 113 199 94 44 146 3 17 160 66 29 92 59 119 10 243 115 179 43 246 209 247 75 152 220 52 5 120 85 68 164 209 102 192 50 80 50 128 3 134 138 2 92 187 240 22 230 231 151 243 24 116 233 39 126 246 208 190 169 249 86 116 193 55 178 12 240 137 8 213 106 13 165 74 21 115 121 173 2 202 25 36 12 8 65 187 62 70 146 67 117 150 25 141 133 121 216 98 190 10 42 14 77 110 155 168 7 232 161 245 155 166 160 235 227 88 140 40 110 119 167 137 51 175 31 70 62 159 107 212 163 255 234 161 237 155 159 127 230 205 51 179 48 22 245 27 101 154 11 102 105 165 88 106 74 171 139 17 132 45 18 40 130 87 194 125 219 38 198 124 226 159 204 127 124 215 61 123 113 46 42 131 22 5 66 140 5 0 34 101 108 216 247 32 206 191 242 108 119 251 132 160 238 153 28 174 220 104 117 102 7 93 55 3 130 139 103 79 163 178 125 20 237 72 186 246 172 16 36 205 45 72 104 120 237 198 2 16 184 90 246 17 169 207 19 43 69 34 33 20 64 66 90 41 120 67 37 119 95 53 32 238 175 0 0 32 0 73 68 65 84 118 25 10 128 53 19 147 152 107 199 224 149 42 201 222 0 218 160 167 112 233 141 243 133 174 223 88 10 207 136 88 67 34 30 147 81 32 145 127 246 216 189 31 241 41 250 145 126 67 181 118 221 70 184 99 235 112 181 5 92 101 129 180 0 160 103 239 30 146 109 3 17 74 144 250 22 212 199 238 194 136 9 113 229 244 235 104 54 139 91 151 74 162 7 62 184 107 243 111 157 94 51 242 187 95 124 229 245 147 32 165 89 224 145 112 5 44 170 191 233 155 140 122 42 137 41 62 244 1 132 251 183 174 221 102 148 20 34 178 27 247 62 128 115 139 28 35 23 128 249 0 128 26 198 93 187 15 224 212 145 111 102 207 145 13 127 234 71 30 188 231 11 95 124 254 149 227 145 162 8 38 98 68 70 105 101 221 221 107 215 60 2 177 153 90 34 34 76 238 126 0 231 90 12 116 98 135 110 22 10 228 140 97 234 158 42 78 231 18 199 6 93 253 248 134 241 161 55 55 143 213 179 221 41 0 80 202 160 190 227 0 206 182 45 128 120 1 93 135 194 224 186 157 168 68 175 97 177 103 236 134 71 70 49 184 126 27 46 181 4 231 173 0 45 1 36 202 76 245 133 54 0 69 16 113 65 99 219 176 97 179 129 189 126 113 217 97 185 138 145 119 72 201 169 230 231 210 243 125 172 223 190 23 23 218 10 109 102 92 18 2 192 16 78 183 106 57 182 215 24 16 21 207 193 217 200 7 213 167 146 188 25 130 30 21 172 47 107 204 158 57 142 133 92 244 127 77 217 41 196 6 166 238 217 139 243 161 15 44 90 8 128 185 14 129 216 199 250 61 15 226 194 107 207 101 107 12 16 119 231 150 137 251 190 113 242 205 147 18 146 66 93 128 43 235 17 231 114 60 181 108 238 179 113 93 241 147 20 200 90 13 66 24 144 24 82 18 145 218 190 110 205 221 64 247 246 155 74 181 134 75 82 73 55 72 114 129 41 193 165 69 139 205 59 118 22 152 14 149 156 218 179 39 167 207 71 66 237 244 61 107 35 140 185 81 86 158 50 223 61 111 79 9 154 186 84 224 101 36 60 248 129 123 239 218 175 72 85 148 210 21 86 186 66 70 85 33 82 243 136 247 229 159 173 141 77 38 92 82 190 73 70 100 46 202 94 71 59 55 160 64 8 117 230 47 95 58 126 88 177 56 2 114 73 113 249 231 222 115 239 135 251 129 192 154 137 73 108 216 247 16 174 149 39 48 221 20 68 204 9 39 70 193 81 79 234 79 235 225 164 254 197 208 226 220 146 130 157 220 141 187 246 28 132 95 42 154 117 196 209 250 45 35 213 79 30 184 107 243 221 16 170 3 24 4 84 85 168 207 28 138 0 194 9 115 78 188 132 180 29 203 129 96 180 236 173 201 255 189 97 203 86 92 92 202 61 159 184 81 2 193 133 192 193 208 240 104 161 252 196 128 127 192 146 41 105 199 241 180 214 190 214 218 103 79 249 190 67 133 68 174 205 219 238 198 149 86 148 155 87 202 198 226 138 148 81 174 116 177 72 145 148 119 76 174 217 61 80 118 119 244 242 152 93 138 121 100 199 68 24 152 11 66 172 153 218 149 127 20 83 119 239 70 107 100 43 206 55 45 34 150 188 55 8 112 119 199 58 78 41 137 103 228 82 51 194 181 210 56 238 218 185 31 212 131 176 21 45 5 80 90 187 99 63 206 46 1 108 227 185 22 202 103 0 74 87 167 1 32 70 44 216 156 73 97 178 91 8 76 55 45 42 155 138 135 220 148 234 206 107 165 90 195 101 91 138 167 85 98 190 196 49 143 203 139 17 54 111 47 150 125 243 244 217 251 192 154 224 70 113 2 85 70 79 98 37 234 11 4 93 63 226 16 16 44 82 189 90 38 68 46 65 65 189 120 228 248 254 78 216 53 101 214 172 93 143 208 118 143 28 245 10 155 245 139 153 129 21 135 234 115 205 214 210 124 135 11 182 112 243 234 197 68 128 211 9 206 205 114 194 239 70 203 102 102 85 74 163 181 242 110 40 212 172 66 141 4 53 136 212 62 112 96 199 253 26 182 32 64 115 54 222 180 150 172 14 201 213 17 191 190 118 225 76 129 119 51 144 55 193 162 133 224 40 130 255 254 123 239 217 87 209 252 161 222 241 154 186 123 15 230 107 27 112 121 209 2 76 16 73 64 64 24 34 212 237 143 112 146 160 157 188 199 12 34 206 163 57 34 177 56 215 82 168 108 217 135 209 158 59 4 20 236 196 193 77 195 31 85 74 215 149 162 65 69 52 32 34 69 171 46 169 43 75 109 149 110 14 129 176 100 199 196 243 84 117 85 225 18 6 83 27 6 37 161 20 36 167 221 210 197 98 133 49 60 177 174 80 222 119 212 1 77 202 103 66 137 109 252 91 193 148 148 240 59 242 207 89 191 158 76 103 178 32 56 206 201 39 1 58 33 99 77 15 223 225 170 55 85 210 178 33 255 30 251 213 12 187 41 145 149 20 95 231 18 177 36 82 216 188 247 65 156 11 203 136 108 60 190 241 22 170 100 67 148 92 107 85 0 185 212 106 18 22 156 13 28 108 222 91 192 49 16 117 199 90 107 131 75 139 28 159 152 69 94 102 187 202 38 185 22 8 130 226 107 65 92 71 190 236 213 37 139 90 173 144 150 144 209 154 181 235 208 177 221 120 86 10 46 233 223 214 143 203 117 194 8 95 120 230 101 124 229 133 151 31 132 34 5 235 196 183 132 143 246 73 111 239 161 155 7 11 27 211 148 38 102 139 23 146 163 160 14 159 60 51 245 135 95 126 26 211 51 177 47 165 188 18 192 137 212 164 199 144 185 251 122 49 44 74 158 134 24 81 104 93 107 6 151 243 239 95 185 116 17 131 126 58 206 185 137 201 146 140 98 193 169 79 172 47 240 43 105 217 13 210 3 154 104 64 27 26 32 50 3 99 21 175 160 26 198 215 174 195 124 199 66 164 123 200 41 27 153 68 200 215 148 52 230 230 110 20 120 95 94 104 159 19 64 41 192 93 59 84 31 216 58 236 125 52 255 57 145 194 212 222 251 227 163 212 156 30 88 138 247 236 137 211 246 115 23 224 40 214 22 25 24 145 196 154 41 89 164 121 67 104 46 176 88 26 222 140 13 91 238 42 180 201 33 185 235 99 143 238 250 24 136 234 12 170 137 44 15 22 166 124 57 249 151 229 162 173 32 14 26 69 48 233 64 131 243 194 156 242 69 210 86 237 22 202 19 243 6 214 202 83 34 158 22 120 10 218 19 17 79 68 10 146 221 202 109 223 165 203 143 89 226 223 16 104 175 104 241 149 140 26 34 161 66 78 110 192 73 252 40 85 174 72 183 229 4 141 192 162 82 173 97 203 158 131 184 144 152 208 153 143 46 241 81 108 145 84 91 75 23 7 178 54 73 102 25 136 0 231 23 101 217 113 244 148 152 57 158 231 180 13 57 235 50 139 119 231 153 23 20 100 50 162 217 199 2 5 65 39 204 7 169 187 164 220 114 65 103 49 210 35 251 49 143 102 4 76 207 204 226 15 191 252 52 78 158 155 134 64 234 98 74 4 55 201 160 12 110 146 130 157 214 177 242 71 79 198 191 70 23 73 66 159 74 157 216 53 80 194 35 243 205 37 252 233 223 62 131 175 126 243 40 34 73 89 164 189 74 80 46 57 247 218 182 61 42 136 160 8 210 254 219 35 111 189 217 178 84 136 204 13 242 82 214 65 74 204 32 32 253 155 33 36 104 20 229 2 46 241 142 247 238 185 107 95 108 46 235 1 104 12 148 12 10 214 64 117 116 45 32 221 163 184 2 73 20 93 162 41 32 112 131 98 118 86 155 213 137 167 14 159 58 15 192 8 139 243 216 158 77 143 17 138 87 80 77 237 186 15 231 22 227 54 102 134 116 210 126 70 60 97 233 200 100 70 129 72 102 58 198 233 167 233 18 139 219 194 153 160 2 157 72 112 85 141 96 98 178 8 126 101 141 29 15 239 220 180 67 129 235 4 46 204 97 182 88 147 197 18 123 173 73 91 82 109 220 67 170 199 189 232 228 14 45 37 89 242 89 59 25 130 136 138 241 73 34 25 84 18 231 53 48 145 43 32 87 137 246 0 41 32 198 82 196 217 98 76 219 215 173 7 16 221 147 126 75 82 238 141 113 199 214 103 166 27 187 115 153 48 27 155 186 7 103 155 177 31 79 169 21 134 108 80 178 121 128 228 121 20 199 47 117 109 69 4 151 169 214 87 83 139 48 38 253 244 30 13 228 198 40 225 146 151 221 140 49 50 160 232 42 162 248 215 186 50 33 104 183 209 143 68 245 174 177 238 235 208 50 254 230 141 107 248 211 191 125 6 243 205 165 116 44 141 19 117 148 216 136 164 220 33 96 60 57 12 183 242 157 4 171 218 62 148 40 241 51 92 23 121 181 242 234 27 111 225 203 199 46 226 232 204 98 206 24 136 27 152 9 99 63 126 140 182 176 109 45 116 162 139 249 247 103 46 158 205 208 61 51 151 211 5 156 188 190 209 138 150 93 187 53 86 243 118 64 59 3 80 84 127 124 207 214 251 12 108 118 34 143 64 184 17 197 10 47 187 175 71 82 1 143 249 106 165 48 221 19 181 158 105 134 39 88 129 4 162 31 191 119 251 221 3 142 20 142 49 111 156 218 134 179 173 92 222 119 170 229 227 63 10 39 197 42 142 194 250 10 97 179 31 97 163 23 96 93 89 97 192 211 57 55 37 110 8 165 2 154 10 12 4 17 4 173 129 245 168 84 139 87 83 109 31 171 189 131 149 174 65 104 89 192 151 211 142 81 202 59 237 185 100 11 230 102 148 142 117 106 182 146 72 81 152 251 149 33 113 68 147 17 165 28 165 196 17 213 39 16 45 57 6 146 166 139 165 99 16 3 99 158 40 14 181 245 141 129 116 23 92 247 183 136 224 124 147 147 113 204 201 16 3 46 17 70 75 26 19 21 3 95 247 204 27 75 206 138 149 2 223 78 196 24 91 191 165 111 159 207 30 123 5 27 253 16 195 190 134 81 73 52 48 7 180 93 168 202 52 80 86 167 209 64 205 37 172 173 104 108 116 22 113 246 200 75 253 7 54 237 94 206 213 136 227 62 130 227 151 27 248 79 223 186 136 163 87 26 203 203 40 82 96 135 208 243 5 66 43 209 173 119 13 130 22 73 197 33 38 95 145 90 62 41 173 142 197 115 111 94 195 107 211 243 120 104 211 16 54 12 250 113 16 36 235 67 111 196 28 16 145 128 64 246 242 124 235 220 120 169 154 249 145 11 243 179 88 191 209 224 210 98 148 77 4 17 37 102 106 252 12 1 168 175 153 196 245 220 118 91 205 213 155 25 56 12 40 140 84 189 130 45 189 102 237 36 174 119 108 55 136 67 169 127 216 229 55 81 18 188 21 228 208 88 192 167 175 222 184 144 100 57 233 177 170 87 184 205 163 82 173 97 70 15 65 108 175 70 145 84 209 3 66 240 29 194 56 150 112 254 205 19 120 43 90 190 205 88 169 84 49 114 215 110 76 55 211 219 132 114 185 19 57 198 205 78 132 181 91 118 97 241 240 115 89 89 95 201 232 131 91 215 109 234 23 44 76 65 184 0 195 73 167 87 129 3 200 86 124 186 160 8 241 34 89 97 43 82 4 74 88 57 154 99 43 95 0 45 44 78 95 182 133 23 9 80 245 170 199 140 111 150 188 223 135 73 55 239 36 206 216 236 2 137 116 135 17 35 101 3 111 113 6 23 222 60 93 56 25 56 48 56 132 209 141 119 225 108 83 146 61 228 244 212 91 130 161 233 14 11 1 139 170 232 178 164 100 109 132 211 199 94 205 254 30 29 155 192 141 106 108 189 101 110 65 238 120 187 64 176 1 13 156 61 115 18 22 64 27 192 202 39 113 114 61 206 92 202 248 239 243 179 45 124 253 173 57 92 109 6 32 0 3 126 63 204 85 4 219 137 7 164 179 244 118 92 131 163 241 247 173 97 28 241 217 89 31 253 14 50 196 193 21 198 213 70 128 207 28 185 138 63 123 237 18 206 207 182 186 8 216 71 240 68 208 22 72 235 233 227 231 78 183 45 189 145 255 204 180 231 208 45 72 153 155 144 103 54 47 197 77 81 143 236 250 71 118 110 188 71 145 26 168 58 84 56 159 95 25 158 64 186 207 26 203 117 17 153 5 130 104 110 166 192 175 105 233 200 177 11 87 111 64 136 30 218 190 121 125 221 163 66 50 203 248 230 109 89 240 166 240 211 149 81 84 29 5 255 250 25 156 62 113 4 97 31 16 0 128 197 197 38 206 191 246 60 54 250 97 214 158 126 236 128 56 154 189 118 93 241 234 129 109 163 213 141 16 233 19 35 72 115 155 99 70 2 244 100 83 230 105 185 140 136 80 6 2 41 159 226 20 244 50 33 104 130 18 136 22 136 6 105 5 244 28 179 3 186 219 193 249 159 140 111 95 65 89 158 53 153 130 147 228 44 59 74 135 46 167 125 33 216 84 37 204 28 125 30 231 223 58 213 181 14 18 90 152 159 197 233 195 47 97 83 25 0 167 254 118 10 159 177 149 144 54 235 218 82 136 129 193 161 229 237 91 222 224 204 194 232 6 49 187 174 195 106 169 195 82 188 143 40 9 51 157 155 107 225 207 94 157 198 255 115 248 18 102 154 109 100 61 150 229 202 22 142 11 248 126 124 88 48 165 155 220 82 180 186 204 194 168 19 103 21 198 64 80 44 147 118 58 73 165 156 110 182 241 153 163 151 241 39 175 93 194 201 107 205 196 231 237 37 106 9 164 69 194 75 243 109 46 216 228 151 206 157 134 147 30 163 201 252 44 201 254 20 8 102 91 209 178 187 16 39 6 74 235 222 179 107 243 14 87 73 150 159 64 32 92 183 6 5 41 22 116 109 112 196 11 246 226 249 226 158 241 108 59 122 139 19 83 102 114 164 84 88 125 165 82 25 211 109 93 0 149 174 197 27 255 161 9 208 51 167 112 253 90 17 96 250 145 64 112 250 216 43 216 228 117 178 54 166 70 109 10 128 169 207 170 235 197 251 6 107 174 12 11 21 131 133 177 64 83 198 167 11 46 146 227 124 115 162 158 16 97 87 159 117 231 162 79 63 18 16 72 0 161 239 182 102 151 99 151 87 174 85 203 241 165 111 77 153 21 144 182 133 37 23 180 139 217 108 172 16 206 28 126 233 150 253 61 115 236 91 40 187 42 43 155 62 158 46 226 116 33 215 123 118 171 86 162 212 234 76 185 72 78 46 86 3 7 167 110 4 175 145 168 108 101 51 11 206 207 54 241 39 175 78 227 51 135 47 97 122 62 72 186 44 9 64 72 215 250 200 19 91 2 71 4 223 139 239 124 216 185 252 145 60 173 14 8 128 56 111 89 235 254 38 70 34 55 66 22 9 152 226 234 66 27 95 124 125 6 127 244 242 69 124 243 245 211 104 5 185 136 40 113 64 214 182 133 101 233 200 197 107 175 138 80 182 31 25 4 1 38 74 200 4 55 211 140 146 51 215 32 24 24 45 46 138 170 163 198 71 170 94 1 29 214 172 157 68 35 176 185 69 43 217 235 84 8 71 76 84 64 212 72 212 229 207 191 120 242 21 136 101 144 200 160 167 11 64 176 118 243 86 116 226 143 10 113 144 60 88 173 247 25 55 114 137 79 41 117 96 206 181 197 121 195 138 90 232 253 236 236 201 99 168 186 42 39 40 73 80 141 187 102 225 244 98 132 209 209 53 197 130 92 212 154 36 221 248 68 87 254 86 48 51 86 160 204 77 206 105 236 244 101 97 1 22 42 38 5 69 4 130 2 89 133 126 64 192 221 152 3 16 111 231 117 227 35 203 121 202 10 242 153 118 41 222 183 239 2 86 218 78 95 19 166 223 56 178 108 217 137 80 196 80 157 226 123 130 81 39 86 185 66 121 197 147 47 43 208 78 113 167 228 70 128 206 217 6 55 251 181 45 31 40 44 180 161 207 176 89 161 78 51 164 115 23 22 194 151 190 122 242 242 231 255 243 203 111 30 103 8 183 130 14 190 249 250 105 252 31 159 255 42 158 63 125 21 87 230 91 221 224 103 46 224 10 72 95 101 27 2 16 155 88 240 65 114 93 217 77 104 229 24 65 118 39 220 18 193 235 239 35 33 233 180 128 227 132 137 44 133 13 224 36 179 170 209 142 240 244 43 199 241 204 107 39 176 117 253 4 246 108 221 4 17 180 65 42 4 216 190 126 238 242 165 7 167 198 191 89 201 165 110 134 243 51 16 61 146 140 93 58 168 137 185 154 116 103 150 139 46 104 89 203 0 145 50 249 209 174 12 143 99 102 81 226 45 189 116 239 62 65 236 84 103 206 95 41 102 18 54 58 246 77 22 27 129 73 160 88 123 138 54 228 121 6 170 4 72 152 184 163 148 109 55 165 228 106 194 244 169 163 5 158 129 152 179 127 117 100 250 79 175 204 55 22 1 197 0 235 15 63 184 253 61 67 198 102 249 240 214 70 24 70 11 13 184 232 58 185 105 43 187 115 56 48 58 142 107 215 174 230 184 23 143 18 101 235 62 41 31 187 168 169 102 162 190 107 184 31 101 49 139 76 163 197 239 199 1 171 62 50 37 68 16 73 226 138 138 64 182 207 34 206 105 197 12 224 37 87 205 106 81 170 187 240 99 96 98 228 207 166 76 152 16 167 131 98 4 126 54 210 39 62 255 218 217 87 26 237 136 63 252 142 173 7 135 157 40 75 14 10 155 55 0 170 163 112 31 70 33 110 65 160 30 79 199 85 192 220 98 59 218 84 235 201 231 239 154 114 73 251 210 12 210 76 101 20 219 21 200 27 127 242 220 177 231 72 216 130 25 162 180 254 202 75 71 248 205 179 231 97 147 219 164 4 73 136 70 4 80 113 121 98 21 187 128 66 232 59 106 204 171 10 18 166 180 106 139 0 0 68 250 196 8 114 19 203 169 105 144 36 201 80 186 95 135 56 175 250 196 185 105 252 217 87 158 5 177 4 100 109 155 4 109 33 89 154 111 135 175 231 121 78 159 63 135 170 163 242 208 31 207 120 106 17 136 96 190 29 97 172 199 61 40 41 238 166 179 130 112 61 212 72 37 174 48 88 18 47 142 177 146 89 102 190 95 107 6 167 137 57 34 136 189 127 235 134 53 148 203 162 116 140 131 153 86 247 104 110 113 145 10 132 5 99 190 66 187 103 27 232 153 51 215 255 236 202 236 220 85 142 236 44 219 104 14 204 243 127 252 236 137 47 94 237 152 47 230 159 187 112 234 4 202 58 141 62 103 149 100 125 134 8 58 61 217 149 90 45 247 163 243 42 93 10 25 68 253 119 113 86 44 143 174 214 73 223 39 201 253 157 47 66 86 65 169 174 69 32 203 111 13 146 220 139 2 155 254 44 87 104 27 18 11 34 110 79 55 172 210 189 18 255 198 229 11 133 34 243 145 62 254 199 207 157 248 187 249 102 235 6 172 93 184 209 10 10 187 85 173 102 35 177 24 227 140 134 204 194 19 78 134 157 243 200 0 32 213 71 203 157 115 1 103 211 213 29 191 124 150 105 145 20 33 4 243 146 88 187 36 34 75 96 219 58 113 246 34 219 222 43 229 146 220 26 22 73 210 118 36 227 73 189 91 244 223 6 221 22 16 244 39 137 211 29 147 222 51 51 132 5 196 156 220 193 190 188 243 12 233 48 73 91 36 106 139 72 251 179 47 157 248 198 220 82 39 251 150 6 17 198 168 137 80 144 148 36 8 147 87 39 181 30 247 32 79 227 147 235 208 232 228 51 88 186 139 35 21 152 114 84 60 215 221 97 117 252 175 95 125 227 40 67 66 22 68 27 71 7 11 169 110 99 19 107 17 101 59 5 249 73 238 254 101 194 226 86 206 18 155 87 142 157 191 114 193 178 93 128 68 13 68 65 195 114 184 0 230 133 115 215 23 142 231 159 13 163 16 117 47 31 249 238 106 132 52 0 120 181 21 21 174 187 50 203 118 114 82 255 155 146 188 86 201 132 249 118 130 86 146 69 224 114 229 111 86 90 20 129 19 0 16 69 253 205 6 36 192 212 13 180 198 255 210 148 162 213 180 77 178 182 36 186 18 25 112 138 192 81 180 236 240 209 155 51 11 135 173 181 77 88 219 180 28 45 190 53 179 80 248 70 144 86 171 213 213 213 137 223 221 29 169 244 92 72 177 59 138 210 231 150 53 15 93 57 67 2 158 217 7 217 251 243 205 37 188 116 252 20 254 230 133 215 66 130 180 8 212 138 127 163 181 108 209 164 9 123 41 47 17 8 44 136 227 52 242 254 35 125 123 116 27 23 147 248 232 135 104 72 17 19 0 165 215 178 136 2 136 227 75 27 251 140 21 17 5 36 210 33 81 33 44 33 66 100 127 255 63 63 243 202 168 175 55 110 219 176 22 83 235 214 96 116 230 34 164 188 14 153 47 64 93 243 138 16 215 147 230 7 244 163 210 208 26 96 49 94 16 249 156 239 244 4 136 38 224 242 249 183 10 101 174 183 195 163 194 232 144 40 6 65 85 125 51 154 239 179 91 42 67 58 169 73 154 134 207 226 224 90 98 72 163 49 91 204 78 108 132 209 73 97 219 84 54 108 49 208 1 177 72 68 70 148 68 47 156 188 112 234 222 201 157 23 180 68 89 198 144 3 206 9 34 37 50 65 72 175 188 9 173 160 90 169 160 209 88 22 102 200 230 131 18 127 55 238 123 94 221 50 122 15 43 174 76 89 70 8 210 224 92 247 50 151 222 73 101 21 187 5 90 145 88 8 148 90 166 66 145 44 156 52 46 144 152 207 153 21 189 74 97 150 164 73 169 75 145 255 64 40 206 217 152 205 1 138 8 248 217 147 23 78 43 230 14 139 21 176 166 51 151 174 89 220 213 221 5 104 181 90 133 109 85 73 100 183 219 253 94 147 50 253 136 162 229 239 230 27 148 190 138 125 159 153 102 128 198 194 12 62 251 165 167 49 51 23 207 159 242 170 172 107 245 14 56 190 79 143 52 226 188 243 222 62 39 167 23 179 89 200 226 92 212 103 62 110 159 190 173 27 138 242 20 139 89 188 15 203 18 47 83 192 118 183 101 251 108 92 51 35 34 166 128 72 34 32 130 134 178 98 220 99 51 115 179 63 50 51 183 128 103 14 159 64 245 107 47 226 208 143 127 28 70 27 108 24 242 225 232 204 55 64 26 244 155 15 66 172 25 95 139 171 61 95 39 69 68 184 214 81 16 137 173 138 180 85 93 207 155 177 182 98 112 190 85 180 8 206 95 107 188 65 34 109 48 3 90 41 135 80 200 226 81 218 41 14 122 154 173 150 226 31 9 90 75 197 157 159 83 87 23 94 39 230 128 5 109 70 212 129 37 209 10 134 57 2 41 50 86 112 77 231 47 216 182 1 186 25 191 57 139 40 55 223 158 95 90 25 8 144 91 84 194 221 197 155 115 171 122 158 94 94 62 39 196 105 40 93 114 62 120 127 34 13 136 138 47 18 21 45 160 254 136 147 213 79 93 141 74 183 33 204 153 117 151 96 65 234 54 38 150 143 211 91 43 81 36 214 182 33 54 16 203 12 18 213 22 91 92 104 194 112 53 37 91 194 105 55 37 247 26 253 112 13 43 141 71 218 175 208 10 46 204 182 112 230 198 18 78 207 54 209 108 91 60 224 93 203 64 0 0 132 16 1 210 33 136 133 74 48 183 135 45 229 130 219 224 24 220 57 145 233 88 46 222 198 109 56 9 189 109 32 64 226 22 196 129 12 138 183 114 84 44 52 44 210 247 18 23 18 14 73 164 67 108 67 144 18 86 162 181 95 123 145 131 165 151 16 6 7 1 160 185 212 198 252 229 115 248 250 188 15 77 10 227 21 23 27 134 75 88 63 88 194 218 1 31 70 197 3 81 25 30 7 122 128 96 98 237 122 92 238 228 192 90 36 23 127 75 204 230 197 162 249 216 182 234 249 23 78 156 61 67 194 97 2 224 198 144 84 242 207 72 106 146 103 90 34 21 200 4 169 133 208 106 21 129 224 196 197 107 87 152 109 164 56 138 72 36 2 91 97 210 66 32 77 108 163 182 197 37 87 99 127 250 188 109 183 1 164 213 230 132 47 213 128 66 112 189 98 154 117 161 141 197 255 146 192 151 116 173 231 85 104 94 234 89 8 241 176 101 225 195 190 38 188 128 141 2 91 86 34 32 173 64 188 76 182 210 195 88 4 100 7 5 110 238 14 100 79 47 239 95 126 139 46 247 94 111 22 147 8 34 98 105 9 208 33 18 142 15 145 169 101 166 109 215 200 136 25 101 224 158 50 238 11 84 197 247 34 203 56 55 187 136 115 179 45 92 156 95 194 165 70 16 187 66 233 160 171 101 69 226 90 89 98 95 154 137 160 216 162 199 244 142 177 47 9 12 38 237 2 113 146 232 5 244 73 183 184 109 122 251 64 144 106 104 161 196 151 33 176 229 120 247 72 113 255 1 84 20 178 165 144 68 119 0 22 109 173 98 109 64 218 253 166 36 64 0 0 199 191 249 12 244 214 199 16 177 197 244 66 11 151 154 45 60 199 128 67 132 241 65 31 235 235 37 52 198 171 240 173 20 118 54 189 250 24 164 105 19 204 76 39 50 109 43 80 50 26 211 103 139 185 3 141 208 30 35 145 54 83 124 81 159 2 88 160 188 60 146 197 71 67 108 119 191 57 219 200 72 226 3 10 8 123 46 148 92 92 106 135 36 96 203 96 138 131 39 2 75 66 202 8 136 165 221 137 230 6 114 241 191 48 108 67 116 165 251 77 54 169 28 165 202 83 4 218 220 196 188 151 212 6 202 45 219 188 21 189 10 205 219 77 197 78 180 182 74 172 62 198 77 128 68 57 66 96 97 17 104 104 18 181 44 179 144 147 19 135 241 186 74 58 69 212 61 87 210 203 188 239 218 139 29 50 226 120 69 100 99 147 31 164 34 69 34 18 66 108 135 37 22 76 213 247 49 201 230 49 214 188 121 110 203 1 9 0 88 192 23 174 92 199 249 171 215 113 225 234 117 84 70 39 112 162 186 43 142 40 164 215 152 231 215 104 62 165 117 25 179 190 85 116 63 76 251 151 238 82 9 117 221 153 183 239 25 220 2 8 142 1 184 85 30 133 72 12 0 148 238 171 39 199 94 137 33 86 192 78 159 96 33 73 68 36 17 145 13 33 194 44 164 148 181 128 235 29 65 187 27 108 187 54 115 21 7 30 114 241 173 75 241 23 53 72 114 242 44 20 224 194 220 34 46 206 181 240 252 153 235 216 221 185 132 27 23 207 98 98 100 8 107 71 135 192 235 34 104 221 221 176 201 212 90 66 227 158 197 153 220 173 48 22 250 234 87 143 159 122 90 88 150 20 96 65 80 12 37 66 104 228 203 145 216 100 79 63 230 74 12 64 37 190 56 1 97 196 208 218 20 110 156 169 87 124 111 118 161 169 64 162 1 178 32 18 33 40 81 66 36 154 202 142 30 205 131 141 227 249 201 215 91 37 22 34 197 230 32 148 100 194 18 133 253 51 21 1 32 61 214 155 221 167 223 227 214 175 46 32 199 137 236 37 229 211 179 244 201 80 246 178 16 129 18 34 135 88 160 32 34 172 20 180 44 187 19 39 74 183 10 243 22 71 218 162 85 7 188 82 235 38 177 200 186 72 16 227 74 79 227 136 136 129 40 20 225 144 132 24 96 197 253 114 28 208 205 73 232 215 24 1 176 208 108 225 242 141 57 92 185 49 143 203 115 139 184 22 128 131 217 238 33 218 173 195 227 49 58 40 64 165 253 178 136 227 101 43 240 77 252 34 141 212 74 97 104 244 4 241 227 56 57 35 254 2 199 52 234 211 253 70 165 190 153 133 183 73 183 109 17 244 138 81 220 168 238 177 80 82 12 74 206 26 172 176 195 9 48 34 34 68 145 141 66 130 178 70 17 49 89 209 218 59 17 105 239 43 200 125 79 161 153 189 0 193 112 226 39 81 55 104 40 4 161 88 235 15 108 216 142 195 175 188 140 139 51 55 176 247 190 119 224 175 190 246 6 60 79 99 188 82 194 120 205 139 127 6 124 84 93 3 64 176 120 189 120 45 88 135 241 220 204 204 194 156 8 2 17 102 16 41 101 132 69 122 82 193 217 38 102 88 174 95 76 153 38 33 0 165 82 169 112 195 208 174 141 227 235 190 126 180 177 160 148 14 89 66 1 27 214 2 195 10 46 136 28 87 163 176 245 161 29 31 232 160 152 142 139 100 112 147 60 128 78 208 255 148 90 126 62 138 150 208 109 82 170 153 115 101 243 86 197 114 48 33 67 144 146 16 105 40 37 32 168 141 99 35 133 147 154 158 235 33 176 73 155 114 87 121 197 66 67 43 240 93 169 125 72 186 150 186 100 200 89 25 189 196 32 70 36 140 8 34 204 68 138 148 244 113 91 186 221 37 0 205 32 196 149 70 27 151 23 2 92 109 182 48 85 178 248 234 231 191 210 45 160 93 214 149 158 111 225 74 187 82 216 178 141 115 77 56 249 221 107 145 9 139 129 210 38 77 223 23 210 102 25 94 72 42 243 200 226 33 196 177 126 200 44 143 183 73 183 1 4 109 0 110 255 143 132 145 98 94 106 82 197 129 140 62 234 3 0 9 89 107 37 34 50 17 69 18 69 81 68 198 184 98 29 82 202 113 94 225 28 16 188 242 252 55 80 59 248 163 104 4 177 54 230 228 10 51 74 3 97 194 120 99 209 5 65 65 192 168 173 219 6 185 28 162 29 68 56 27 44 226 236 141 102 166 29 171 190 193 129 117 53 180 14 255 29 70 6 170 24 30 172 97 184 86 193 108 155 95 99 177 45 98 233 144 22 22 171 21 91 43 34 152 201 79 10 135 29 64 186 254 121 106 70 102 219 117 16 148 203 149 2 16 172 31 174 108 19 165 78 131 173 16 180 33 205 194 164 149 40 237 1 228 107 37 195 133 5 167 12 144 236 28 164 49 226 94 185 104 183 90 55 153 39 233 10 98 22 68 163 236 110 198 213 81 178 42 40 9 180 74 113 243 44 90 158 171 98 136 180 15 69 6 2 6 148 90 83 175 22 82 32 93 207 67 0 116 221 157 244 53 144 221 242 187 154 0 70 90 78 114 152 146 186 49 233 73 198 94 98 144 141 45 79 203 128 6 65 101 38 88 20 89 220 104 44 98 169 220 192 133 185 22 174 53 219 184 210 236 96 177 29 198 223 233 152 180 117 221 218 126 75 101 185 90 20 182 93 124 83 57 112 146 116 171 180 167 143 4 37 86 60 16 162 56 34 203 206 114 167 63 190 183 33 125 77 210 13 78 11 250 156 203 202 211 98 242 211 255 206 147 140 86 6 130 79 163 251 69 144 64 140 3 203 207 147 33 141 68 231 12 180 120 32 192 80 172 86 48 91 216 2 18 81 36 17 17 71 20 127 25 42 107 107 149 248 131 79 35 88 250 25 8 15 3 64 16 180 113 96 68 225 27 151 194 236 20 98 118 73 159 0 44 132 171 141 54 118 237 221 135 227 71 94 195 241 249 56 151 65 41 36 209 212 212 183 2 154 173 16 60 63 131 23 143 189 153 27 1 247 69 93 95 243 12 35 106 145 178 33 89 97 33 104 173 148 44 118 236 49 215 67 118 45 89 123 169 9 49 94 50 9 177 141 155 222 123 152 90 63 149 250 48 112 181 107 46 86 29 189 131 160 191 193 36 154 128 80 68 49 148 210 196 218 255 129 123 183 237 209 194 147 249 145 9 69 1 98 123 50 219 210 46 8 74 142 194 210 10 247 218 103 243 129 116 29 231 156 72 145 85 71 231 243 34 91 224 145 216 62 81 207 53 71 4 40 33 170 0 42 76 162 10 122 109 189 92 184 68 161 92 173 162 145 235 71 172 41 115 124 87 185 107 144 105 70 233 222 251 136 100 81 164 220 138 164 24 196 66 42 189 165 69 8 34 252 217 175 189 132 27 11 13 44 44 182 32 34 168 60 60 142 133 54 103 160 36 169 171 64 137 11 216 167 125 210 103 63 93 128 204 149 74 131 249 197 157 179 101 214 148 67 74 149 88 16 169 56 233 218 65 239 205 212 105 127 9 113 240 145 82 101 168 178 75 74 222 46 125 7 182 15 99 45 173 208 181 29 211 126 51 184 127 68 83 192 4 178 68 28 117 66 142 72 89 113 60 97 37 142 178 74 95 35 237 126 85 162 118 118 5 246 194 217 215 1 179 57 73 81 160 24 29 187 177 38 48 3 131 27 182 97 143 113 240 114 179 19 71 250 88 146 172 83 6 139 74 44 86 224 141 151 159 43 52 133 140 251 162 2 181 192 186 77 44 33 69 86 196 211 202 90 145 207 62 127 248 88 37 108 98 160 82 198 96 181 132 161 115 151 49 188 231 17 248 142 66 197 53 185 117 149 194 128 160 221 115 113 74 73 217 221 247 111 223 176 237 249 19 103 207 16 171 8 74 146 24 1 121 147 117 127 95 94 150 124 191 140 171 75 81 34 220 249 156 197 84 185 19 70 125 141 11 185 137 15 45 216 209 121 159 178 219 150 88 107 230 226 252 125 183 15 115 252 19 50 212 141 162 103 6 120 238 171 123 230 130 16 93 135 8 32 18 115 96 235 134 77 47 157 186 112 89 226 0 145 158 172 185 251 242 66 239 151 107 144 118 113 65 228 77 221 110 75 110 78 249 115 0 233 66 77 95 55 131 8 51 176 56 118 230 2 22 22 151 48 223 108 97 161 21 0 108 36 22 70 205 16 171 44 25 57 51 221 115 107 52 35 190 214 152 8 194 12 144 234 142 65 124 224 99 25 229 78 219 231 248 112 172 165 115 99 174 18 109 193 185 182 103 60 72 28 1 149 40 81 245 164 72 163 231 251 44 11 249 171 9 11 34 138 55 27 72 208 55 191 231 54 233 182 128 128 168 207 141 119 9 4 74 119 86 193 144 196 172 234 47 120 100 148 21 37 22 129 178 68 81 68 26 28 138 181 16 67 90 137 182 198 188 130 8 25 16 28 125 245 21 76 190 119 59 46 206 5 5 95 57 187 114 136 9 111 52 20 182 78 78 129 46 5 73 80 145 193 136 211 238 84 146 215 176 111 109 21 175 190 116 185 216 22 237 189 202 18 181 148 229 118 164 109 8 165 5 97 168 181 167 100 161 19 189 53 119 109 238 218 197 153 27 217 109 157 247 214 239 198 55 47 181 160 21 80 245 29 12 150 28 212 125 131 1 223 160 228 58 184 224 27 140 139 66 20 180 81 242 226 47 34 186 111 221 224 63 38 108 249 226 243 111 252 191 237 125 105 176 92 199 117 222 119 78 247 189 119 150 55 111 1 1 16 220 0 18 148 73 90 36 69 138 224 34 74 162 200 148 156 168 100 43 75 85 76 59 63 82 78 57 209 31 87 18 167 226 114 74 46 59 118 104 151 126 56 113 37 229 56 249 147 184 202 170 82 42 149 74 224 44 86 202 142 196 72 34 69 82 36 65 44 92 192 21 36 64 16 2 64 44 15 111 155 55 51 119 233 62 39 63 250 222 153 185 243 230 97 17 101 101 195 169 34 223 195 155 185 125 187 79 159 243 157 211 167 79 159 62 241 3 40 105 108 216 254 205 79 223 241 87 103 172 220 53 222 151 29 55 223 138 247 215 202 73 29 55 222 99 1 54 91 212 189 1 175 144 168 22 92 154 224 249 228 154 116 195 108 148 241 173 177 0 90 76 99 74 166 99 57 4 229 28 59 167 152 159 155 175 149 254 190 253 218 217 59 95 61 110 7 119 237 218 62 127 255 141 11 247 36 44 181 10 167 46 106 1 105 142 241 232 101 181 236 184 232 125 108 229 16 6 89 142 126 154 98 125 185 143 247 151 7 232 101 14 107 131 2 221 204 97 101 80 96 61 205 81 40 240 208 117 77 28 220 55 170 17 0 98 240 252 117 226 169 40 115 37 141 76 85 96 84 113 89 13 30 103 141 111 52 229 80 148 86 80 54 226 163 72 25 242 8 181 42 161 10 112 72 9 14 22 157 64 147 149 229 64 13 245 217 78 205 210 121 5 140 137 147 101 48 184 190 237 174 80 9 219 133 213 84 148 88 21 182 239 167 21 162 44 105 29 27 206 69 77 165 233 235 94 190 0 0 31 58 73 68 65 84 75 3 65 220 82 64 65 198 233 244 175 143 242 189 131 75 84 122 95 20 214 240 211 86 6 78 84 140 20 82 104 225 73 217 67 85 40 247 194 214 147 43 140 225 214 150 167 36 207 15 145 228 247 133 55 8 110 141 51 156 172 172 100 89 132 98 8 210 228 113 118 61 195 98 63 48 168 218 193 168 50 236 170 200 114 178 86 191 179 64 108 242 29 142 155 111 178 207 50 79 46 51 57 21 224 76 149 34 227 51 1 39 98 96 237 75 112 249 79 87 207 52 7 23 32 104 64 4 88 25 228 88 233 167 56 1 26 190 3 4 124 234 250 25 188 244 167 255 29 76 132 86 35 65 187 153 236 104 55 27 191 248 241 217 246 90 171 21 187 86 100 102 79 127 120 202 38 113 132 70 249 223 252 220 44 78 246 195 104 199 131 124 21 222 161 4 215 165 141 247 31 76 201 66 27 129 114 109 85 186 209 32 133 6 70 152 9 0 48 213 254 90 53 177 53 80 8 13 45 108 223 81 3 130 107 18 189 245 151 30 185 237 86 76 177 80 215 221 112 19 78 174 229 163 254 169 32 115 130 212 121 164 69 248 153 21 2 159 18 14 188 126 4 189 65 134 94 154 97 61 23 244 214 215 49 72 211 225 9 187 155 254 194 13 120 127 169 143 81 128 96 236 126 96 218 244 80 149 64 88 161 78 65 97 67 104 26 19 60 9 88 104 152 52 30 102 148 17 254 50 177 101 75 36 68 245 147 140 121 158 130 102 2 207 168 244 34 68 171 32 97 240 160 120 162 28 155 166 235 183 250 116 125 88 76 199 13 0 53 182 94 73 100 184 244 161 178 78 194 104 57 21 156 190 41 131 246 94 131 206 94 30 93 158 71 96 83 5 53 20 204 27 2 148 90 109 31 50 2 195 148 203 237 195 42 67 123 138 71 160 16 40 121 120 21 130 58 176 8 52 162 220 49 162 72 13 147 207 52 138 246 105 150 15 111 222 249 224 205 67 160 45 247 150 133 80 168 60 194 90 215 22 231 42 43 35 80 10 27 56 84 110 131 205 38 140 215 246 191 80 235 7 27 123 144 149 6 222 155 180 128 203 200 123 7 88 85 242 38 182 177 122 71 76 54 218 175 99 64 112 232 133 239 97 235 253 95 194 98 175 24 85 237 209 144 11 82 121 185 47 158 234 227 147 247 61 128 87 15 237 199 250 32 197 250 32 5 176 10 108 18 178 33 48 62 245 51 63 139 231 223 120 19 81 100 144 24 131 70 100 208 140 24 177 49 72 34 70 68 132 123 119 180 240 210 75 7 96 173 129 53 6 145 53 96 27 75 98 128 200 24 88 107 176 208 207 177 220 119 32 66 121 42 56 84 95 229 210 18 49 135 0 25 17 149 103 132 8 185 136 51 30 182 170 153 232 139 28 253 178 170 83 168 49 136 97 233 33 81 133 243 130 60 139 112 254 236 18 178 60 71 225 61 10 231 225 188 135 115 30 133 115 40 188 135 115 130 206 252 60 138 254 54 188 191 180 132 212 11 178 220 35 243 126 56 79 193 21 15 74 247 200 13 9 94 124 125 172 78 141 137 69 125 193 117 25 170 182 170 203 157 35 21 40 135 221 85 218 100 159 158 68 149 56 156 40 34 8 85 101 12 235 36 101 137 240 240 81 112 238 9 12 25 22 131 157 148 97 37 83 139 218 166 253 1 116 97 236 140 130 242 24 160 7 3 73 209 230 201 96 195 182 189 171 29 105 84 104 185 58 41 229 172 2 228 210 59 158 122 243 26 179 34 5 96 34 69 196 138 19 103 20 111 76 249 94 73 23 7 130 198 130 2 103 81 201 111 17 130 45 53 54 134 66 12 227 37 176 66 18 145 84 113 186 169 94 152 247 36 16 138 217 163 231 132 27 137 131 20 36 166 208 66 154 108 156 205 152 237 203 227 179 245 131 19 31 224 206 59 62 131 215 207 174 143 213 37 40 49 160 116 101 171 4 162 224 150 133 14 84 75 219 187 23 26 216 151 142 205 27 241 10 146 185 167 60 185 204 33 203 72 93 206 141 196 161 215 131 90 246 133 177 106 73 12 153 100 191 199 200 29 79 211 1 238 107 14 240 236 58 151 198 114 44 232 37 193 141 86 16 222 50 55 226 158 61 132 87 15 190 116 81 22 183 154 109 220 241 216 95 198 179 167 66 70 162 207 29 50 120 172 13 42 79 188 156 120 86 172 191 243 60 142 189 55 82 20 138 91 231 196 21 51 36 163 188 130 135 237 117 120 238 84 6 129 130 203 193 87 221 35 10 101 173 122 251 190 89 239 68 220 202 145 247 135 18 250 240 231 13 158 189 96 130 35 80 97 93 21 13 174 212 131 128 207 93 127 35 94 120 106 239 166 99 219 253 177 219 112 166 125 27 62 252 224 66 153 187 95 165 240 18 148 203 68 39 45 215 212 52 82 194 139 145 150 73 73 129 247 26 34 243 194 99 46 249 228 19 2 48 121 8 133 122 112 97 25 178 49 200 167 229 170 190 60 43 51 10 76 235 232 179 90 171 2 203 92 191 190 111 208 15 214 187 124 150 224 199 118 30 8 128 199 89 169 37 171 94 1 9 0 134 250 210 232 86 65 195 106 146 38 169 40 0 54 58 188 200 246 18 116 145 220 196 59 67 235 73 83 169 31 43 123 149 225 209 187 49 170 38 36 148 243 174 38 34 32 85 48 150 211 14 42 177 207 81 120 26 24 207 51 137 99 29 120 54 206 49 39 142 108 86 176 106 206 173 133 151 97 226 239 142 63 54 95 44 150 101 169 170 19 103 10 149 16 52 9 179 37 229 218 64 70 66 91 186 183 189 211 245 171 186 200 196 223 178 22 231 216 251 148 52 202 77 142 194 100 235 133 177 90 24 23 229 236 139 188 112 54 149 134 61 78 241 204 87 199 159 125 229 185 167 112 195 108 18 210 169 197 7 129 20 29 70 135 9 138 94 94 224 176 92 135 79 125 241 103 177 227 186 218 198 0 128 112 5 215 93 247 220 139 237 15 255 12 94 58 213 131 250 192 63 148 117 23 66 64 84 161 234 161 16 60 124 93 179 6 2 0 192 141 246 145 114 192 99 188 13 187 38 213 109 210 82 41 205 248 18 110 130 216 216 90 190 245 241 183 94 43 11 175 40 134 181 247 203 138 168 33 74 29 236 193 179 167 6 184 251 11 127 3 119 124 252 46 196 113 60 28 215 237 63 249 113 60 240 197 159 195 209 153 219 241 225 74 6 18 129 170 12 107 132 106 53 47 213 90 69 165 76 197 157 232 24 77 19 158 81 232 73 75 240 13 57 96 126 216 215 13 228 197 67 189 16 200 135 29 43 108 208 142 225 225 172 178 16 12 171 6 11 172 50 181 104 10 17 9 184 94 96 166 215 235 97 182 97 74 4 151 176 213 141 32 23 84 98 207 219 231 122 120 248 243 63 141 249 133 112 232 137 153 177 125 199 14 220 249 137 123 113 239 125 15 161 221 222 8 20 170 165 226 139 12 227 69 82 102 125 142 42 95 79 118 208 43 10 167 176 177 134 229 253 197 233 178 150 6 100 83 29 152 142 26 154 114 63 134 6 32 96 80 121 213 211 40 8 52 37 72 26 218 99 117 228 216 163 145 121 42 50 233 10 203 92 47 86 36 78 213 58 46 226 126 110 165 145 106 20 63 69 62 31 230 20 188 113 232 37 196 183 62 138 220 135 139 66 180 218 219 169 44 113 233 41 13 171 1 151 214 240 250 78 3 111 60 247 74 189 219 145 61 224 189 164 206 229 133 117 190 48 17 21 171 82 222 137 70 134 58 89 4 181 158 10 31 165 28 219 67 227 171 193 254 160 135 27 206 30 70 163 125 7 250 133 7 83 216 153 8 86 87 135 235 250 92 61 158 61 45 136 118 236 193 205 119 124 22 215 52 24 6 30 231 82 194 251 203 3 188 34 2 89 236 5 200 172 150 188 42 33 56 71 90 174 60 8 187 22 154 120 235 217 63 171 243 48 110 30 133 77 142 145 82 45 224 88 1 113 216 95 150 225 182 74 176 234 58 125 59 215 38 167 1 236 170 254 249 225 233 147 184 235 206 79 227 181 51 61 0 193 117 7 87 103 44 203 245 179 50 4 192 161 83 107 0 223 12 190 227 22 44 52 35 92 232 231 56 12 5 78 246 134 167 81 165 52 196 6 4 175 35 15 5 229 142 15 85 33 150 73 97 17 218 216 89 173 188 191 210 90 83 72 6 23 132 118 54 90 54 18 97 41 200 81 225 85 5 42 150 45 111 88 60 171 208 152 188 142 60 139 80 60 119 200 216 241 126 56 21 237 41 81 78 58 42 219 190 115 54 198 114 63 15 91 175 16 136 16 8 2 34 70 200 85 35 124 239 44 96 110 250 52 110 184 171 137 115 235 41 78 58 193 15 20 160 140 112 253 189 95 192 53 63 56 132 19 39 142 215 38 85 203 126 145 242 200 115 145 145 193 221 48 106 176 7 103 138 126 161 48 155 31 80 171 232 210 247 26 44 182 149 162 68 201 245 133 224 124 168 71 54 206 143 210 106 168 47 45 90 176 202 82 162 243 180 67 91 164 236 137 196 177 176 95 23 246 240 198 175 118 214 124 215 247 188 137 81 144 70 57 65 114 19 53 106 218 187 182 186 130 251 174 77 106 251 166 84 34 182 202 152 5 83 41 153 6 64 129 219 90 89 205 27 84 178 7 180 57 251 221 130 56 99 95 228 38 162 98 117 37 115 240 236 97 219 14 60 112 221 152 11 19 247 11 230 52 179 220 126 147 226 246 111 143 247 229 221 119 222 198 158 118 23 21 242 163 60 131 160 226 203 203 74 116 136 216 69 161 56 178 216 195 139 39 215 240 252 169 30 222 93 236 195 59 41 163 201 101 156 165 242 104 42 207 85 130 21 104 69 140 232 196 65 172 175 215 163 191 20 181 95 0 252 18 152 38 110 197 168 138 111 150 107 51 5 170 192 82 200 130 220 56 33 106 162 19 48 113 173 154 199 92 190 92 90 94 25 173 71 125 176 152 225 54 181 176 4 172 192 216 171 224 194 122 121 101 92 229 77 160 10 107 1 55 207 181 240 200 14 59 92 106 64 203 241 163 242 132 54 122 4 74 36 58 225 198 87 41 212 90 185 219 50 86 199 64 52 244 171 206 41 33 213 156 24 5 177 47 96 56 23 149 41 57 218 33 73 173 242 50 43 84 208 202 18 111 36 7 194 42 81 93 203 22 236 232 44 138 150 158 69 5 166 149 247 172 170 240 34 248 96 169 143 180 8 134 44 124 95 112 122 165 143 249 59 234 55 44 85 177 232 234 254 134 42 16 46 213 214 240 132 121 86 133 144 207 133 34 21 216 84 145 52 53 44 243 239 220 212 51 184 248 177 165 206 17 69 178 172 43 153 23 130 241 84 68 14 140 90 117 23 46 210 33 98 41 149 21 84 8 80 4 47 108 107 179 158 133 36 74 125 114 185 131 87 33 39 130 204 11 156 245 24 204 9 10 246 166 219 114 38 31 20 69 70 153 218 232 56 217 248 63 141 63 191 248 214 1 4 185 212 114 226 131 252 112 217 135 224 134 6 166 137 40 102 99 131 215 94 124 186 206 168 56 250 30 43 13 88 125 110 98 20 171 38 115 216 98 61 204 188 131 75 60 114 227 225 87 124 119 128 194 172 23 121 225 122 41 58 11 123 97 108 173 161 125 207 126 7 143 44 100 136 153 70 10 141 106 199 68 49 236 72 229 181 40 202 10 82 82 186 139 227 245 5 203 224 151 175 158 241 216 58 147 224 214 254 123 56 254 254 209 250 188 68 201 62 196 246 13 242 116 158 64 53 183 158 93 21 97 15 192 34 234 49 58 79 239 177 181 61 49 31 32 7 232 5 138 162 227 227 127 223 255 253 167 113 207 142 118 105 189 131 171 11 96 120 10 113 252 234 56 241 229 119 168 116 243 81 173 255 195 182 215 174 249 38 138 119 158 129 235 175 132 197 133 84 71 214 43 176 68 240 90 164 142 105 68 212 39 83 119 227 231 146 50 153 134 100 248 174 10 68 85 21 13 154 136 156 17 46 16 36 151 66 243 80 3 67 114 0 153 132 20 185 33 109 107 71 195 37 230 48 26 95 1 58 20 40 38 178 57 137 150 73 100 21 198 214 248 118 238 189 215 70 6 81 21 213 141 81 149 39 166 213 255 53 120 12 33 43 183 226 113 120 239 135 235 117 62 84 58 70 165 23 224 49 106 23 80 108 239 212 231 84 65 41 113 228 224 19 65 214 17 44 182 75 33 123 2 155 209 244 226 144 85 214 198 182 109 138 102 71 177 214 83 42 68 72 157 7 217 90 85 157 188 183 58 92 143 67 70 69 19 80 34 246 150 137 251 21 152 105 177 176 84 16 123 199 84 56 20 236 209 113 130 236 188 199 22 235 87 138 53 207 84 56 246 62 47 188 79 213 38 181 12 160 227 199 143 225 161 235 195 21 80 82 186 186 85 68 91 171 84 231 177 212 213 251 22 4 221 181 186 107 100 40 57 224 184 200 88 125 222 29 160 128 90 15 151 120 156 203 4 231 50 65 55 14 160 192 3 103 91 141 220 88 155 186 220 247 125 50 255 79 68 169 118 206 120 223 51 223 198 157 242 3 108 105 38 33 103 165 90 183 86 66 0 25 203 61 47 21 167 252 211 48 43 172 84 12 168 130 16 10 192 222 118 77 27 141 99 207 227 237 183 38 66 189 108 95 227 246 220 31 66 176 8 146 69 101 123 172 54 31 235 171 229 155 80 10 100 201 23 10 145 231 107 226 137 249 32 234 51 112 30 182 113 112 220 250 122 87 224 236 161 239 224 198 217 4 85 93 3 69 185 79 14 25 75 100 41 239 111 20 148 150 20 35 128 80 197 174 249 38 252 59 207 225 220 185 179 88 91 58 63 178 250 33 77 174 140 69 4 78 21 253 122 117 39 98 190 64 48 53 126 183 217 67 189 148 247 56 134 198 134 202 6 0 249 68 214 37 153 19 226 41 35 150 148 160 25 123 73 153 36 101 226 218 57 146 45 9 149 161 165 18 100 42 79 163 92 130 102 235 117 25 34 50 39 5 126 153 35 91 43 179 119 244 189 119 241 224 141 51 97 13 95 113 83 43 192 31 121 62 213 21 121 42 0 139 12 13 24 169 98 231 76 125 197 94 244 86 81 29 247 175 188 221 170 210 147 40 176 37 174 171 49 51 45 230 36 142 89 28 154 94 144 44 43 58 71 54 245 6 128 75 121 4 123 1 156 56 163 104 23 194 98 125 206 226 192 113 237 74 150 215 15 237 199 181 157 24 85 77 130 81 237 183 208 105 119 102 194 154 49 63 75 46 47 120 224 220 154 55 30 237 66 208 205 5 243 59 4 46 241 216 98 253 26 183 156 137 77 193 68 25 53 103 191 9 19 255 199 241 38 142 191 244 93 220 182 181 9 242 2 86 26 6 234 8 37 138 107 88 50 124 242 250 54 14 61 247 237 218 235 37 105 253 51 138 219 47 83 134 204 100 92 128 103 221 16 4 58 71 20 7 151 195 207 115 153 192 204 187 149 190 45 172 207 115 206 93 170 150 79 155 102 251 31 9 168 102 77 222 56 252 10 162 163 207 224 209 27 18 36 6 64 41 4 84 205 123 185 190 11 59 95 85 48 179 4 203 234 206 195 210 242 92 211 106 224 209 237 130 83 207 127 3 103 207 213 147 159 96 204 43 166 189 240 187 240 122 1 226 23 1 189 128 136 107 203 167 215 95 62 128 107 59 213 242 137 134 174 116 137 47 144 197 227 181 38 213 68 111 137 248 69 24 115 132 154 237 127 55 254 217 210 210 5 200 219 207 224 254 27 102 74 139 61 220 58 8 73 226 101 76 86 17 14 128 105 121 115 170 138 34 102 194 163 55 54 145 189 249 52 206 158 11 185 15 239 29 57 130 155 231 155 37 126 148 94 74 9 218 237 200 224 232 91 175 215 250 70 38 62 6 91 247 84 206 191 119 24 204 85 5 143 0 114 84 2 239 76 98 240 238 43 7 38 218 48 7 88 116 224 217 167 222 115 234 153 83 47 156 42 155 125 227 223 115 103 75 57 85 132 192 109 245 59 20 215 119 98 188 241 234 161 250 92 216 232 48 68 47 168 109 62 175 38 218 63 254 209 177 23 159 196 221 59 218 67 93 144 18 232 42 199 172 186 173 40 240 78 130 7 77 1 4 22 154 9 186 39 234 224 255 250 203 7 112 237 108 3 213 89 140 42 67 4 229 114 216 157 171 217 130 82 199 184 96 181 30 3 47 104 118 130 81 15 54 126 42 32 92 162 162 193 157 97 109 209 77 101 205 247 60 23 105 1 138 94 135 142 238 44 76 179 20 55 187 15 209 176 22 82 173 69 75 47 241 209 27 91 120 109 114 98 200 236 35 71 5 35 113 112 54 184 225 231 123 50 180 198 46 241 176 153 235 14 186 5 171 207 157 147 84 227 230 191 31 111 227 194 210 5 92 56 248 36 238 222 49 3 41 163 197 240 62 176 182 68 243 135 110 108 227 157 167 255 4 131 137 3 58 134 163 253 133 235 165 198 187 124 141 157 67 247 131 240 222 221 203 130 167 31 19 96 175 226 233 199 194 191 207 101 130 124 209 175 246 168 176 160 204 160 232 23 113 235 73 147 180 54 128 193 210 210 5 188 248 228 127 195 246 179 47 227 115 55 198 216 185 208 44 147 153 4 82 110 107 5 143 129 202 53 94 85 224 53 76 194 79 110 159 193 163 215 2 197 235 223 194 11 79 125 19 121 94 119 15 149 205 62 106 206 254 174 24 124 168 164 75 10 191 12 47 203 132 198 65 128 134 181 211 211 44 197 205 197 25 52 45 7 171 83 238 230 128 4 159 189 169 185 97 59 147 201 188 2 248 69 168 156 39 219 252 31 202 209 247 39 121 253 218 147 127 140 207 46 100 184 99 71 171 148 191 178 14 17 233 112 71 128 180 140 108 3 248 204 206 25 92 191 244 42 94 124 242 191 96 121 172 116 155 115 5 174 89 63 142 86 204 195 157 38 241 10 40 225 129 249 12 75 75 23 70 227 37 234 195 216 195 68 166 230 129 30 59 250 46 62 119 29 67 202 101 104 165 92 198 24 220 55 211 199 133 177 54 194 0 147 67 222 98 192 206 165 198 234 128 157 79 89 242 1 152 107 140 56 252 234 33 124 238 166 198 40 222 80 186 223 77 75 216 229 207 32 27 59 241 169 196 103 108 212 120 5 226 150 32 186 196 73 242 141 241 182 186 107 107 56 245 226 159 225 209 157 45 116 146 112 226 117 164 23 37 116 150 6 12 26 2 252 134 128 61 55 204 96 246 244 65 28 121 187 54 100 164 89 138 93 254 12 26 150 199 188 148 128 167 143 220 212 194 225 87 14 214 190 79 100 95 36 22 215 149 126 240 182 207 101 130 205 119 121 195 51 155 29 88 40 175 70 39 60 246 24 163 121 183 193 192 71 157 5 74 156 36 45 51 232 254 53 205 251 127 48 254 253 155 119 223 138 235 62 246 9 116 213 160 197 130 98 233 67 188 60 145 192 163 76 251 165 61 255 243 166 111 250 61 26 164 104 162 192 177 101 135 109 231 71 209 152 238 109 132 237 9 195 175 216 185 104 38 46 92 210 240 205 168 101 187 231 127 19 190 248 91 227 237 25 107 241 19 63 113 59 22 118 220 132 65 212 134 1 33 202 86 112 246 228 113 28 63 122 12 147 219 197 106 27 95 149 230 194 31 25 42 250 17 83 182 226 251 249 240 253 79 63 93 134 238 70 44 192 227 143 19 142 45 48 58 185 65 193 81 167 209 140 93 51 110 8 163 105 157 255 152 166 171 191 69 226 30 222 140 185 55 237 220 133 27 118 223 6 196 45 120 50 72 133 145 123 69 195 16 26 44 32 41 224 215 87 112 228 205 195 88 93 189 200 229 87 108 190 107 218 91 127 195 65 114 82 239 193 172 16 33 75 98 20 28 75 154 126 81 139 254 111 213 230 227 150 91 177 227 99 119 163 11 139 54 20 126 245 67 28 124 233 249 58 63 136 143 162 53 255 15 72 57 7 171 64 13 33 2 235 218 133 223 33 241 15 97 10 237 218 117 11 174 219 125 27 96 27 200 17 65 1 52 52 135 100 235 232 46 95 192 153 211 39 107 10 61 141 118 238 220 133 235 238 248 36 186 222 96 198 40 122 31 30 195 27 135 235 187 58 20 183 254 51 226 153 111 3 128 12 86 126 129 124 94 227 243 61 159 124 0 201 246 155 176 238 25 179 236 112 225 248 219 120 247 72 205 75 7 76 242 123 212 152 249 122 65 200 40 23 7 164 64 20 145 122 68 150 77 172 253 213 63 34 200 253 227 143 220 247 208 167 97 102 175 69 207 51 58 236 112 246 189 195 56 126 124 194 226 198 205 223 51 81 251 59 30 226 195 198 155 24 164 171 255 16 190 248 194 228 88 27 73 3 119 237 121 16 182 53 7 33 139 190 48 114 1 26 6 72 72 192 240 144 245 101 188 245 250 171 88 191 72 249 57 0 184 249 150 221 216 113 235 221 88 211 8 109 235 225 150 62 196 203 251 235 103 103 148 105 191 196 91 127 206 74 218 95 55 81 138 65 55 7 142 187 74 190 55 243 8 54 5 2 160 2 131 199 25 123 22 24 113 219 162 221 139 219 173 102 195 25 55 103 87 86 191 1 213 219 55 125 120 26 37 173 191 168 73 242 166 205 6 233 154 230 25 204 188 195 185 231 5 7 119 75 136 104 190 65 120 28 24 42 31 90 118 54 73 226 34 66 83 24 77 219 91 250 3 120 247 197 43 122 103 73 106 236 31 251 206 246 95 51 131 162 31 217 44 93 45 214 115 152 121 135 193 97 31 60 129 39 202 184 152 106 9 130 192 20 48 152 157 153 139 28 52 145 216 54 108 108 90 178 122 238 239 146 203 127 233 135 233 211 229 16 69 205 223 210 153 217 111 80 46 121 97 242 130 148 61 50 0 9 16 147 24 241 113 36 172 51 232 94 248 15 4 189 245 146 13 142 83 50 243 183 197 52 222 36 82 7 174 114 68 172 49 150 172 95 93 254 117 18 247 165 31 253 136 46 143 168 217 249 251 100 226 83 202 74 234 252 44 250 171 95 187 146 231 5 148 218 164 243 151 10 139 83 84 80 65 154 122 176 85 45 152 193 98 196 216 216 144 191 141 210 245 63 189 146 118 149 248 40 183 231 190 204 160 190 19 21 16 171 146 26 171 100 165 191 250 59 80 247 249 43 27 233 69 222 197 230 28 137 223 126 233 111 142 81 99 230 167 84 155 111 14 101 252 84 90 224 227 240 216 187 87 54 3 1 224 178 202 153 239 13 129 134 121 39 224 129 179 62 207 77 191 232 106 210 248 21 16 189 115 185 253 19 107 127 95 184 241 182 49 154 173 37 90 160 155 6 151 229 224 238 224 142 227 137 240 174 189 123 21 187 151 67 192 14 125 183 150 172 22 54 202 83 22 12 92 123 203 47 19 69 127 114 185 239 28 146 137 191 46 243 91 190 98 100 48 176 160 108 181 71 5 114 19 226 2 19 32 80 253 28 6 76 199 251 19 73 177 150 101 121 100 179 212 80 209 119 131 245 117 211 218 246 47 53 158 249 178 70 241 191 185 226 126 93 132 40 110 255 182 182 183 124 137 26 115 123 189 203 215 124 145 175 155 204 245 76 63 237 91 132 159 46 115 61 95 228 235 222 201 18 39 205 175 0 245 123 36 47 74 108 191 6 19 29 176 198 175 122 202 214 124 174 225 63 239 86 53 199 10 205 204 255 6 197 173 95 22 92 230 169 149 205 40 106 126 139 103 183 253 58 177 185 108 89 33 219 248 42 16 29 86 241 23 224 100 145 212 188 175 182 241 175 47 247 121 81 238 147 137 255 94 97 248 4 187 100 96 32 153 17 151 89 248 204 146 73 13 115 202 145 12 36 138 222 82 54 255 234 242 7 67 239 146 109 253 38 148 23 53 215 53 15 93 243 234 187 62 215 53 101 191 138 230 194 175 170 137 126 36 114 160 54 126 142 27 237 127 171 68 167 47 253 237 64 194 246 247 197 182 222 54 174 200 87 87 50 135 220 120 108 59 47 216 187 249 182 97 69 23 245 8 128 202 43 120 130 176 231 180 25 183 210 14 189 196 196 241 156 172 175 255 26 180 238 178 79 180 240 174 198 205 95 209 120 230 101 75 189 172 235 146 28 43 182 192 218 73 95 34 85 80 184 137 135 134 150 56 94 182 216 214 177 179 89 101 137 93 35 202 179 159 242 121 250 119 72 101 170 251 58 100 12 217 103 216 198 95 243 166 253 52 107 63 179 104 103 107 89 150 3 125 135 110 236 113 112 89 128 189 229 238 205 38 46 83 181 68 194 227 132 61 11 92 45 91 32 77 219 105 118 34 167 146 40 153 56 130 38 62 91 255 12 36 223 67 234 31 134 247 247 78 107 111 211 190 2 235 204 209 11 106 205 62 152 214 75 62 106 30 33 206 51 114 84 152 124 80 144 55 190 235 123 30 54 86 68 61 69 209 166 185 212 176 88 111 124 130 72 227 102 196 222 207 33 235 254 42 188 251 133 205 167 131 78 80 212 252 74 209 136 14 80 46 142 40 114 36 153 39 99 3 8 22 204 74 98 148 99 163 86 34 82 221 97 139 244 110 245 197 95 153 230 250 78 39 94 33 107 190 3 219 120 221 52 103 191 15 0 234 37 150 254 226 47 170 43 254 250 102 79 41 155 23 76 212 252 167 98 204 7 0 123 34 87 2 179 37 64 12 57 127 187 230 253 127 12 212 79 109 214 134 7 243 95 165 211 249 170 102 122 158 125 158 27 171 197 154 55 30 3 23 214 137 179 25 97 16 113 199 180 141 36 26 137 137 98 164 253 61 84 12 254 57 65 111 217 116 72 198 126 61 106 54 254 197 192 199 235 68 226 72 51 79 174 204 132 72 98 66 42 70 155 177 81 50 177 205 251 15 171 115 15 194 231 63 79 138 45 155 182 185 129 1 88 130 137 14 34 226 215 76 99 225 127 18 137 74 238 155 146 174 126 25 23 245 206 54 209 177 188 231 46 71 198 129 203 6 2 96 184 68 40 193 96 174 173 145 47 52 242 38 138 141 95 255 148 122 125 80 189 255 44 84 111 37 194 57 53 252 12 145 221 103 76 227 121 7 215 51 46 202 187 49 23 67 16 216 118 126 170 53 222 212 45 159 120 167 218 36 50 197 250 109 240 197 61 42 238 65 18 255 128 42 10 50 230 69 49 209 75 134 27 175 185 168 241 1 169 207 77 62 8 153 131 61 42 134 32 176 123 89 42 16 186 24 131 54 240 224 177 243 132 243 219 24 179 55 26 108 91 181 115 62 177 190 208 200 199 205 72 173 70 177 139 34 73 92 44 89 190 203 228 197 39 188 207 246 192 203 46 16 182 16 208 81 69 76 170 125 24 90 85 165 37 152 232 85 99 204 203 46 105 189 101 12 150 10 79 5 185 188 96 75 5 23 84 24 118 110 85 172 135 95 241 72 154 138 197 229 81 95 59 13 70 47 226 249 72 140 239 196 214 231 1 16 76 186 254 144 138 127 96 52 31 116 94 153 159 33 142 246 83 100 246 121 111 186 68 206 49 23 142 133 61 245 6 186 106 99 5 128 57 151 147 182 155 36 220 50 34 198 106 131 173 58 141 34 230 216 187 236 22 42 210 123 84 221 253 80 191 19 138 210 109 229 147 196 230 40 140 121 155 109 252 38 219 246 41 88 21 148 181 21 137 88 53 156 13 135 184 193 253 62 47 238 129 184 7 9 186 19 42 231 213 68 207 25 166 3 136 90 207 228 202 158 188 10 172 10 229 69 144 141 56 34 56 98 37 49 49 69 6 249 218 35 94 245 126 82 247 25 85 108 7 211 251 196 246 57 130 217 239 103 226 231 41 117 206 184 40 239 82 17 2 210 29 39 88 92 86 36 109 69 214 163 13 124 163 56 54 78 103 36 75 31 86 117 15 145 200 35 170 186 29 68 71 137 249 121 34 222 239 146 214 139 196 222 49 135 148 120 202 189 80 47 240 76 219 57 105 102 88 140 24 105 90 171 98 172 218 56 226 194 109 37 205 239 132 203 247 192 251 79 16 116 43 128 5 85 141 137 208 135 114 79 161 43 48 246 16 155 232 85 141 27 71 44 155 85 120 214 209 82 45 144 12 214 246 120 209 79 64 138 135 64 180 139 84 207 41 155 103 201 242 62 211 104 126 223 101 149 142 173 20 88 217 62 166 99 23 143 13 12 101 252 114 170 155 12 173 226 184 98 198 222 64 154 182 163 145 85 227 141 80 195 104 68 140 60 99 24 163 48 133 86 76 51 221 150 91 65 238 144 157 247 88 195 166 32 112 209 119 86 150 216 204 155 89 177 86 116 96 165 97 173 82 108 180 32 70 236 9 41 0 54 74 209 64 40 141 29 107 234 153 154 110 141 157 131 95 9 185 1 231 50 41 81 242 178 64 96 162 63 0 158 32 60 246 52 15 131 154 54 51 112 137 157 99 103 132 91 198 231 221 72 171 126 9 217 216 16 131 137 213 129 97 109 184 81 154 189 194 177 146 64 72 217 231 137 243 24 228 158 56 118 204 226 88 173 55 198 187 21 89 11 231 116 171 157 149 198 66 189 175 233 50 97 91 155 209 137 25 75 206 204 71 98 188 105 27 65 102 181 221 8 124 169 46 194 140 69 168 16 97 101 79 222 120 227 123 126 165 224 176 125 59 14 48 91 23 8 217 128 130 162 204 26 111 10 163 198 155 33 175 133 173 146 55 137 88 82 38 70 117 13 30 57 37 137 5 236 52 99 171 84 56 5 23 211 121 43 17 13 63 243 42 148 91 13 233 230 34 228 68 40 246 66 131 72 97 162 242 59 5 105 204 172 141 132 52 27 176 70 204 200 153 81 85 127 30 0 212 96 79 189 212 51 18 55 28 219 150 50 63 228 196 25 173 241 174 226 91 236 13 140 152 57 158 53 194 222 136 183 86 88 12 124 68 240 158 134 114 44 236 73 7 158 133 253 208 187 104 23 193 195 72 154 138 108 64 200 59 132 166 225 32 7 222 8 53 141 8 91 21 182 26 179 141 201 27 56 98 101 240 240 94 66 102 133 243 74 236 20 54 22 242 42 89 225 66 133 235 113 222 73 117 213 96 3 224 66 81 132 207 73 217 51 121 199 198 185 233 58 118 121 32 0 92 38 16 0 155 184 200 43 150 209 89 100 152 121 51 63 48 172 237 140 170 251 216 201 198 186 90 101 13 118 156 212 246 234 75 16 184 76 75 28 222 57 180 196 48 232 52 194 59 19 195 50 32 214 184 199 24 222 69 210 5 229 109 225 76 101 165 233 5 126 197 163 155 202 136 57 219 244 114 92 165 43 234 83 165 140 93 203 176 206 204 154 182 209 152 89 200 25 205 136 145 56 82 137 8 177 27 9 88 110 149 184 80 114 165 240 183 141 231 92 100 85 202 189 223 44 241 152 119 130 19 103 20 219 206 11 182 109 211 176 5 84 173 247 202 192 234 249 178 15 59 119 16 108 102 208 181 140 166 225 249 129 97 73 186 195 24 16 217 88 169 55 208 149 102 33 240 236 209 221 26 18 77 54 3 152 157 59 168 54 191 137 97 223 45 140 198 28 20 209 21 164 126 60 59 169 15 50 86 97 35 165 52 11 237 153 72 201 134 223 213 21 4 204 132 175 250 130 130 146 175 35 40 124 170 220 104 203 176 127 107 137 34 106 40 226 110 104 39 239 16 138 148 48 155 209 252 32 98 109 55 73 93 78 234 26 165 172 165 74 189 88 87 27 19 242 86 241 14 64 152 247 146 30 59 79 232 222 70 53 64 232 69 140 166 229 185 196 112 37 195 0 48 108 183 82 254 110 26 114 94 78 156 169 243 108 231 14 194 160 75 227 114 48 151 24 22 246 70 51 102 33 49 72 226 32 7 222 133 246 141 85 96 0 42 26 2 244 65 73 83 70 188 203 70 237 251 164 150 5 70 137 8 250 145 146 77 117 8 76 91 198 146 226 58 71 244 74 64 0 184 2 32 0 46 98 21 7 93 66 182 64 216 218 11 214 4 192 208 202 84 76 27 41 225 15 111 137 31 127 35 120 7 213 4 102 11 132 206 98 16 246 188 83 90 190 82 120 38 5 125 247 114 25 52 217 220 11 185 114 62 140 1 66 197 139 149 51 140 173 11 132 174 101 204 206 16 250 43 60 63 211 34 45 178 13 73 254 212 75 116 165 233 5 81 79 145 150 150 185 155 203 176 207 157 35 26 120 118 103 25 76 157 18 75 193 19 0 222 168 247 225 98 243 145 180 181 214 254 16 96 198 168 2 152 113 101 169 120 93 90 62 76 25 15 162 36 244 111 173 23 126 70 141 233 60 46 82 170 125 30 119 181 214 191 102 71 129 247 128 19 51 225 243 157 235 4 124 12 97 92 61 26 122 45 227 52 46 111 149 50 108 219 166 229 156 79 242 46 240 237 241 55 8 199 142 49 210 221 37 240 149 115 55 222 246 164 28 111 198 183 199 206 135 103 166 202 65 74 232 91 158 119 45 210 118 157 111 212 75 116 197 246 75 126 245 20 107 201 70 222 85 252 26 242 185 4 201 31 145 142 1 87 8 4 192 38 74 80 49 0 8 214 100 220 194 12 133 121 20 20 252 104 150 248 137 48 129 227 130 58 73 213 251 235 194 240 145 1 96 147 62 1 53 94 60 6 116 79 211 208 170 86 74 9 0 91 123 163 190 46 182 21 56 137 161 224 111 16 178 141 2 60 217 247 177 247 79 244 1 245 249 152 202 19 96 124 78 166 13 111 83 94 87 227 2 128 172 71 72 218 163 54 154 157 209 239 147 86 19 40 149 186 250 124 102 244 121 99 65 129 131 64 167 124 126 92 209 42 96 2 128 110 151 128 61 216 116 108 0 38 229 173 162 137 173 225 209 24 199 129 180 162 154 28 151 253 170 131 50 48 13 92 170 182 0 12 121 54 148 131 30 141 223 110 23 168 60 235 53 4 64 0 120 111 196 159 113 126 77 242 109 124 220 31 81 199 174 24 8 134 15 214 148 0 24 50 97 72 149 11 251 4 126 216 206 93 228 157 229 123 199 222 249 120 249 215 33 74 95 90 145 126 84 52 85 33 199 133 183 2 135 73 170 4 183 230 246 255 112 125 190 244 124 76 111 127 179 119 108 202 235 218 184 54 161 109 165 27 62 45 155 237 241 137 127 215 230 171 234 55 54 244 17 181 113 1 23 25 91 237 217 139 70 202 167 142 113 178 237 77 21 191 214 246 68 91 101 123 147 114 0 212 192 6 192 212 51 0 147 222 198 166 60 171 245 239 35 233 216 15 13 4 181 70 54 50 161 70 127 30 10 120 169 119 254 121 190 251 98 52 93 32 42 122 2 211 127 191 180 98 126 132 247 111 160 43 182 22 211 219 220 236 61 31 153 223 151 1 76 87 252 252 165 232 71 205 183 203 147 131 39 38 190 242 195 243 238 35 27 217 31 179 158 252 127 71 255 59 64 242 199 69 227 99 251 191 121 28 63 14 250 63 93 14 174 2 193 85 186 74 87 233 114 82 140 175 210 85 186 74 255 175 211 85 32 184 74 87 233 42 93 5 130 171 116 149 174 210 85 32 184 74 87 233 42 1 248 95 87 16 211 147 133 51 173 234 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

Announcement subclass: #RefreshContent
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!RefreshContent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 10/28/2012 11:31'!
content: aComponent
	^ self new content: aComponent! !

!RefreshContent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 11:30'!
content
	^ content! !

!RefreshContent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 11:30'!
content: anObject
	content := anObject! !

WALabelledFormDialog subclass: #VOUserLoginComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOUserLoginComponent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/7/2012 14:52'!
user: aUser
	^ self new model: aUser! !

!VOUserLoginComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/19/2012 14:08'!
buttons
	^ #(login)! !

!VOUserLoginComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 09:49'!
initialize
	super initialize.
	self validateWith: [ :aUser | aUser validate ].
	self addMessage: 'Login'! !

!VOUserLoginComponent methodsFor: 'private protocol' stamp: 'NicolasVanderAuwera 2/6/2012 11:39'!
login
	self answer: self model! !

!VOUserLoginComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/7/2012 14:52'!
model
	^ model! !

!VOUserLoginComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/7/2012 14:53'!
model: aUser
	model := aUser! !

!VOUserLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 13:51'!
renderBlindedIdOn: html
	html textInput
		callback: [ :value | self model blindedId: value greaseInteger ];
		placeholder: 'Enter the blinded id'! !

!VOUserLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/25/2012 10:54'!
renderDescriptionOn: html
	html paragraph
		class: 'info';
		with: self model description! !

!VOUserLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/6/2012 10:02'!
renderIdOn: html
	html textInput callback: [ :value | self model id: value greaseInteger ]! !

!VOUserLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/22/2012 07:37'!
renderNameOn: html
	html textInput placeholder: 'Enter your name'; on: #name of: self model! !

!VOUserLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/19/2012 13:51'!
renderPasswordOn: html
	html passwordInput
		on: #password of: self model;
		placeholder: 'Enter your password'! !

!VOUserLoginComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/6/2012 10:02'!
renderSignatureOn: html
	html textInput callback: [ :value | self model signature: value greaseInteger ]! !

!VOUserLoginComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/7/2012 14:57'!
rows
	^ self model fields! !

!VOUserLoginComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/29/2012 09:21'!
style
	^ ''! !

!VOUserLoginComponent methodsFor: 'validation' stamp: 'NicolasVanderAuwera 2/19/2012 14:00'!
validate
	^ true! !

!InputEventSensor methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 5/5/2012 07:46'!
mousePoint
	^ self cursorPoint! !

WADecoration subclass: #VOErrorHandlingDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOErrorHandlingDecoration methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 16:40'!
renderContentOn: html
	[ self renderNextOn: html ]
		on: Error
		do: [ :ex | self session redirectTo: (html urlForAction: [ self owner call: (VOErrorComponent new failure: ex) ]) ]! !

!RSAKeyPairGenerator methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 3/22/2012 10:03'!
n
	^ self p * self q! !

RSAKeyPairGenerator subclass: #VORSAKeyPairGenerator
	instanceVariableNames: 'e'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!VORSAKeyPairGenerator methodsFor: 'private' stamp: 'NicolasVanderAuwera 2/14/2012 09:28'!
computeE
	| rand ea phi s |
	phi := (self p - 1) * (self q - 1).
	s := SecureRandom new.
	[ 
	rand := s nextFrom: 2 to: 70000.
	ea := EuclidAlgorithm with: phi with: rand.
	ea run.
	ea gcd = 1 ] whileFalse.
	e := rand! !

!VORSAKeyPairGenerator methodsFor: 'private' stamp: 'NicolasVanderAuwera 2/14/2012 08:11'!
computePrimes
	p := self findPrime.
	q := self findPrime! !

!VORSAKeyPairGenerator methodsFor: 'private' stamp: 'NicolasVanderAuwera 1/19/2012 07:28'!
e
	e isNil
		ifTrue: [ self computeE ].
	^ e! !

!VORSAKeyPairGenerator methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/28/2012 08:28'!
e: anInteger
	e := anInteger! !

!VORSAKeyPairGenerator methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 10:11'!
privateKey
	^ VORSAPrivateKey p: self p q: self q dP: self dp dQ: self dq qInv: self qInv d: self d! !

WATask subclass: #VOZKAuthenticationTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOZKAuthenticationTask methodsFor: 'task' stamp: 'NicolasVanderAuwera 10/28/2012 11:35'!
authentication
	| userLogin |
	userLogin := VOUserLoginComponent user: VOSpecialUser new.
	userLogin addDecoration: (VODescriptionView text: 'Please provide the required information.').
	^ self session protocol authenticate: (self call: userLogin)! !

!VOZKAuthenticationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 10/29/2012 14:27'!
go
	| challenge response |
	challenge := nil.
	[ challenge isNil ]
		whileTrue: [ 
			challenge := self authentication.
			challenge ifNil: [ self inform: 'The information provided are wrong.' ] ].
	response := (self
		request:
			'Enter the challenge: ' , challenge greaseString
				, ' in your digipass and click on OK. Enter the response in the field below.') greaseInteger.
	(self session protocol sendResponse: response)
		ifTrue: [ 
			self session user: self session protocol user.
			^ self ].
	self inform: 'Information provided are wrong.'! !

MAOneToManyComponent subclass: #VOOneToManyComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOOneToManyComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 10/28/2012 07:14'!
buildReport
	^ (TWBSMagritteReport rows: self value description: self reference)
		sortEnabled: self magritteDescription isOrdered not;
		showStriped: true;
		yourself! !

VOOneToManyComponent subclass: #VOOneToManyEditableOnlyComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-View'!

!VOOneToManyEditableOnlyComponent methodsFor: 'private' stamp: 'NicolasVanderAuwera 10/28/2012 07:12'!
buildCommands
	commands := MACommandColumn new setReport: self report.
	self magritteDescription isDefinitive
		ifFalse: [ commands addCommandOn: self selector: #edit: text: 'edit' ].
	self magritteDescription isOrdered
		ifTrue: [ 
			commands
				addCommandOn: self selector: #up: text: 'up';
				addCommandOn: self selector: #down: text: 'down' ].
	^ commands! !

TestCase subclass: #ElectionsTest
	instanceVariableNames: 'election urn agents electionmanager configurationManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Tests'!

!ElectionsTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 09:28'!
basePort
	^ 1000! !

!ElectionsTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/10/2012 10:19'!
choices
	^ #('Nicolas' 'Thomas' 'Jerome' 'Amlie' 'Jean' 'Christine')! !

!ElectionsTest methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 09:28'!
createKOutOfNElection
	"K out of N Election "

	election := MPtKOutOfNElection new
		numberOfChoices: self choices size;
		name: self name;
		protocol: VOProtocol new;
		maxNumberOfAllowedChoices: self maxNumberOfAllowedChoices;
		yourself.
	urn := VOUrn new.
	1000
		timesRepeat: [ 
			| ballot |
			ballot := (election ballot) new.
			ballot maxNumberOfAllowedChoices timesRepeat: [ ballot give: 1 additionalPointsTo: ballot availableSlots atRandom ].
			urn addBallot: ballot ]! !

!ElectionsTest methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 09:28'!
createMPtKOutOfNElection
	"Distribute M points on K out of N Election "

	election := MPtKOutOfNElection new
		numberOfChoices: self choices size;
		name: self name;
		protocol: VOProtocol new;
		maxNumberOfAllowedChoices: self maxNumberOfAllowedChoices;
		pointsToDistribute: self pointsToDistribute;
		yourself.
	urn := VOUrn new.
	1000
		timesRepeat: [ 
			| ballot points |
			ballot := (election ballot) new.
			ballot maxNumberOfAllowedVotes
				timesRepeat: [ 
					[ ballot isRemainingPointsToDistribute ]
						whileFalse: [ 
							points := (1 to: ballot remainingPoints) atRandom.
							ballot give: points additionalPointsTo: ballot availableSlots atRandom ] ].
			urn addBallot: ballot ]! !

!ElectionsTest methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2012 09:28'!
createSimpleElection
	"Simple Election "

	election := Election new
		numberOfChoices: self choices size;
		name: self name;
		protocol: VOProtocol new;
		yourself.
	self choices do: [ :choice | election addChoice: choice ].
	urn := VOUrn new.
	1000
		timesRepeat: [ 
			| ballot |
			ballot := (election ballot) new.
			ballot give: 1 additionalPointsTo: (1 to: self choices size) atRandom.
			urn addBallot: ballot ]! !

!ElectionsTest methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/10/2012 10:30'!
maxNumberOfAllowedChoices
	^ 2! !

!ElectionsTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 09:33'!
numberOfCandidates
	^ 5! !

!ElectionsTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 09:31'!
numberOfVoters
	^ 1000! !

!ElectionsTest methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/10/2012 10:31'!
pointsToDistribute
	^ 5! !

!ElectionsTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 7/23/2012 07:41'!
setUpAgents
	agents := Dictionary new.
	(VOCertifiedAgent selectSubclasses: [ :subclass | subclass name ~= #VOManager ])
		keysAndValuesDo: [ :index :agent | agents at: agent key put: (agent new port: self basePort + index) ].
	agents do: [ :agent | agent start ].
	electionmanager := agents at: VOElectionManager key.
	configurationManager := electionmanager manager.
	configurationManager configurations do: [ :config | config port: (agents at: config key) port ]! !

!ElectionsTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/9/2012 09:40'!
tearDown
	agents do: [ :agent | agent stop ]! !

TestCase subclass: #ExtendedEuclidAlgorithmTest
	instanceVariableNames: 'eeu1 eeu2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Tests'!

!ExtendedEuclidAlgorithmTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 3/10/2012 13:32'!
setUp
	"Test based on the example presented in the Handbook of Applied Cryptography"

	eeu1 := ExtendedEuclidAlgorithm with: 4864 with: 3458.
	eeu2 := ExtendedEuclidAlgorithm with: 4 with: 77! !

!ExtendedEuclidAlgorithmTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/10/2012 13:38'!
testEgcd
	| result result2 |
	result := eeu1 egcd.
	self assert: result first = 38.
	self assert: result second = 32.
	self assert: result third = -45.
	result2 := eeu2 egcd.
	self assert: result2 first = 1.
	self assert: result2 second = -19.
	self assert: result2 third = 1! !

!ExtendedEuclidAlgorithmTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/10/2012 13:30'!
testInverseModulo
	self assert: eeu2 inverseModulo = 58! !

TestCase subclass: #LagrangeCoefficientTest
	instanceVariableNames: 'lg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Tests'!

!LagrangeCoefficientTest methodsFor: 'numeric' stamp: 'NicolasVanderAuwera 3/11/2012 13:32'!
a
	^ 6! !

!LagrangeCoefficientTest methodsFor: 'numeric' stamp: 'NicolasVanderAuwera 3/11/2012 13:14'!
b
	^ 3! !

!LagrangeCoefficientTest methodsFor: 'configuration' stamp: 'NicolasVanderAuwera 3/11/2012 13:15'!
interval
	^ 1 to: 5! !

!LagrangeCoefficientTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/11/2012 13:15'!
modulo
	^ 4! !

!LagrangeCoefficientTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 3/11/2012 13:14'!
setUp
	lg := LagrangeCoefficient a: self a b: self b  interval: self interval  modulo: self modulo ! !

!LagrangeCoefficientTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/29/2012 08:59'!
testRun
	self assert: lg lc = 10! !

TestCase subclass: #VOKeyGenerationServerTest
	instanceVariableNames: 'kgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Tests'!

!VOKeyGenerationServerTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/5/2012 14:14'!
kgsPort
	^ 9090! !

!VOKeyGenerationServerTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/6/2012 12:59'!
setUp
	kgs := VOKeyGenerationServer new port: self kgsPort! !

!VOKeyGenerationServerTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/5/2012 14:19'!
testBlindSignature
	| pair1 pair2 m signature blindedm |
	m := 13245.
	pair1 := kgs firstKeyPair.
	pair2 := kgs firstKeyPair.
	blindedm := pair1 first crypt: m.
	signature := pair2 second crypt: blindedm.
	self assert: (pair1 second crypt: signature) greaseString = (pair2 second crypt: m) greaseString! !

!VOKeyGenerationServerTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/5/2012 14:16'!
testKeys
	| m |
	m := 12345.
	kgs keyPairs
		do: [ :pair | 
			| pk sk |
			pk := pair first.
			sk := pair second.
			self assert: (sk crypt: (pk crypt: m)) = m ]! !

!Dictionary methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 5/9/2012 08:09'!
asPairs
	| result |
	result := OrderedCollection new.
	self keysAndValuesDo: [ :key :value | result add: (Array with: key with: value) ].
	^ result! !

Object subclass: #ExtendedEuclidAlgorithm
	instanceVariableNames: 'a b egcd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!ExtendedEuclidAlgorithm commentStamp: 'NicolasVanderAuwera 3/10/2012 15:50' prior: 0!
Implementation of the extended Euclide algorithm.!

!ExtendedEuclidAlgorithm class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/27/2012 10:00'!
with: anInteger with: anotherInteger
	^ self new
		a: anInteger;
		b: anotherInteger;
		yourself! !

!ExtendedEuclidAlgorithm methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/27/2012 10:00'!
a
	^ a! !

!ExtendedEuclidAlgorithm methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/27/2012 10:00'!
a: anObject
	a := anObject! !

!ExtendedEuclidAlgorithm methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/27/2012 10:00'!
b
	^ b! !

!ExtendedEuclidAlgorithm methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/27/2012 10:00'!
b: anObject
	b := anObject! !

!ExtendedEuclidAlgorithm methodsFor: 'mathematical functions' stamp: 'NicolasVanderAuwera 3/10/2012 13:40'!
egcd
	egcd ifNil: [ egcd := self run ].
	^ egcd! !

!ExtendedEuclidAlgorithm methodsFor: 'mathematical functions' stamp: 'NicolasVanderAuwera 3/10/2012 13:32'!
inverseModulo
	"a^(-1) mod b"

	^ self egcd second \\ b! !

!ExtendedEuclidAlgorithm methodsFor: 'private' stamp: 'NicolasVanderAuwera 3/10/2012 13:42'!
run
	"Iterative algorithm presented in Handbook of Applied Cryptography (p. 67) "

	| abis bbis |
	abis := a.
	bbis := b.
	abis isZero
		ifTrue: [ ^ Array with: abis with: 1 with: 0 ]
		ifFalse: [ 
			| x2 x1 y2 y1 q r x y |
			x2 := y1 := 1.
			x1 := y2 := 0.
			[ bbis > 0 ]
				whileTrue: [ 
					q := (abis / bbis) floor.
					r := abis - (q * bbis).
					x := x2 - (q * x1).
					y := y2 - (q * y1).
					abis := bbis.
					bbis := r.
					x2 := x1.
					x1 := x.
					y2 := y1.
					y1 := y ].
			^ Array with: abis with: x2 with: y2 ]! !

Object subclass: #LagrangeCoefficient
	instanceVariableNames: 'a b modulo interval lc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!LagrangeCoefficient class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 3/28/2012 15:11'!
a: a b: b interval: interval modulo: modulo
	^ self new
		a: a
		b: b
		interval: interval
		modulo: modulo! !

!LagrangeCoefficient methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/28/2012 15:05'!
a: int1 b: int2 interval: anInterval modulo: int3
	a := int1.
	b := int2.
	interval := anInterval.
	modulo := int3! !

!LagrangeCoefficient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/28/2012 15:07'!
lc
	lc ifNil: [ self run ].
	^ lc! !

!LagrangeCoefficient methodsFor: 'process' stamp: 'NicolasVanderAuwera 3/28/2012 15:07'!
run
	lc := 1.
	interval
		do: [ :j | 
			b = j
				ifFalse: [ lc := lc * ((j - a) / (j - b)) ] ]! !

!Object class methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 11/1/2012 10:02'!
from: anObject
	^ ReferenceStream unStream: anObject! !

!Object methodsFor: '*volunti-common' stamp: 'NicolasVanderAuwera 12/20/2011 08:43'!
asStreamedObject
	^ ReferenceStream streamedRepresentationOf: self! !

Object subclass: #VOConnection
	instanceVariableNames: 'stream configuration errorMsg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOConnection class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 11/1/2012 09:08'!
configuration: aConfiguration
	^ self new configuration: aConfiguration! !

!VOConnection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:07'!
configuration: aConfiguration
	configuration := aConfiguration! !

!VOConnection methodsFor: 'actions' stamp: 'NicolasVanderAuwera 11/1/2012 09:07'!
connect
	stream := SocketStream openConnectionToHostNamed: configuration host port: configuration port! !

!VOConnection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:07'!
errorMsg
	^ errorMsg! !

!VOConnection methodsFor: 'protocol' stamp: 'NicolasVanderAuwera 11/1/2012 09:16'!
send: aMessage
	| receipt |
	[ 
	(stream isNil or: [ stream isConnected not ])
		ifTrue: [ self connect ].
	stream sendObject: aMessage.
	receipt := stream receiveObject.
	stream close ]
		on: Error
		do: [ :err | 
			stream ifNotNil: [ :arg | stream close ].
			errorMsg := err messageText ].
	^ receipt! !

Object subclass: #VOMessage
	instanceVariableNames: 'command content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

VOMessage subclass: #VOCertificateRequestMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOCertificateRequestMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 14:00'!
command
	^ #registration! !

VOMessage subclass: #VOCreateElectionMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOCreateElectionMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/4/2012 07:42'!
command
	^ #initialization! !

VOMessage subclass: #VOCryptographicParametersMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOCryptographicParametersMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/3/2012 07:30'!
command
	^ #parameters! !

VOMessage subclass: #VOErrorMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOErrorMessage methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/1/2012 09:11'!
isError
	^ true! !

VOMessage subclass: #VOGetElectionsMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOGetElectionsMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:11'!
command
	^ #elections! !

VOMessage subclass: #VOKeyRequestMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOKeyRequestMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2012 13:24'!
command
	^ #keys! !

!VOMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:09'!
command
	^ command! !

!VOMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:09'!
command: anObject
	command := anObject! !

!VOMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:10'!
content
	^ content! !

!VOMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:10'!
content: anObject
	content := anObject! !

!VOMessage methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/1/2012 09:10'!
isError
	^ false! !

!VOMessage methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/1/2012 09:10'!
isSuccess
	^ false! !

VOMessage subclass: #VOSuccessMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOSuccessMessage methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/1/2012 09:12'!
isSuccess
	^ true! !

VOMessage subclass: #VOTestConnectionMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Network'!

!VOTestConnectionMessage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/1/2012 09:12'!
command
	^ #test! !

Object subclass: #VOProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

VOProperty subclass: #VOAnonymityProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!VOAnonymityProperty methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:15'!
name
	^ 'Anonymity'! !

VOProperty subclass: #VOFairnessProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!VOFairnessProperty methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:15'!
name
	^ 'Fairness'! !

VOProperty subclass: #VOPrivacyProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!VOPrivacyProperty methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:15'!
name
	^ 'Privacy'! !

!VOProperty methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:15'!
name
	^ self subclassResponsibility! !

VOProperty subclass: #VOReceiptFreenessProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!VOReceiptFreenessProperty methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:16'!
name
	^ 'Receipt-Freeness'! !

VOProperty subclass: #VOVerifiabilityProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Election'!

!VOVerifiabilityProperty methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/5/2012 17:16'!
name
	^ 'Verifiability'! !

Object subclass: #VOSecret
	instanceVariableNames: 'id array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!VOSecret class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/20/2012 07:23'!
id: anInteger array: anArray
	^ self new
		id: anInteger;
		array: anArray;
		yourself! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/20/2012 07:22'!
array
	^ array! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/20/2012 07:22'!
array: anObject
	array := anObject! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 13:52'!
arrayAsInteger
	^ (array collect: [ :secret | secret asByteArray greaseInteger ]) asOrderedCollection! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 13:52'!
arrayAsIntegerWithout: aSecret
	^ self arrayAsInteger remove: aSecret asByteArray greaseInteger; yourself! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 13:52'!
arrayWithout: aSecret
	^ array select: [ :secret | secret asByteArray greaseInteger ~= aSecret ]! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/23/2012 07:01'!
atRandom
	^ array atRandom! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/20/2012 07:22'!
id
	^ id! !

!VOSecret methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/20/2012 07:22'!
id: anObject
	id := anObject! !

Object subclass: #VOToken
	instanceVariableNames: 'id secret mpdvsShare'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

VOToken subclass: #VOAlternativeToken
	instanceVariableNames: 'secretAsString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-Common-Model-Cryptography'!

!VOAlternativeToken class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/8/2012 10:05'!
id: anInteger possibleSecrets: aCollection
	| token |
	token := self id: anInteger.
	token secretAsString: aCollection atRandom.
	^ token! !

!VOAlternativeToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/29/2012 13:52'!
secret
	^ secret ifNil: [ secret := secretAsString asByteArray greaseInteger ]! !

!VOAlternativeToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 10:06'!
secretAsString
	^ secretAsString! !

!VOAlternativeToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 10:06'!
secretAsString: aString
	secretAsString := aString! !

!VOToken class methodsFor: 'generator' stamp: 'NicolasVanderAuwera 5/6/2012 09:46'!
generateSecret
	^ SecureRandom new nextFrom: 10000 to: 100000! !

!VOToken class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/6/2012 09:45'!
id: anInteger
	^ self new
		id: anInteger;
		yourself! !

!VOToken methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 12/15/2011 07:11'!
<= aToken
	^ self id <= aToken id! !

!VOToken methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 12/27/2011 14:26'!
= aToken
	^ self id = aToken id! !

!VOToken methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 1/8/2012 08:35'!
hash
	^ self id hash! !

!VOToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/14/2011 07:16'!
id
	^ id! !

!VOToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 11:37'!
id: anObject
	id := anObject! !

!VOToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 09:28'!
mpdvsShare
	^ mpdvsShare! !

!VOToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 09:28'!
mpdvsShare: aShare
	mpdvsShare := aShare! !

!VOToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/6/2012 09:45'!
secret
	^ secret ifNil: [ secret := self class generateSecret ]! !

!VOToken methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 07:55'!
secret: aSecret
	secret := aSecret! !
VOAgentComponent initialize!
